require({cache:{
'url:dojoe/gauge/analoggauge/templates/AnalogGauge.html':"<div id=\"${id}_analogGauge\">\r\n\t<table role=\"presentation\" align=\"center\" style='table-layout:fixed' data-dojo-attach-point=\"table\" cellpadding=\"0px\" cellspacing=\"0px\">\r\n\t\t<tr>\r\n\t\t\t<td colspan=\"2\" data-dojo-attach-point=\"topLabelTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div tabindex=\"0\" id=\"${id}_topLabel\" class=\"dojoxEllipsis\" data-dojo-attach-point=\"topLabelDiv\" align=\"center\" style=\"text-overflow: ellipsis\">\r\n\t\t\t\t</div>\r\n\t\t\t</td>\t\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td data-dojo-attach-point=\"leftLabelTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div tabindex=\"0\" class=\"dojoxEllipsis\" id=\"${id}_leftLabel\" data-dojo-attach-point=\"leftLabelDiv\" style=\"text-overflow: ellipsis;text-align:right\">\t\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t\t<td data-dojo-attach-point=\"analogGaugeTD\" style=\"padding: 0px\">\r\n\t\t\t\t<div id=\"${id}_analogGaugeDiv\" data-dojo-attach-point=\"analogGaugeDiv\" style=\"align:left\" >\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t</table>\r\n</div>"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/gauge/analoggauge/AnalogGauge", [
	"dojo/_base/declare",
	"dojo/_base/connect",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dojo/text!./templates/AnalogGauge.html",
	"dojoe/gauge/analoggauge/AnalogStyle",
	"dojoe/gauge/common/AbstractGauge",
	"dijit/Tooltip",
	"dojoe/BidiUtil"
], function(declare, connect, _WidgetBase, _TemplatedMixin, template, AnalogStyle, AbstractGauge, Tooltip, bidiUtil) {
	return declare("dojoe.gauge.analoggauge.AnalogGauge", [_WidgetBase, _TemplatedMixin], {
		templateString: template,
		analogGauge:null,
		
		// width: number  
		//		Holds the width of the Analog Gauge. 
		width:120,
		
		// height: number  
		//		Holds the height of the Analog Gauge. 
		height:110,
		
		// topLabel: String  
		//		Holds the String/label to be displayed on top of the Analog Gauge
		topLabel:"",
		
		// leftLabel: String  
		//		Holds the String/label to be displayed on the leading edge the Analog Gauge
		leftLabel:"",
		
		// value: Numeric  
		//		Holds the numeric value which the Analog Gauge should represent.
		value:0,
		
		// value: Boolean  
		//		Holds a boolean value to indicate if the gauge is supposed to have a top label at any point
		topLabelPresent: false,
		
		// value: Boolean  
		//		Holds a boolean value to indicate if the gauge is supposed to have a leading edge label at any point
		leftLabelPresent: false,
		
		_labelRatio:0.25,
		_size:0,
		_labelset:false,
		_textHeight : 15,
		
		constructor: function() {
			dojo.mixin(this, arguments);
		},
		
		postCreate: function() {

			if(this.topLabelPresent) {
				this.topLabelDiv.innerHTML = ".";
			}
				
			if(this.leftLabelPresent) {
				this._labelRatio = 0.25;
				this.leftLabelTD.style.width = (this.domNode.offsetWidth * 0.25) + "px";
				this.leftLabelDiv.style.width= (this.domNode.offsetWidth * 0.25) + "px";
				this.leftLabelDiv.style.marginRight = "0px";
				if(this.leftLabel)
					this.leftLabelDiv.innerHTML = this.leftLabel;
				if(this.dir == "rtl")
					this.leftLabelDiv.style.marginLeft="8px";
				else
					this.leftLabelDiv.style.marginRight="8px";
			} else
				this._labelRatio = 0;
						
			this.analogGauge = new dojoe.gauge.common.AbstractGauge({minValue:this.minValue, maxValue:this.maxValue, thresholds:this.thresholds, majorTickSeparation:this.majorTickSeparation, minorTickSeparation:this.minorTickSeparation, units:this.units, _currentValue:this._currentValue, dir:this.dir, textDir:this.textDir}, this.analogGaugeDiv);
			this.analogGauge.styler = new AnalogStyle();
			this.analogGauge.styler.showThresholdStrip = this.showThresholdStrip;
			this.analogGauge.styler.orient = this.dir;
			this.analogGauge.styler.textDir = this.textDir;
			this.analogGauge.startup();
			this._textHeight = this.topLabelTD.clientHeight;
			this.topLabelDiv.innerHTML = "";
			if(this.topLabel)
				this.topLabelDiv.innerHTML = this.topLabel;
			if(!this.leftLabelPresent) {
				this.analogGauge.domNode.style.margin = "auto";
			}
			
			var leftLabelTooltip = dojo.hitch( this, this._showTooltip, "left" ); 			
			var topLabelTooltip = dojo.hitch( this, this._showTooltip, "top" ); 			
			this.connect(this.leftLabelDiv, "onclick", this, leftLabelTooltip);
			this.connect(this.topLabelDiv, "onclick", this, topLabelTooltip);
			this.analogGauge.domNode.tabIndex = "0";
			this.leftLabelDiv.style.textOverflow="ellipsis";
			this.topLabelDiv.style.textOverflow="ellipsis";
			this.inherited(arguments);
		},
		

		startup: function() {
			try{
				this.inherited(arguments);	
			}catch(err){
				console.debug(err);
			}
		},
		
		_showTooltip : function(arg) {
			var node;
			if(arg == "left"){
				node = this.leftLabelDiv;
				Tooltip.show(this.leftLabel, node, ['above-centered','below-centered','after']);
			} else {
				node = this.topLabelDiv;
				Tooltip.show(this.topLabel, node, ['above-centered','below-centered','after']);
			}			
			setTimeout(function(){
				Tooltip.hide(node);
			}, 2000);
		},
		
		draw: function(surface){
			this.analogGauge.adjust(surface);
		},
		
		resizeByScale: function(sx, sy, px, py){
			// summary:  
			//		Resizes the Analog Gauge
			// sx: number
			//		 Ratio of original width and new width available
			// sy: number 
			//		Ratio of original Height and new height available
			// px: number 
			//		New width available
			// py: number 
			//		New height available
			// Do not add metric while specifying the numbers above
			// tags: public
			
			if(this.width == px && this.height == py) // same dimensions, no need to resize again.
				return;
						
			this.leftLabelTD.style.width = (px * this._labelRatio) + "px";
			this.leftLabelDiv.style.width=(px * this._labelRatio) + "px";
		
			this.width = px;
			this.height = py;
			var gfxWidth = px - this.leftLabelTD.offsetWidth - 4;
			if(this.leftLabelPresent)
				gfxWidth = gfxWidth - 10;
			var gfxHeight = py - this._textHeight - 4;
			var min = gfxWidth < gfxHeight?gfxWidth:gfxHeight;
			this.analogGaugeDiv.style.position = "relative";
			this.analogGauge._adjust({
				width:min, 
				height:min
			});
			this.topLabelTD.style.width=min + "px"; 			
			this.topLabelDiv.style.width=min + "px"; 
			this.topLabelDiv.style.whiteSpace="nowrap";
			if (this.dir == "rtl"){                                                                 //def58992
					this.topLabelDiv.style.marginRight = this.leftLabelDiv.clientWidth + "px";      //def58992
					this.topLabelDiv.style.textAlign = "right";                                     //def58992
					this.topLabelDiv.style.marginLeft = "0px";
			} else {                                                                                //def58992
				this.topLabelDiv.style.marginLeft = this.leftLabelDiv.clientWidth + "px";
			} 
			//this.table.style.marginTop = (py- this.table.offsetHeight)/2 + "px";
		},
		
		setLabelAndValue: function(topLabel, leftLabel, value) {
			// summary:  
			//		Sets labels and value for the Analog Gauge
			// topLabel: String
			//		 Label which appears at the TOP of the gauge
			// leftLabel: String 
			//		Label which appears on theleading edge of the gauge
			// value: Numeric 
			//		Numeric Value to be displayed on the gauge
			// tags: public
			
			/*LS - avoid calling data apis in widget on object references
	    	 * 58511: TBSM 36702: Perf: Memory Leak in TWL status gauge*/
			/*if(topLabel && typeof(topLabel.getValueType) != "undefined" && topLabel.getValueType() == "status") {
				this.topLabel = topLabel.getValue().getValue();
			} else if(topLabel && typeof(topLabel.getValue) != "undefined") {
				this.topLabel = topLabel.getValue();
			} else
				this.topLabel = topLabel;
				
			if(leftLabel && typeof(leftLabel.getValueType) != "undefined" && leftLabel.getValueType()=="status")
				this.leftLabel = leftLabel.getValue().getValue();
			else if(leftLabel && typeof(leftLabel.getValue) != "undefined") {
				this.leftLabel = leftLabel.getValue();
			}else
				this.leftLabel = leftLabel;*/
				
			if(topLabel != "undefined" && topLabel != null) {
				this.topLabelDiv.innerHTML = topLabel;
				this.topLabelDiv.title = topLabel;
				this.topLabel = topLabel;
			}
	    	if(leftLabel != "undefined" && leftLabel != null)  {
				if (this.dir != this.textDir)                                                                              //54380
					this.leftLabelDiv.innerHTML = dojoe.BidiUtil.getFormattedText(leftLabel, this.textDir, this.dir); //54380
				else                                                                                                       //54380
					this.leftLabelDiv.innerHTML = leftLabel;
				
				this.leftLabelDiv.title = leftLabel;
				this.leftLabel = leftLabel;
				if (this.dir == "rtl")                                   //def58992
					this.leftLabelDiv.style.textAlign = "left";          //def58992
			}
	    	
	    	if(value && typeof value.getValue == 'function')
				value = value.getValue();
	    	if(value != "undefined" && value != null) this.value = value;
			
			if (this.dir == "rtl"){    
				this.leftLabelDiv.style.textAlign = "left";
				this.topLabelDiv.style.marginRight = this.leftLabelDiv.clientWidth + "px";        //58992
				this.topLabelDiv.style.marginLeft = "0px";                                        //58992
			} else {                                                                              //58992
				this.topLabelDiv.style.marginLeft = this.leftLabelDiv.clientWidth + "px";
			}
			this.setValue(this.value);
		},
		
		setValue: function(/*number*/ value){
			if(value && typeof value.getValue == 'function')
				value = value.getValue();
			this.analogGauge.setValue(value);
			this.analogGauge.domNode.title = value + " " + this.analogGauge.styler.getStatus();
		},
	
		clearLabels: function() {
			this.leftLabelDiv.innerHTML = "";
			this.topLabelDiv.innerHTML = "";
		},
	
		destroy: function(){
			// summary:
			//          Called when the widget is destroyed by dojo, used to clean 
			//          up memory before disassociating the widget from the dom.
			/*this.destroyWidgets();
			if(dojo.byId(this.id+"analogGaugeDiv")) dojo.forEach(dijit.findWidgets(dojo.byId(this.id+"analogGaugeDiv")), function(widget){
				// Avoid double destroy of widgets like Menu that are attached to body
				// even though they are logically children of other widgets.
				if(widget && !widget._destroyed){
					if(widget.destroyRecursive){
						widget.destroyRecursive();
					}else if(widget.destroy){
						widget.destroy();
					}
				}
			});	*/
			this.inherited(arguments);
		}	
		
});
});
