/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/list/_MultiSelectTabBarButton", [
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/dom-class",
	"dijit/registry",	// registry.byNode
	"dojox/mobile/TabBarButton"
], function(declare, lang, domClass, registry, TabBarButton){



/*=====

	var ItemBase = dojox.mobile._ItemBase;

=====*/



	// module:

	//		dojoe/list/MultiSelectTabBarButton

	// summary:

	//		A button widget that is placed in the TabBar widget.



	return declare("dojoe.list._MultiSelectTabBarButton", TabBarButton,{
		toggle: true, // acts like a toggle button
		select: function() {
			// summary:

			//		Makes this widget in the selected state.

			//		OVERRIDE to do multi select
			//		When it's selected and it was clicked, it will
			//		deselect
			console.info("Is Button selected:"+this.selected);
			if(arguments[0]||this.selected===true){ // deselect

				this.selected = false;

				domClass.remove(this.domNode, "mblTabButtonSelected");

			}else{ // select

				this.selected = true;

				domClass.add(this.domNode, "mblTabButtonSelected");

			}

			if(this.iconNode1){

				this.iconNode1.style.visibility = this.selected ? "hidden" : "";

			}

			if(this.iconNode2){

				this.iconNode2.style.visibility = this.selected ? "" : "hidden";

			}

	    },
		selectAll: function() {
			this.select();
			for(var i = 0, c = this.domNode.parentNode.childNodes; i < c.length; i++){
				if(c[i].nodeType != 1){ continue; }
				var w = registry.byNode(c[i]); // sibling widget
				if(w && w != this){
					w.select();
				}
			}
		},
		deselectAll: function() {
			this.deselect();
			for(var i = 0, c = this.domNode.parentNode.childNodes; i < c.length; i++){
				if(c[i].nodeType != 1){ continue; }
				var w = registry.byNode(c[i]); // sibling widget
				if(w && w != this){
					w.deselect();
				}
			}
		}
	});
});
