// wrapped by build app
define("dojoe/progressbar/EnhancedProgressBar", ["dijit","dojo","dojox","dojo/i18n!dojoe/progressbar/nls/EnhancedProgressBar","dojo/require!dijit/_Widget,dijit/_Templated,dijit/ProgressBar,dijit/form/Button,dijit/Dialog,dojo/parser,dojoe/messagedialog/MessageDialog,dojo/i18n"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("dojoe.progressbar.EnhancedProgressBar" );

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.ProgressBar"); 
dojo.require("dijit.form.Button");
dojo.require("dijit.Dialog");
dojo.require("dojo.parser");
dojo.require("dojoe.messagedialog.MessageDialog");
dojo.require("dojo.i18n");

/******************************************************************************
 * Busy Pane that blocks all user input and shows progress message.
 ******************************************************************************/
//Localization of resource bundles
dojo.requireLocalization("dojoe.progressbar", "EnhancedProgressBar");

dojo.declare("dojoe.progressbar.EnhancedProgressBar", [dijit._Widget, dijit._Templated],
		{
	// summary:  EnhancedProgressBar is a widget to show progress in determinate(indicates progress) or indeterminate way .
	// It can also be used as a standby or busy pane
	// description: EnhancedProgressBar widget uses the dijit.ProgressBar for its implementation.
	//		  EnhancedProgressBar has also been customized with multiple default actions .

	//	processingImageSrc:String
	//  Path to the processing image
	processingImageSrc: dojo.moduleUrl("dojoe.common","themes/images/progress32.gif"), 

	// _resources:  Object
	//	Reference to the resources
	resources_:null,
	//  progressBar:Object
	//  refrence to the progressbar  
	progressBar: null,

	// cancellable: Boolean
	//Set this to true if cancel button is needed in progressbar	
	cancellable:false,	

	//pauseable: Boolean
	//Set this to true if pause/resume toggle button is needed in progressbar	
	pauseable:false,

	//closeable: Boolean
	//Set this to true if close button is needed in progressbar	
	closeable:false,  

	//  progressIndicatorType:number
	//  indicates the type of progressbar.It can be set to  0:indeterminate or 1:determinant  
	progressIndicatorType : 0,

	//showmessagetext:Boolean
	//Set this to true to enable message from the user	
	showmessagetext:true,

	//processingLabel:String
	//Label to be shown when progress starts
	processingLabel:'Processing',

	//hidden:boolean
	//Set to true if the progressbar needs to be hidden once progress completes
	hidden:false,

	//maximumValue:number
	// maximum progress value
	maximumValue : 100,

	//progress:number
	//Holds the progress set by the user operation
	progress  : 0,

	//width: number
	//Holds the width of the progressbar set by user. It can be set in px,percentage or em like '150px','150%' or '150em'.
	width : "150px",

	//height: number
	//Holds the height of the progressbar set by user. It can be set in px,percentage or em like '150px','150%' or '150em'.
	height : "50px",

	//size:String
	//Holds the size of the processing image,it can be set to small,medium,large,huge
	size:"large",

	/*#36265 TED: EnhancedProgressBar: unable to create instance via declarative declaration */
	//Commenting this as id attribute comes with dijit progressbar by default and giving problem while parsing the declarative markup. 
	//id:  String
	// id of the widget
	//id:null, 

	//contentIsolation:  Boolean
	// Flag to indicate if sample is isolated
	contentIsolation:false,


	//namespace:  String
	// namespace for messageDialog in case of content isolation
	namespace:null,

	// target: DOMNode||DOMID(String)||WidgetID(String)
	//		The target to overlay when active.  Can be a widget id, a
	//		dom id, or a direct node reference.
	target: "",

	// _resizeCheck: [private] Object
	//		Handle to interval function that checks the target for changes.
	_resizeCheck: null,

	// zIndex: String
	//		Control that lets you specify if the zIndex for the overlay
	//		should be auto-computed based off parent zIndex, or should be set
	//		to a particular value.  This is useful when you want to overlay
	//		things in digit.Dialogs, you can specify a base zIndex to append from.
	zIndex: "auto",
	
	// _underlayNode: [private] DOMNode
	//		The node that is the translucent underlay for the
	//		image that blocks access to the target.
	_underlayNode: null,

	// color:	String
	//		The color to set the overlay.  Should be in #XXXXXX form.
	//		Default color for the translucent overlay is light gray.
	color: "#C0C0C0",
	
	// duration: integer
	//		Integer defining how long the show and hide effects should take.
	duration: 500,
	
	// _displayed: [private] Boolean
	//		Indicates whether EPB is displayed or not
	_displayed : false,

	// _imageSize: String
	//		Indicates the sixe of the progress image to be used
	_imageSize : "medium",
	
	//templateString:  String
	// Path to the template
	templateString:dojo.cache("dojoe.progressbar", "templates/EnhancedProgressBar.html", "\r\n<div class=\"enhanced t\" >\r\n<div style=\"display: none; opacity: 0; z-index: 9999; position: absolute;\" dojoAttachPoint=\"_underlayNode\"></div>\r\n<div class='EnhancedProgressBarProcessing' dojoAttachPoint='rootDiv' style=\"overflow:auto;;position:absolute;display:none;\" >\r\n\t\r\n\t<table  dojoAttachPoint='progressBarTable' cellspacing='0' cellpadding='0' style=\"overflow:auto;\" role=\"region\" aria-label=\"progressBarTable\">\r\n\t         \r\n\t\t\t\t  <tr  style=\"overflow:auto;\" >\r\n\t\t\t\t    \r\n\t\t\t\t\t   <td class='process-anim'  width='10%'> \r\n\t\t\t\t\t   <!-- 23Aug12 : Updated to read the image from css -->\r\n\t\t\t\t<!--\t   <img src='${processingImageSrc}'role=\"img\" alt='${processingLabel}' title='${processingLabel}'/>  -->\r\n\t\t\t\t\t\t\t<div dojoAttachPoint=\"progressImage\" alt='${processingLabel}' title='${processingLabel}' ></td>\r\n\t\t\t\t\t   <td> \r\n\t\t\t\t\t      \r\n\t\t\t\t\t\t\t <table width=\"100%\" role=\"presentation\">\r\n\t\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t\t<td width=\"40%\" class='process-message' dojoAttachPoint='messageArea'>\r\n\t\t\t\t\t\t\t\t       <div dojoAttachPoint='msgareaDiv' role=\"log\" aria-label=\"message area\">${processingLabel}</div>\r\n\t\t\t\t\t\t\t\t    </td> \r\n\t\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t\t<td >\r\n\t\t\t\t\t\t\t    \t<div dojoAttachPoint='progressBarNode' ></div>\r\n\t\t\t\t\t\t\t\t\t</td> \r\n\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t\t<tr dojoAttachPoint='buttonsNode' style=\"display:none;\"> \r\n\t\t\t\t\t\t\t\t\t<td width=\"100%\" > \r\n\t\t\t\t\t\t\t\t\t<table role=\"presentation\">\r\n\t\t\t\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t\t\t\t<td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t<div dojoAttachPoint='progressBarPause' style=\"overflow:auto;\" role=\"button\" aria-label=\"progressBarPause\"> </div>\r\n\t\t\t\t\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t\t\t\t\t\t<td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t<div dojoAttachPoint='progressBarCancel' style=\"overflow:auto;\" role=\"button\" aria-label=\"progressBarCancel\"> </div>\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t\t\t\t\t\t<td> \r\n\t\t\t\t\t\t\t\t\t\t\t<div dojoAttachPoint='progressBarClose' style=\"overflow:auto;\" role=\"button\" aria-label=\"progressBarClose\"> </div>\r\n\t\t\t\t\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t\t\t</table>\r\n\t\t\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t\t\t</tr>\t \r\n\t\t\t\t\t\t\t </table>\r\n\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t</td> \r\n\t\t\t\t\t\t\r\n\t\t\t\t\t</tr>\r\n\t\t\t  \r\n\t\t</table>\r\n\t\t\r\n\t\t\r\n\t</div>\r\n</div>"),

	preamble: function(){  //Called before Constructor
		//23Aug12:Richa ,Commented to move the images out of js file
		//Only 2 image sizes will be supported, medium and large.
	/*	if(arguments[0].size=="small")
			this.processingImageSrc=dojo.moduleUrl("dojoe.common","themes/images/progress_22_DARK.gif");
		else if(arguments[0].size=="medium")
			this.processingImageSrc= dojo.moduleUrl("dojoe.common","themes/images/progress_22_DARK.gif");
		else if(arguments[0].size=="large")
			this.processingImageSrc= dojo.moduleUrl("dojoe.common","themes/images/progress_32_DARK.gif");
		else if(arguments[0].size=="huge")
			this.processingImageSrc= dojo.moduleUrl("dojoe.common","themes/images/progress_32_DARK.gif");*/
		
		//24Aug12 :Richa Set the image size based on the argument passed
		if(arguments[0].size=="small" || arguments[0].size=="medium"){
			this._imageSize="medium";
			}
		else if(arguments[0].size=="large" ||arguments[0].size=="huge" ){
			this._imageSize="large";
		}
		
		if(arguments[0].cancellable !==null && arguments[0].cancellable== true){
			this.cancelButton=true;	
		}				
		else
			this.cancelButton=false;	
	
		if(arguments[0].closeable !==null && arguments[0].closeable== true)
		{
	
			this.closeButton=true;
		}
		else
			this.closeButton=false;	
	
		if(arguments[0].pauseable !==null && arguments[0].pauseable== true)
		{
	
			this.pauseButton=true;
		}
		else
			this.pauseButton=false;	

	},

	constructor: function () {
		// resources_:  Object
		//Reference to the resources
		this.resources_ = dojo.i18n.getLocalization("dojoe.progressbar", "EnhancedProgressBar",this.lang); 
		//61731: TBSM 37529: dojoe.progressbar.EnhancedProgressBar:  "Processing" string is not NLS enabled
		//Bobby: 31Dec2012, loading processingLabel from nls
		this.processingLabel = this.resources_.PROCESSING;
	},

	postCreate: function()
	{
		// summary:  Creates and initialises the progressbar with actions like close,cancel,pause/resume.
		// tags: public
	
		//24Aug12 -Richa:Set the  class based on the imagesize
		if(this._imageSize=="medium"){
			dojo.addClass( this.progressImage,"medium");
		}else if(this._imageSize=="large"){
			dojo.addClass( this.progressImage,"large");
		}
		
		this.inherited( arguments );
		var size = dijit.getViewport();
		this._allProgressBarButtons = [];
		var height = this.height;
		var sizeType = this.height.substring(this.height.length-1, this.height.length);
		if(sizeType == "%") {
			//convert to px
			var height = size.h * ((parseInt(this.height.slice(0, -1))) / 100);
			height = height + "px";
		}
		if(this.progressIndicatorType==1) {	
	
			this.progressBar = new dijit.ProgressBar({id:this.id+"progressBar",
				width:this.width ,
				height:this.height, 	
				report:function(percent){	
				return '';
			}},this.progressBarNode);
			
			this.progressBar.set('aria-label', 'progressBar');
		}
		
		if(this.cancelButton || this.closeButton || this.pauseButton){
			this.buttonsNode.style.display = "block";
		}
	
		if(this.cancelButton ==true) {	
	
			this.cancelButton = new dijit.form.Button({
				id: this.id+"Cancel",
				showLabel: true,						
				label: this.resources_.CANCEL
			},this.progressBarCancel);
	
			this.cancelButton.onClick = dojo.hitch (this, "_onCancelClick");
			this._allProgressBarButtons.push( this.cancelButton );
	
	
		}
		if(this.closeButton ==true) {	 
			this.closeButton = new dijit.form.Button({
				id: this.id+"Close",
				showLabel: true,						
				label: this.resources_.CLOSE
			},this.progressBarClose);
	
			this.closeButton.onClick = dojo.hitch (this, "_onCloseClick");		
			this._allProgressBarButtons.push( this.closeButton );
		}
		if(this.pauseButton ==true) {
			if(this.progress !== this.maximumValue){
				this.pauseButton=new dijit.form.ToggleButton({
					id: this.id+"Toggle",
					ShowLabel: true,
					checked: false,
					label: this.resources_.PAUSE
				},this.progressBarPause);
				this.pauseButton.onChange = dojo.hitch (this, "_onToggleClick");		
				this._allProgressBarButtons.push( this.pauseButton );
			}
		}
	
		this.calculateMsgWidth();
	
		/*# 40363: Enhanced Progressbar need "modal" option to be compatible with previous LDTW's BusyPane 
		 * set the target to default dom node of this widget
		 * This widget should function just as a progress bar attached to the given node and 
		 * also as a busy pane which centers itself for the target node...*/
		if(this.target == "" || this.target == null){
			this.target = this.rootDiv;
		}else{
		
			dojo.style(this._underlayNode, {
						display: "none",
						backgroundColor: this.color
					});
					
			this.connect(this._underlayNode, "onclick", "_ignore");
		}
		/*#36265 TED: EnhancedProgressBar: unable to create instance via declarative declaration */
		//the line below is causing declarative sample not to work
		
	},
	_ignore: function(e){
		// summary:
		//		Function to ignore events that occur on the overlay.
		// event: Event
		//		The event to halt
		// tags:
		//		private
		if(e){
			dojo.stopEvent(e);
		}
	},
	_fadeIn: function(){
		// summary:
		//		Internal function that does the opacity style fade in animation.
		// tags:
		//		private
		var self = this;
		var underlayNodeAnim = dojo.animateProperty({
			duration: self.duration,
			node: self._underlayNode,
			properties: {opacity: {start: 0, end: 0.75}}
		});
		
		this._anim = underlayNodeAnim;
		this._anim.play();
	},

	_fadeOut: function(){
		// summary:
		//		Internal function that does the opacity style fade out animation.
		// tags:
		//		private
		var self = this;
		var underlayNodeAnim = dojo.animateProperty({
			duration: self.duration,
			node: self._underlayNode,
			properties: {opacity: {start: 0.75, end: 0}},
			onEnd: function(){
				dojo.style(this.node,{"display":"none", "zIndex": "-1000"});
			}
		});
		
		this._anim = underlayNodeAnim;
		this._anim.play();
	},
	_onToggleClick: function(/* Event */e){  
	
		// summary:  indicates pause/resume state of the progressbar and calls appropriate functions.
		//Also published events onPauseClick and onResumeClick.
		// tags: private			
		if(e==true)
		{
			this.pauseButton.set('label', this.resources_.RESUME);	
	
			dojo.publish(this.id +"#onPauseClick", ["Paused"]);
			this.progressPaused=true;
		}
		else
		{
			this.pauseButton.set('label', this.resources_.PAUSE);	
	
			dojo.publish(this.id +"#onResumeClick", ["Resumed"]);
			this.progressPaused=false;
		}
	
	},
	_onCloseClick: function(/* Event */e){  
		// summary:  indicates closed state of the progressbar and publish event onCloseClick.
		// tags: private	
		this.closed=true;
		dojo.publish(this.id +"#onCloseClick", ["Closed"]);
		this.hide();
		setTimeout( dojo.hitch( this, "destroy" ), 500 );	
	},

	calculateMsgWidth :function() {
		// summary:  calculate the width of the message set by the user.
		// tags: public
		var strWidth = this.width.substring(0,this.width.length-2); // get numeric width 
		var totalWidth = parseInt(strWidth);
		var animwidth = .1 * totalWidth;
		var animwidth =animwidth+5;
		var	msgWidthtemp = totalWidth-(animwidth+20);
		this.msgWidth=msgWidthtemp+"px";
	
	},

	doProgress : function(progress,message) {
		//summary: Trigger for start displaying the progress
		//tags :public
		if( this.closed!=true){
			this.show();	
			this.getProgress(progress,message);
		}
	},	

	getProgress :function (progress,message) {
		//summary: Trigger for start displaying the progress.
		//tags :public
		this.progressCallBack(progress,message);
	
	},

	progressCallBack : function  (progress,message){
		//summary: Method which shows progress
		//tags :public
	
		if( progress < this.maximumValue ) {  //  Progress% is less than 100 and progress is not cancelled
			var y = parseInt(progress);
			if (!isNaN(y)) {
				this.progress = y;
				if(this.progressIndicatorType==1 && this.progressCancelled!=true && this.progressPaused!=true ) {			      
					this.progressBar.update({ maximum:this.maximumValue, progress: this.progress });  //Update the progressbar
					if(this.showmessagetext==true)
						this.setMessage(message);
					else
						this.setMessage("");
	
				}else if(this.progressCancelled==true){
	
					this.hide();
					this.cancelButton.disabled=true;
					this.pauseButton.disabled=true;
				}
			}
	
		}
		else if(progress=this.maximumValue) { 
			// Progress Process is completed
			if(	this.progressIndicatorType==1){	 
				this.progressBar.update({ maximum:this.maximumValue, progress: this.progress });		
	
				if(this.showmessagetext==true)
				{
					this.setMessage(message);
				}
				else
				{
					this.setMessage("");
				}}
			var callback = dojo.hitch(this, this.afterCompletion);
	
			setTimeout(callback,1000);
		}
	},

	afterCompletion : function () {
		//summary: Called after the progress completes,hides the progressbar,if hidden enabled,disables the cancel and pause/resume button.
		//tags :public
		
		if(this.closeButton && !(this.closeButton.disabled)){
			// do not hide if close button is enabled...
		}else{
			this.hide();
		}
		
		this.cancelButton.disabled=true;
		this.pauseButton.disabled=true;
	
		//setTimeout( dojo.hitch( this, "destroyRecursive" ), 5000 );
	
	},

	updateProgress : function(progressParam)
	{
		//summary: updates the progress of determinate progressbar
		//tags :public
	
		if(this.progressIndicatorType==1) { //Updates Progress Only If type is Determinate otherwise ignore	
			this.progress=progressParam;		
			this.progressBar.update({ maximum:this.maximumValue, progress: this.progress });
	
		}
	},


	onCancelClick: function(/* Event */e){
		//summary: Cancels the operation once Ok is clicked in the confirmation dialog ,also publishes onCancelClick.
		//tags :public
		if(e==0){
			if(this.cancellable==true ) {	
	
				var callback = dojo.hitch(this, this.afterCompletion);
				if(this.contentIsolation==true){
					this.successfulDialog = new dojoe.messagedialog.MessageDialog(
							{message: this.resources_.SUCCESSFULCANCEL_MESSAGE,
								messageId: "Success",
								type: "Info",	
								namespace	:  this.namespace,
								showCheckbox: false,
								contentIsolation:true});
				}else{
					this.successfulDialog = new dojoe.messagedialog.MessageDialog(
							{message: this.resources_.SUCCESSFULCANCEL_MESSAGE,
								messageId: "Success",
								type: "Info",					 
								showCheckbox: false});
				}
				this.successfulDialog.show();	
	
				dojo.publish(this.id +"#onCancelClick", ["Cancelled"]);
				this.progressCancelled=true;			
				setTimeout(callback,1000);
				setTimeout( dojo.hitch( this, "destroy" ), 500 );	
	
			}   
		}
	},

	_onCancelClick: function(/* Event */e){
		//summary: Pops up the confirmation dialog once cancel button is clicked,also publishes onCancelClick.
		//tags :private 
	
		if(this.contentIsolation==true){
			this.msgDlg = new dojoe.messagedialog.MessageDialog(
					{
						message: this.resources_.CANCEL_MESSAGE,
						messageId: "Confirmation",
						type: "Confirm",
						namespace	:  this.namespace,
						callback:  dojo.hitch(this, this.onCancelClick) ,
						buttons: [this.resources_.CONFIRM_OK, this.resources_.CONFIRM_CANCEL],
						showCheckbox: false,
						contentIsolation:true
					});
	
		}else{
			this.msgDlg = new dojoe.messagedialog.MessageDialog(
					{
						message: this.resources_.CANCEL_MESSAGE,
						messageId: "Confirmation",
						type: "Confirm",			 
						callback:  dojo.hitch(this, this.onCancelClick) ,
						buttons: [this.resources_.CONFIRM_OK, this.resources_.CONFIRM_CANCEL],
						showCheckbox: false
	
					});
	
	
		}
	
		this.msgDlg.show();
	},

	setMessage:function(msg){
		//summary: Sets the message generated by user operation.
		//tags :public
		this.messageArea.innerHTML=msg;
	},
	
	getProgressIndicatorType : function()
	{
		//summary:Retuns the type of progressIndicator 0 if indeterminate 1 if determinant
		//tags:public
		return this.progressIndicatorType;
	},
	/*  setProgressIndicatorType : function(type)
	  {
	    this.progressIndicatorType=type;
	  },*/
	getWidth : function()
	{
		//summary:returns the width of the progressbar.
		//tags:public
		return this.width;
	},
	
	setWidth : function(widthParam)
	{
		//summary:sets the width of the progressbar
		//tags:public
		this.width=widthParam;
		this.stylePage();
	},
	
	getHeight  : function()
	{
		//summary:returns the height of the progressbar
		//tags:public
		return this.height;
	},
	
	setHeight : function(heightParam)
	{
		//summary:sets the height of the progressbar
		//tags:public
		this.height=heightParam;
		this.stylePage();
	},
	
	stylePage: function () {
		//summary:styles the progressbar by setting height,width,message width
		//tags:public
		if(this.rootDiv){
			dojo.style (this.rootDiv, "align", "center");
			//dojo.style (this.progressBarTable, "width", this.width);
			dojo.style (this.progressBarTable, "height", this.height);  
			dojo.style (this.rootDiv, "width", this.width);
			var msgWidth = this.calculateMsgWidth();
			//dojo.style (this.msgareaDiv, "width", this.msgWidth); 
		}
	},
	
	show: function(  )
	{
		//summary:display the progressbar
		//tags:public
		this.stylePage();
		if(this.target == this.rootDiv){
			this.rootDiv.style.display="block";
		}
		else if(!this._displayed){
			this.domNode.style.display="block";
			this._displayed = true;
			if(this.target != this.rooDiv){
				this._size();
				this._fadeIn();
			}
		}
		//this.rootDiv.style.display="";
	},

	hide: function() {
		//summary:hides the progressbar
		//tags:public
		if(this.domNode){
			this._displayed = false;
			if(this.target != this.rootDiv){
				this._fadeOut();
			}
			this.domNode.style.display="none";
			
		}
		//this.rootDiv.style.display="none";
	},

	_size: function(){
		// summary:
		//		Internal function that handles centering of the progressbar on window resizing
		//		and when the target node is specified
		//		It also sizes and styles the underlay node to block/overlay the target node...
		// tags:
		//		private
		
		/*# 40363: Enhanced Progressbar need "modal" option to be compatible with previous LDTW's BusyPane 
		 * A new function to handle the centering of the progress bar when target is specified..*/
		 
		if(this._displayed) {
			//debugger;
			var dir = dojo.body().dir;
			if(dir){dir = dir.toLowerCase();}
			var _ie7zoom;
			var scrollers = this._scrollerWidths();
			var target = this.target;
	
			var box = (target == this.domNode)?null:dojo.position(target,true);
			
			if(target === dojo.body() || target === dojo.doc){
				// Target is the whole doc, so scale to viewport.
			//	box = dojo.window.getBox();
				box = dojo.window.getBox();
				//box = viewport;
				box.x = box.l;
				box.y = box.t;
				
			}
			var cntrIndicator = dojo.getMarginBox(this.rootDiv);
			//IE has a horrible zoom bug.  So, we have to try and account for
			//it and fix up the scaling.
			if(this._ieFixNode){
				_ie7zoom = -this._ieFixNode.offsetTop / 1000;
				box.x = Math.floor((box.x + 0.9) / _ie7zoom);
				box.y = Math.floor((box.y + 0.9) / _ie7zoom);
				box.w = Math.floor((box.w + 0.9) / _ie7zoom);
				box.h = Math.floor((box.h + 0.9) / _ie7zoom);
			}
	
			//Figure out how to zIndex this thing over the target.
			var zi = dojo.getAttr(target, "zIndex");
			var ziIn = zi;
			var ziUl = zi;
	
			if(this.zIndex === "auto"){
				if(zi != "auto" && zi != null){
					ziUl = parseInt(ziUl, 10) + 1;
					ziIn = parseInt(ziIn, 10) + 2;
				}else{
					//We need to search up the chain to see if there
					//are any parent zIndexs to overlay.
					var cNode = target.parentNode;
					var oldZi = -100000;
					while(cNode && cNode !== dojo.body()){
						zi = dojo.getAttr(cNode, "zIndex");
						if(!zi || zi === "auto"){
							cNode = cNode.parentNode;
						}else{
							var newZi = parseInt(zi, 10);
							if(oldZi < newZi){
								oldZi = newZi;
								ziUl = newZi + 1;
								ziIn = newZi + 2;
							}
							// Keep looking until we run out, we want the highest zIndex.
							cNode = cNode.parentNode;
						}
					}
					if(ziUl == null){
						ziUl = 9999;
						ziIn = ziUl + 2;
					}
				}
			}else{
				ziUl = parseInt(this.zIndex, 10) + 1;
				ziIn = parseInt(this.zIndex, 10) + 2;
			}
	
			dojo.style(this._underlayNode, "zIndex", ziUl);
			dojo.style(this.rootDiv, "zIndex", ziIn);
	
			var pn = target.parentNode;
			if(pn && pn !== dojo.body() &&
					target !== dojo.body() &&
					target !== dojo.doc && target !== this.domNode){
	
				// If the parent is the body tag itself,
				// we can avoid all this, the body takes
				// care of overflow.  Besides, browser
				// weirdness with height and width on body causes
				// problems with this sort of intersect testing
				// anyway.
				var obh = box.h;
				var obw = box.w;
				var pnBox = dojo.position(pn,true);
	
				//More IE zoom corrections.
				if(this._ieFixNode){
					_ie7zoom = -this._ieFixNode.offsetTop / 1000;
					pnBox.x = Math.floor((pnBox.x + 0.9) / _ie7zoom);
					pnBox.y = Math.floor((pnBox.y + 0.9) / _ie7zoom);
					pnBox.w = Math.floor((pnBox.w + 0.9) / _ie7zoom);
					pnBox.h = Math.floor((pnBox.h + 0.9) / _ie7zoom);
				}
	
				//Shift the parent width/height a bit if scollers are present.
				pnBox.w -= pn.scrollHeight > pn.clientHeight &&
				pn.clientHeight > 0 ? scrollers.v: 0;
				pnBox.h -= pn.scrollWidth > pn.clientWidth &&
				pn.clientWidth > 0 ? scrollers.h: 0;
				
	
				//RTL requires a bit of massaging in some cases
				//(and differently depending on browser, ugh!)
				//WebKit and others still need work.
				if(dir === "rtl"){
					if(dojo.isOpera){
						box.x += pn.scrollHeight > pn.clientHeight &&
						pn.clientHeight > 0 ? scrollers.v: 0;
						pnBox.x += pn.scrollHeight > pn.clientHeight &&
						pn.clientHeight > 0 ? scrollers.v: 0;
					}else if(dojo.isIE){
						pnBox.x += pn.scrollHeight > pn.clientHeight &&
						pn.clientHeight > 0 ? scrollers.v: 0;
					}else if(dojo.isWebKit){
						//TODO:  FIX THIS!
					}
				}
	
				//Figure out if we need to adjust the overlay to fit a viewable
				//area, then resize it, we saved the original height/width above.
				//This is causing issues on IE.  Argh!
				if(pnBox.w < box.w){
					//Scale down the width if necessary.
					box.w = box.w - pnBox.w;
				}
				if(pnBox.h < box.h){
					//Scale down the width if necessary.
					box.h = box.h - pnBox.h;
				}
				//Look at the y positions and see if we intersect with the
				//viewport borders.  Will have to do computations off it.
				var vpTop = pnBox.y;
				var vpBottom = pnBox.y + pnBox.h;
				var bTop = box.y;
				var bBottom = box.y + obh;
				var vpLeft = pnBox.x;
				var vpRight = pnBox.x + pnBox.w;
				var bLeft = box.x;
				var bRight = box.x + obw;
				var delta;
				//Adjust the height now
				if(bBottom > vpTop &&
						bTop < vpTop){
					box.y = pnBox.y;
					//intersecting top, need to do some shifting.
					delta = vpTop - bTop;
					var visHeight = obh - delta;
					//If the visible height < viewport height,
					//We need to shift it.
					if(visHeight < pnBox.h){
						box.h = visHeight;
					}else{
						//Deal with horizontal scrollbars if necessary.
						box.h -= 2*(pn.scrollWidth > pn.clientWidth &&
								pn.clientWidth > 0? scrollers.h: 0);
					}
				}else if(bTop < vpBottom && bBottom > vpBottom){
					//Intersecting bottom, just figure out how much
					//overlay to show.
					box.h = vpBottom - bTop;
				}else if(bBottom <= vpTop || bTop >= vpBottom){
					//Outside view, hide it.
					box.h = 0;
				}
	
				//adjust width
				if(bRight > vpLeft && bLeft < vpLeft){
					box.x = pnBox.x;
					//intersecting left, need to do some shifting.
					delta = vpLeft - bLeft;
					var visWidth = obw - delta;
					//If the visible width < viewport width,
					//We need to shift it.
					if(visWidth < pnBox.w){
						box.w = visWidth;
					}else{
						//Deal with horizontal scrollbars if necessary.
						box.w -= 2*(pn.scrollHeight > pn.clientHeight &&
								pn.clientHeight > 0? scrollers.w:0);
					}
				}else if(bLeft < vpRight && bRight > vpRight){
					//Intersecting right, just figure out how much
					//overlay to show.
					box.w = vpRight - bLeft;
				}else if(bRight <= vpLeft || bLeft >= vpRight){
					//Outside view, hide it.
					box.w = 0;
				}
	
			}
	
			
			if(box && box.h > 0 && box.w > 0){
				if(!(this.target === dojo.body() || this.target === dojo.doc) && this.target.offsetLeft == 0 ){
					box.x = this.target.offsetLeft;
					box.y = this.target.offsetTop;
				}
				//Set position and size of the blocking div overlay.
						dojo.style(this._underlayNode, {
							display: "block",
							width: box.w + "px",
							height: box.h + "px",
							top: box.y + "px",
							left: box.x + "px",
							backgroundColor: this.color
						});
						
				var styles = ["borderRadius", "borderTopLeftRadius",
							"borderTopRightRadius","borderBottomLeftRadius",
							"borderBottomRightRadius"];
						this._cloneStyles(styles);
				if(!dojo.isIE){
					//Browser specific styles to try and clone if non-IE.
					styles = ["MozBorderRadius", "MozBorderRadiusTopleft",
						"MozBorderRadiusTopright","MozBorderRadiusBottomleft",
						"MozBorderRadiusBottomright","WebkitBorderRadius",
						"WebkitBorderTopLeftRadius", "WebkitBorderTopRightRadius",
						"WebkitBorderBottomLeftRadius","WebkitBorderBottomRightRadius"
					];
					this._cloneStyles(styles, this);
				}
				var cntrIndicatorTop = (box.h/2) - (cntrIndicator.h/2);
				var cntrIndicatorLeft = (box.w/2) - (cntrIndicator.w/2);
				//Only show the image if there is height and width room.
				var top = cntrIndicatorTop + box.y;
				var left = cntrIndicatorLeft + box.x;
				if(box.h >= cntrIndicator.h && box.w >= cntrIndicator.w){
					dojo.style(this.rootDiv, {
						top: top + "px",
						left: left + "px",
						display: "block"
					});
				}else{
					dojo.style(this._underlayNode, "display", "none");
					dojo.style(this.rootDiv, "display", "none");
				}
			}else{
				//Target has no size, do not position
				//a case when the current domnode itself is a target (defautl case)
				//do nothing on positioning the progress bar
			}
			if(this._resizeCheck === null){
				//Set an interval timer that checks the target size and scales as needed.
				//Checking every 10th of a second seems to generate a fairly smooth update.
				var self = this;
				//hope this is not needed as window resize is getting handled....
				//keeping it commented in case it is required...
				//note: it is a overhead if this keeps running every fraction of a second...
				//should be used only if required...
				this._resizeCheck = setInterval(function(){self._size();}, 100);
			}
		}
		//}
	},
	_cloneStyles: function(list){
			// summary:
			//		Internal function to clone a set of styles from the target to
			//		the underlay.
			// list: Array
			//		An array of style names to clone.
			//
			// tags:
			//		private
			dojo.forEach(list, function(s){
				dojo.style(this._underlayNode, s, dojo.getStyle(this.target, s));
			}, this);
	},
	
	_scrollerWidths: function(){
		// summary:
		//		This function will calculate the size of the vertical and
		//		horizontal scrollbars.
		// returns:
		//		Object of form: {v: Number, h: Number} where v is vertical scrollbar width
		//		and h is horizontal scrollbar width.
		// tags:
		//		private
		/*# 40363: Enhanced Progressbar need "modal" option to be compatible with previous LDTW's BusyPane */
		 
		var div = dojo.create("div");
		dojo.style(div, {
			position: "absolute",
			opacity: 0,
			overflow: "hidden",
			width: "50px",
			height: "50px",
			zIndex: "-100",
			top: "-200px",
			padding: "0px",
			margin: "0px"
		});
		var iDiv = dojo.create("div");
		dojo.style(iDiv, {
			width: "200px",
			height: "10px"
		});
		div.appendChild(iDiv);
		dojo.body().appendChild(div);
	
		//Figure out content size before and after
		//scrollbars are there, then just subtract to
		//get width.
		var b = dojo.getContentBox(div);
		dojo.style(div, "overflow", "scroll");
		var a = dojo.getContentBox(div);
		dojo.body().removeChild(div);
		return { v: b.w - a.w, h: b.h - a.h };
	},

	//Satanik:03May2011: updating destroy for complete cleanup
	destroy: function(){
		// summary:  Destroys the toolbar.
		// tags: public	
		//memory leak issue: custom destroy method to take care of removing all widgets					
		try{
			//this.domNode was not getting cleanedup completely by the destroy so hiding the dom node.
			//this.domNode.style.display = "none";
			delete this.resources_;
			//this is for destroying child templated widgets 
			//this should happen by itself but need to figure out why dijit._Templated is not taking care of it...
			if(this.domNode){
				this._displayed = false;
				var widgets = dijit.findWidgets(this.domNode);
				dojo.forEach(widgets, function(w) {
					if(w){
						if(w.destroyRecursive){
							w.destroyRecursive();
						} else if(w.destroy){
							w.destroy();
						}
					}
				});
				// this is for widgets added as child to this widget and their children..
				//not present in template
				var widgetArr = this.getChildren();
				dojo.forEach(widgetArr, function (child) {
					if(child){
						if(child.destroyRecursive){
							child.destroyRecursive();
						} else if(child.destroy){
							child.destroy();
						}
					}
				});
				this.inherited(arguments);
				//console.log(this.domNode);
				//if(this.domNode) this.domNode.destroy();
	
			}
		}catch(ex){
			console.warn("Widget destroy failed: "+this.id+", ex="+ex.name+":"+ex.message);
		}
	},
	
	onview:function(){                                   
		//summary:parses the template
		//tags:public				
		dojo.parser.parse(this.progressBarTable);			
	}
}); 

});
