require({cache:{
'url:dojoe/refreshtimer/templates/RefreshTimerButton.html':"<div data-dojo-attach-point=\"containerNode\">\n\t<div data-dojo-attach-point=\"selectorButtonNode\">\n\t</div>\n</div>"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/refreshtimer/RefreshTimerButton",[
        "dojo/_base/lang",
        "dojo/_base/declare",
        "dijit/_WidgetBase",
        "dijit/_TemplatedMixin",
        "dijit/Menu",
        "dijit/MenuItem",
        "dijit/MenuSeparator",
        "dijit/form/DropDownButton",
        "dojo/i18n",
        "dojo/i18n!dojoe/refreshtimer/nls/Common",
		"dojoe/BidiUtil",
        "dojo/text!dojoe/refreshtimer/templates/RefreshTimerButton.html"
        ], function(lang, declare, _WidgetBase, _TemplatedMixin, Menu, MenuItem, MenuSeparator, DropDownButton, i18n, Common, bidiUtil, template){
		
		return declare("dojoe.refreshtimer.RefreshTimerButton", [_WidgetBase, _TemplatedMixin], {
		
			templateString: template,
			_selectorButton: null,
			uniqueId: null,
			style: null,
			
			constructor: function(args) {
				this.uniqueId = args._uId;
				this.style = args.style;
				
				this._initLocalization();
				this._initTimerValues(args.timerList);
				
				this._selectorButton =   "_selectorButton_"+this.uniqueId;	
			},
			
			_initLocalization: function() {				  
				  this._minuteText = Common.MINUTE;
				  this._minutesText = Common.MINUTES;
			},
			
			_initTimerValues: function(values){
					this._timerValues = new Array();
					
					if(values.length == 0) {
						this._timerValues.push({value:1,unit:"minute"});
						this._timerValues.push({value:2,unit:"minutes"});
						this._timerValues.push({value:5,unit:"minutes"});
						this._timerValues.push({value:7,unit:"minutes"});
						this._timerValues.push({value:10,unit:"minutes"});
					} else {
						var timerList = values.split(',');
										
						for(var index in timerList) {
							var selValue = timerList[index];
							if(selValue == 1)
								this._timerValues.push({value:selValue,unit:"minute"});
							else
								this._timerValues.push({value:selValue,unit:"minutes"});
						}						
					}					
			},

			postCreate: function(){
				var timeSelectorList = new Menu({});
				
				var timerButtonItem = new MenuItem({});
				
				timeSelectorList.addChild(timerButtonItem);
				timeSelectorList.set('aria-label', 'RefreshTimer interval list');
				
				var timerButtonMenuItem = null;
				for(var i=0;i<this._timerValues.length;i++){
					timerButtonMenuItem = this._timerValues[i];
					timeSelectorList.addChild(this._createMenuItem(timerButtonMenuItem));
				}
				
				var params = {
					label: this._displayText,
					dropDown: timeSelectorList,
					dir: this.dir,
					style: this.style,
					showLabel: this.showLabel,
					iconClass: this.iconToUse
				};
				
				this._selectorButton = new DropDownButton(params, this.selectorButtonNode);
				var stopTimerMethodName = this.uniqueId+'stopCountDownTimer';
				dojo.connect(this._selectorButton, "onClick", window[stopTimerMethodName]);
				this._selectorButton.startup();
				
				window[this.uniqueId+'_selectorButton'] = this._selectorButton;
				
			},
			
			_createMenuItem: function(menuItem) {
				var value = menuItem.value;
				var unit = menuItem.unit;
				var labelText = value + " " + this._getUnitText(unit);				
				var timerMenuItem = new dijit.MenuItem({
					label: bidiUtil.getFormattedText(labelText,"auto","ltr"),
					onClick: lang.hitch(this, function() {
						var startTimerMethodName = this.uniqueId+'startCountDownTimer';
						window[startTimerMethodName](value);	

						var setCountMethodName = this.uniqueId+'setCountOnLabel';
						window[setCountMethodName](this._selectorButton);	
					}),
					
				});
				return timerMenuItem;
			},
			
			_getUnitText: function(unit){
				if(unit == "minute"){
					return this._minuteText;
				}
				else if(unit == "minutes"){
					return this._minutesText;
				}else{
					return null;
				}
				
			},			
			
		});
});		
		