require({cache:{
'url:dojoe/ssd/quickedit/templates/DefaultMapper.html':"<div style=\"height:100%;width:100%;\"> \n\t<b class=\"label\" data-dojo-attach-point=\"mappingGridLabel\">${nls.MAP_VISUAL_ATTRIBUTES}</b><br/>\t\n\t<div id=\"${id}_mappingGridContainer\" data-dojo-attach-point=\"mappingGridNode\" style=\"height:100%;width:100%;\"></div>\n</div>"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/ssd/quickedit/DefaultMapper", [
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dojo/text!./templates/DefaultMapper.html",
	"dojoe/tablelayout/TableLayout",
	'dijit/form/TextBox',
	"dijit/form/FilteringSelect",
	"dojo/store/Memory",
	"dojo/i18n!./nls/QueryDatasets",
	"dojoe/Util"
], function (declare,lang,_WidgetBase, _TemplatedMixin, template, TableLayout,TextBox,FilteringSelect,Memory, nlsBundle) {
	 return declare("dojoe.ssd.quickedit.DefaultMapper", [_WidgetBase, _TemplatedMixin], {
		templateString: template,
		mappingGrid_data: null,
		columns: null,
		nls:nlsBundle,

		constructor: function (mappingGrid_data, columns) {
			//lang.mixin (this, props);
			this.mappingGrid_data = mappingGrid_data;
			this.columns = columns;
		},

		createMappingGrid: function () {
			console.log ("DefaultMapper.createMappingGrid... BEGIN");
			
			var datasetAttribs = new Array();
			datasetAttribs.push({'label':this.nls.NONE, 'value': "None", 'selected': true});
			var datasetAttribsTemp = new Array();

			for (i=0;i<this.columns.length;i++){
				//exclude hidden columns from dataset
				//59268: TBSM36938: QuickEdit should not display hidden columns
				//Bobby: 06Dec2012, hidden should be changed to isHidden() API with NavModel
				//if(!this.columns[i].hidden)
				if(!this.columns[i].isHidden())
					datasetAttribsTemp.push({
						'value': this.columns[i].getId(), 
						'label': this.columns[i].getLabel(), 
						'valueType': this.columns[i].getValueType()
					});
			}
			//sort the dataset columns
			datasetAttribsTemp.sort(function(a, b){
				if (a.label < b.label) //sort string ascending
					return -1;
				if (a.label > b.label)
					return 1;
				return 0; //default return value (no sorting)
			});

			datasetAttribs = datasetAttribs.concat(datasetAttribsTemp);

			console.info("datasetAttribs..");
			console.dir(datasetAttribs);
			console.info('dashletConfig:');
			console.dir(dashletConfig);

			if(!this.mappingGrid_data){
				this.mappingGrid_data =  { "identifier": "id", "idAttribute":"id", "items": []};
			}else{
				var attribName;
				var filteredDatasetAttribs;
				this.mappingGrid_data.itemsUI = new Array();
				for(var i=0;i<this.mappingGrid_data.items.length;i++){
					//filter dataset column types
					if(!this.mappingGrid_data.items[i].valueTypes || this.mappingGrid_data.items[i].valueTypes.length == 0
							|| this.mappingGrid_data.items[i].valueTypes[0] == 'any'){
						//53666 TWL 1.1 : List Attributes in Required settings reset to default values when opened second time
						filteredDatasetAttribs = lang.clone(datasetAttribs);
					}else{
						filteredDatasetAttribs = new Array();
						filteredDatasetAttribs.push({ 'label':this.nls.NONE, 'value': "None", 'selected': true});
						for(var k=0;k<datasetAttribs.length;k++){
							for(var l=0;l<this.mappingGrid_data.items[i].valueTypes.length;l++){
								if(this._mapDataType(datasetAttribs[k].valueType) == this.mappingGrid_data.items[i].valueTypes[l])
									filteredDatasetAttribs.push(datasetAttribs[k]);
							}
						}
					}

					//Bobby: 22Mar2013 - Changing from Select to FilteringSelect format
					for(var x=0;x<filteredDatasetAttribs.length;x++){
						filteredDatasetAttribs[x].name = filteredDatasetAttribs[x].label;
					}
					
					//console.warn("filteredDatasetAttribs:");
					//console.dir(filteredDatasetAttribs);
					
					//check whether attribute is in preferences
					for(var j=0;j<dashletConfig.attrNameArr.length;j++){
						attribName = dashletConfig.attrNameArr[j].replace("qe_attr_","");
						//console.log("attribName:"+attribName);
						//console.log("this.mappingGrid_data.items[i].id:"+this.mappingGrid_data.items[i].id);
						if(this.mappingGrid_data.items[i].id == attribName){
							this.mappingGrid_data.itemsUI[i] = new Object();
							this.mappingGrid_data.itemsUI[i].item_id = attribName;
							this.mappingGrid_data.itemsUI[i].item_name = this.mappingGrid_data.items[i].name?this.mappingGrid_data.items[i].name:this.mappingGrid_data.items[i].id;
							this.mappingGrid_data.itemsUI[i].item_desc = this.mappingGrid_data.items[i].description;
							//this.mappingGrid_data.itemsUI[i].item_value = new Select({options: filteredDatasetAttribs, style: "width:150px;" });
							this.mappingGrid_data.itemsUI[i].item_value = new FilteringSelect({store: new Memory({idProperty: "value", data: filteredDatasetAttribs})});
							if(dashletConfig.attrValueArr[j]){
								this.mappingGrid_data.itemsUI[i].item_value.set('value', unescapeHTML(dashletConfig.attrValueArr[j]));
							}
						}
					}
					//if attribute not found in preferences, create default control
					if(!this.mappingGrid_data.itemsUI[i]){
						console.log("No settings in preferences for ..."+ this.mappingGrid_data.items[i].id);
						this.mappingGrid_data.itemsUI[i] = new Object();
						this.mappingGrid_data.itemsUI[i].item_id = this.mappingGrid_data.items[i].id;
						this.mappingGrid_data.itemsUI[i].item_name = this.mappingGrid_data.items[i].name?this.mappingGrid_data.items[i].name:this.mappingGrid_data.items[i].id;
						this.mappingGrid_data.itemsUI[i].item_desc = this.mappingGrid_data.items[i].description;
						this.mappingGrid_data.itemsUI[i].item_value = new FilteringSelect({store: new Memory({idProperty: "value", data: filteredDatasetAttribs})});
						//70702: TWL 1.1.0.2 : Gauges Value in Required Settings of QE is blank by default (should be None)
						//02Apr2013, Bobby Joseph: Setting default value to None
						this.mappingGrid_data.itemsUI[i].item_value.set('value', "None");
					}
				}
			}

			console.info("mappingGrid_data..");
			console.dir(this.mappingGrid_data);

			if(this.mappingGrid_data.itemsUI.length > 0){	
				this.mappingGrid = new TableLayout({
					items: this.mappingGrid_data.itemsUI,
					rowTemplatePath: dojo.moduleUrl("dojoe.ssd.quickedit","templates/RowLayout.html")
				},this.mappingGridNode);
			}else this.mappingGridLabel.innerHTML = this.nls.NO_MAPPING_ATTRIBUTES;
			console.log ("DefaultMapper.createMappingGrid... END");
		},


		_mapDataType: function(dataType){
			switch( dataType ){
				case "byte": case "short":  case "int": case "long": case "ushort": case "ubyte": case "uint": case "ulong": case "float": case "double": case "decimal": case "percentage" : case "java.lang.Integer": case "java.lang.Double": case "java.lang.Long": case "java.lang.Decimal":
					return "number";
				case "status":
					return "status";
				case "boolean": case "java.lang.Boolean":
					return "boolean";
				case "date": case "datetime": case "isodate": case "isodatetime": case "java.lang.Date": case "java.util.Date":
					return "date";
				case "time": case "isotime" :
					return "time";
				default :
					return "string";
			}
		},

		//This is expected out of any Custom Mapping widget
		//QuickEditController.js looks for this method to get current UI state when 'OK' is pressed
		//This value is stored in prefrences and View JSP retrieves from there
		getQuickEditMappingString: function () {
			var quickEditMapping="";
			for(var i=0;i<this.mappingGrid_data.itemsUI.length;i++){
				var valueSet = this.mappingGrid_data.itemsUI[i].item_value.get('value');
				valueSet = escape(escapeHTML(valueSet));
				quickEditMapping = quickEditMapping +
									"&qe_attr_"+this.mappingGrid_data.itemsUI[i].item_id+
									"="+valueSet;
			}
			return quickEditMapping;
		},

		destroy: function () {
			if(this.mappingGridNode){
				if(this.mappingGridNode.destroyRecursive) this.mappingGridNode.destroyRecursive();
				else if (this.mappingGridNode.destroy) this.mappingGridNode.destroy();
			}
			this.inherited(arguments);
		}
	});
});
