require({cache:{
'url:dojoe/ssd/quickedit/templates/GaugeOptions.html':"<div style=\"height:100%;width:100%;\"> \n\t<div data-dojo-attach-point=\"gaugeOptionsNode\"></div>\t\n</div>\t"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/ssd/quickedit/GaugeOptions", [
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dojo/text!./templates/GaugeOptions.html",
	"dojo/i18n!./nls/GaugeOptions",
	"dojoe/ssd/quickedit/DatasetDetails",
	"dojoe/tablelayout/TableLayout",
	"dijit/form/TextBox",
	"dijit/form/NumberSpinner",
	"dijit/form/NumberTextBox",
	"dijit/form/ComboBox",
	"dijit/form/CheckBox",
	"dojo/store/Memory",
	"dojoe/Util"
], function (declare, lang, _WidgetBase, _TemplatedMixin, template, nlsBundle, datasetDetails, TableLayout, TextBox, NumberSpinner, NumberTextBox, ComboBox, CheckBox, Memory) {
	 return declare("dojoe.ssd.quickedit.GaugeOptions", [_WidgetBase, _TemplatedMixin], {
		templateString: template,
		nls: nlsBundle,
		optionsList: null,		
		_datasetColumns: null,
		_gaugeName: "AnalogGauge",
		_topLabelCustom:"true",
		_leftLabelCustom:"true",
		_disableThreshold:"false",
		_oslcResourceURI:"false",
		
		constructor: function (args) {
			console.debug("In GaugeOptions Constructor");
			this._gaugeName = args.name;
		},
			
		postCreate: function() {
			console.debug("In GaugeOptions postCreate : " + quickEdit);
		},
		
		createOptionsGrid: function() {
			quickEdit.getDatasetColumns(this, "_getDatasetAttributes");
		},
		
		_getDatasetAttributes: function(columns) {
			this._datasetColumns = new Array();
			this._datasetColumns.push({id:"None", name:this.nls.NONE});			
			var datasetColumnsTemp = new Array();					
		
			for (var i=0;i<columns.length;i++){
				//exclude hidden columns from dataset
				if(!columns[i].isHidden()){
					datasetColumnsTemp.push({
						id: columns[i].getId(), 
						name: columns[i].getLabel(), 
						valueType: columns[i].getValueType()
					});			
				}	
				if(columns[i].getId() == "OslcResourceURI")
					this._oslcResourceURI = true;
			}			

			//sort the dataset columns
			datasetColumnsTemp.sort(function(a, b){
				if (a.name < b.name) //sort string ascending
					return -1;
				if (a.name > b.name)
					return 1;
				return 0; //default return value (no sorting)
			});			
			
			this._datasetColumns = this._datasetColumns.concat(datasetColumnsTemp);				

			console.info("Dataset Attributes...");
			console.dir(this._datasetColumns);			
			
			this.createGaugeOptions();			
		},
		
		_updateThreshold: function(widget) {
			var val;
			var initialThresholdState = this._disableThreshold; // for optimization, don't need to change options if state doesn't change
			var options = widget.item;
			if(options) {
				if(options.valueType && options.valueType.toLowerCase() == "status") {
					this._disableThreshold = true;
				} else {
					this._disableThreshold = false;
				}
			}
			//Select has been changed to Filtering Select in DefaultMapper hence changes
			/*for(var i in options) {
				if(options[i].value == widget.get('value') && options[i].valueType && options[i].valueType.toLowerCase() == "status") {
					this._disableThreshold = true;
					break;
				} else {
					this._disableThreshold = false;
				}
			}*/
			if(this._disableThreshold != initialThresholdState) { // do this only if there is a change in state
				for(var i=0; i<this.optionsList._rowsNode.children.length; i++) {
					if(this.optionsList._rowsNode.children[i].innerHTML.indexOf("Threshold Value")>-1) { // Need a better way identify this
						if(this._disableThreshold)
							this.optionsList._rowsNode.children[i].style.display = "none";
						else
							this.optionsList._rowsNode.children[i].style.display = "";
					}
				}
			}
		},
		
		createGaugeOptions: function () {	
			
			console.log ("GaugeOptions._createOptionsGrid... BEGIN");			
			if(this._gaugeName == "StatusGauge") {
				for(var i in quickEdit.dd.mappingGrid_data.items) {
					if(quickEdit.dd.mappingGrid_data.items[i].id == "Value") {
						quickEdit.dd.mappingGrid_data.itemsUI[i].item_value.onChange = dojo.hitch(this, this._updateThreshold, quickEdit.dd.mappingGrid_data.itemsUI[i].item_value);
					}
				}
			}
			// Create the options grid
			if(!this.optionsGrid_data)
				this.optionsGrid_data = { "identifier": "id", "idAttribute":"id", "items": [], "itemsUI": []};
			
			this.optionsGrid_data.items = new Array();
			this.optionsGrid_data.items.push({id:"TopLabel", name:this.nls.TOPLABEL, description: this.nls.DESC_TOPLABEL, valueType: "label"});
			this.optionsGrid_data.items.push({id:"LeftLabel", name:this.nls.LEFTLABEL, description: this.nls.DESC_LEFTLABEL, valueType: "label"});
			this.optionsGrid_data.items.push({id:"Informational", 
				name: "<image alt='"+this.nls.INFORMATIONAL+"' src="+require.toUrl("dojoe/ssd/quickedit/images/Informational.png")+" /> "+this.nls.INFORMATIONAL, 
				description:this.nls.DESC_INFORMATIONAL, valueType:"numberInput"});
			this.optionsGrid_data.items.push({id:"Normal", 
				name: "<image alt='"+this.nls.NORMAL+"' src="+require.toUrl("dojoe/ssd/quickedit/images/Normal.png")+" /> "+this.nls.NORMAL, 
				description:this.nls.DESC_NORMAL, valueType:"numberInput"});
			this.optionsGrid_data.items.push({id:"Minor", 
				name: "<image alt='"+this.nls.MINOR+"' src="+require.toUrl("dojoe/ssd/quickedit/images/MinorWarning.png")+" /> "+this.nls.MINOR, 
				description:this.nls.DESC_MINOR, valueType:"numberInput"});
			this.optionsGrid_data.items.push({id:"Major", 
				name: "<image alt='"+this.nls.MAJOR+"' src="+require.toUrl("dojoe/ssd/quickedit/images/MajorWarning.png")+" /> "+this.nls.MAJOR, 
				description:this.nls.DESC_MAJOR, valueType:"numberInput"});
			this.optionsGrid_data.items.push({id:"Critical", 
				name: "<image alt='"+this.nls.CRITICAL+"' src="+require.toUrl("dojoe/ssd/quickedit/images/Critical.png")+" /> "+this.nls.CRITICAL, 
				description:this.nls.DESC_CRITICAL, valueType:"numberInput"});
			this.optionsGrid_data.items.push({id:"Fatal", 
				name: "<image alt='"+this.nls.FATAL+"' src="+require.toUrl("dojoe/ssd/quickedit/images/Fatal.png")+" /> "+this.nls.FATAL, 
				description:this.nls.DESC_FATAL, valueType:"numberInput"});
				
			if(this._gaugeName == "VolumeBar" || this._gaugeName == "AnalogGauge") {
				this.optionsGrid_data.items.push({id:"ShowThresholdStrip", name: this.nls.SHOWTHRESHOLDSTRIP, description:this.nls.DESC_SHOWTHRESHOLDSTRIP, valueType:"checkBox"});
				this.optionsGrid_data.items.push({id:"MinValue", name: this.nls.MINVALUE, description:this.nls.DESC_MINVALUE, def: "0", valueType:"numberSpinner"});
				this.optionsGrid_data.items.push({id:"MaxValue", name: this.nls.MAXVALUE, description:this.nls.DESC_MAXVALUE, def: "100", valueType:"numberSpinner"});
				this.optionsGrid_data.items.push({id:"MajorTicksSeparation", name: this.nls.MAJORTICKSSEPARATION, description:this.nls.DESC_MAJORTICKSSEPARATION, def: "20", valueType:"numberSpinner"});
			}
				
			if(this._gaugeName == "AnalogGauge") {
				this.optionsGrid_data.items.push({id:"MinorTicksSeparation", name: this.nls.MINORTICKSSEPARATION, description:this.nls.DESC_MINORTICKSSEPARATION, def:"5", valueType:"numberSpinner"});
				this.optionsGrid_data.items.push({id:"Unit", name:this.nls.UNIT, description: this.nls.DESC_UNIT});
			}
			this.optionsGrid_data.itemsUI = new Array();
			var attribName;
			for(var i=0;i<this.optionsGrid_data.items.length;i++){
				for(var j=0;j<dashletConfig.optionNameArr.length;j++){
					attribName = dashletConfig.optionNameArr[j].replace("qe_optn_","");
					if(this.optionsGrid_data.items[i].id == attribName){		
						this.optionsGrid_data.itemsUI[i] = new Object();
						this.optionsGrid_data.itemsUI[i].item_id = attribName;
						this.optionsGrid_data.itemsUI[i].item_name = this.optionsGrid_data.items[i].name;
						this.optionsGrid_data.itemsUI[i].item_desc = this.optionsGrid_data.items[i].description;						
						if(this.optionsGrid_data.items[i].valueType == 'label') {
							this.optionsGrid_data.itemsUI[i].item_value = new ComboBox({store: new Memory({ idProperty: "id", data: this._datasetColumns})});
							if(dashletConfig.optionValueArr[j]) {
								this.optionsGrid_data.itemsUI[i].item_value.set('value', unescapeHTML(dashletConfig.optionValueArr[j]));
								for(var k=0;k<this._datasetColumns.length;k++) {
									if(dashletConfig.optionValueArr[j] == this._datasetColumns[k].id)
										this.optionsGrid_data.itemsUI[i].item_value.set('value', this._datasetColumns[k].name);
								}
							}
						} else if(this.optionsGrid_data.items[i].valueType == 'checkBox') {
							this.optionsGrid_data.itemsUI[i].item_value = new CheckBox();
							if(dashletConfig.optionValueArr[j])
								this.optionsGrid_data.itemsUI[i].item_value.set('value', dashletConfig.optionValueArr[j] == "on"?true:false);
						} else if(this.optionsGrid_data.items[i].valueType == 'numberSpinner') {							
							if(dashletConfig.optionValueArr[j]){
								this.optionsGrid_data.itemsUI[i].item_value = new NumberSpinner();
								this.optionsGrid_data.itemsUI[i].item_value.set('value', dashletConfig.optionValueArr[j]);
							}else{
								this.optionsGrid_data.itemsUI[i].item_value = new NumberTextBox();
							}							
						}
						else {
							this.optionsGrid_data.itemsUI[i].item_value = new TextBox();
							if(dashletConfig.optionValueArr[j])
								this.optionsGrid_data.itemsUI[i].item_value.set('value', unescapeHTML(dashletConfig.optionValueArr[j]));
						}
					}
					if(attribName == 'UIPreview'){
						if(quickEdit.dd.richHoverCheckBox){
							console.info("value ofuiPreview in QE -- " + dashletConfig.optionValueArr[j]);
							quickEdit.dd.richHoverCheckBox.set("value",dashletConfig.optionValueArr[j]);
							if(dashletConfig.optionValueArr[j] == 'false')
								quickEdit.dd.richHoverCheckBox.set("checked",false);
							else quickEdit.dd.richHoverCheckBox.set("checked",true);	
						}					
					}
				}
				
				//if option not found in preferences, create default control
				if(!this.optionsGrid_data.itemsUI[i]){
					console.log("No settings in preferences for ..."+ this.optionsGrid_data.items[i].id);
					this.optionsGrid_data.itemsUI[i] = new Object();
					this.optionsGrid_data.itemsUI[i].item_id = this.optionsGrid_data.items[i].id;
					this.optionsGrid_data.itemsUI[i].item_name = this.optionsGrid_data.items[i].name;
					this.optionsGrid_data.itemsUI[i].item_desc = this.optionsGrid_data.items[i].description;
					if(this.optionsGrid_data.items[i].valueType == "numberSpinner")
						this.optionsGrid_data.itemsUI[i].item_value = new NumberSpinner();
					else if(this.optionsGrid_data.items[i].valueType == "numberInput")
						this.optionsGrid_data.itemsUI[i].item_value = new TextBox();				
					else if(this.optionsGrid_data.items[i].valueType == "label"){
						//59203: TBSM 36924: QuickEdit: inconsistent display of default value in drop down list
						//Bobby, 05Dec2012, adding None as default
						var columnsArray = [{"id":"None", "name": this.nls.NONE}];
						dojo.mixin(columnsArray,this._datasetColumns);
						this.optionsGrid_data.itemsUI[i].item_value = new ComboBox({
							value: this.nls.NONE, store: new Memory({ idProperty: "id", data: columnsArray})});
					}else if(this.optionsGrid_data.items[i].valueType == "checkBox")
						this.optionsGrid_data.itemsUI[i].item_value = new CheckBox();
					else
						this.optionsGrid_data.itemsUI[i].item_value = new TextBox();
					
					if(this.optionsGrid_data.items[i].def)
						this.optionsGrid_data.itemsUI[i].item_value.set('value', this.optionsGrid_data.items[i].def);
				}				
			}	

			console.log("this.optionsGrid_data -->");
			console.dir(this.optionsGrid_data);			
			console.log("this.optionsGrid_data.items.length - " + this.optionsGrid_data.itemsUI.length);	
					
			this.optionsList = new TableLayout({
				items: this.optionsGrid_data.itemsUI,
				rowTemplatePath: dojo.moduleUrl("dojoe.ssd.quickedit","templates/RowLayout.html")
			},this.gaugeOptionsNode);				
			
			this.optionsList.startup();
			// anurag : 58906: TBSM 36846 : Thresholds shown for status gauge when a status property is used for the value and you edit gauge more than once
			// when QE is opened for already configured dataset, we need to explicitly check if the value is
			// configured to Status obj and accordingly hide/show thresholding.
			if(this._gaugeName == "StatusGauge") {
				for(var i in quickEdit.dd.mappingGrid_data.items) {
					if(quickEdit.dd.mappingGrid_data.items[i].id == "Value") {
						this._updateThreshold(quickEdit.dd.mappingGrid_data.itemsUI[i].item_value);
					}
				}
			}
			
			//67644
			if (quickEdit.enablePageLaunch == true) {
				for(var j=0;j<dashletConfig.optionNameArr.length;j++) {
					var name = dashletConfig.optionNameArr[j].replace("qe_optn_","");
					if(name == 'LaunchPage') {
						if(quickEdit.dd.launchPageSelect && dashletConfig.optionValueArr[j])							
							quickEdit.dd.launchPageSelect.set("value",dashletConfig.optionValueArr[j]);
						break;
					}
				}
			}
			console.log ("GaugeOptions.createOptionsGrid... END");				
		},	
		
		getQuickEditOptionsString: function () {	
			console.info("In getQuickEditOptionsString");
			// Check if Labels are Custom
			for(i=0;i<this.optionsGrid_data.itemsUI.length;i++) {
				if(this.optionsGrid_data.itemsUI[i].item_id == "TopLabel" || this.optionsGrid_data.itemsUI[i].item_id == "LeftLabel") {
					var valueSet = "";
					//59203: TBSM 36924: QuickEdit: inconsistent display of default value in drop down list
					//Bobby, 05Dec2012, adding None as default
					if(this.optionsGrid_data.itemsUI[i].item_value.get('value') != this.nls.NONE){
						valueSet = this.optionsGrid_data.itemsUI[i].item_value.get('value');
					}	
					if(valueSet) {
						for(var j=0;j<this._datasetColumns.length;j++) {
							console.debug("Matching with : "+this._datasetColumns[j].id);
							if(this._datasetColumns[j].name == valueSet) {
								this.optionsGrid_data.itemsUI[i].item_value.set('value', this._datasetColumns[j].id);
								if(this.optionsGrid_data.itemsUI[i].item_id == "TopLabel")
									this._topLabelCustom = "false";
								else
									this._leftLabelCustom = "false";
								break;
							}
						}						
					}
				}
			}
			
			var quickEditOptions="";							
			
			for(var i=0;i<this.optionsGrid_data.itemsUI.length;i++){
				var valueSet = "";				
				//59203: TBSM 36924: QuickEdit: inconsistent display of default value in drop down list
				//Bobby, 05Dec2012, adding None as default
				if(this.optionsGrid_data.itemsUI[i].item_value.get('value') != this.nls.NONE){
					valueSet = this.optionsGrid_data.itemsUI[i].item_value.get('value');
				}				
				//anurag: 03Sep2012, sending NaN creates issues
				if(valueSet == this.nls.NONE || valueSet.toString() == "NaN"){ 	
					quickEditOptions = quickEditOptions + 
										"&qe_optn_"+this.optionsGrid_data.itemsUI[i].item_id+
										"=";
				}else {
					valueSet = escape(escapeHTML(valueSet));
					console.info(this.optionsGrid_data.itemsUI[i].item_id+" : "+ valueSet );
					quickEditOptions = quickEditOptions + 
											"&qe_optn_"+this.optionsGrid_data.itemsUI[i].item_id+
											"="+valueSet;
				}
			}
			
			// Add the label flags to quickEditOptions
			quickEditOptions = quickEditOptions +
								"&qe_optn_TopLabelCustom="+this._topLabelCustom;
								
			quickEditOptions = quickEditOptions +
								"&qe_optn_LeftLabelCustom="+this._leftLabelCustom;
			
			if(quickEdit.dd.richHoverCheckBox){
				 if(quickEdit.dd.richHoverCheckBox.get('checked')){
					quickEditOptions = quickEditOptions + "&qe_optn_UIPreview=true"
				}else quickEditOptions = quickEditOptions + "&qe_optn_UIPreview="+ quickEdit.dd.richHoverCheckBox.get('checked');	 
			}
			//67644
			if(quickEdit.enablePageLaunch == true && quickEdit.dd.launchPageSelect){
				quickEditOptions = quickEditOptions + "&qe_optn_LaunchPage="+quickEdit.dd.launchPageSelect.get('value');			
			}
								
			return quickEditOptions;
		},
		  
		validate: function() {
			var maxValue, minValue, majorTicks, minorTicks;
			var allThresholds = [];
			for(i=0;i<this.optionsGrid_data.itemsUI.length;i++) {
				if(this.optionsGrid_data.items[i].valueType == "number" && this.optionsGrid_data.itemsUI[i].item_value.getValue() === undefined) {
					var msgDialog = new dojoe.messagedialog.MessageDialog({namespace: portletId+'_tsErrMsg', message: quickEdit.quickEditCCS.nls.MSGDIALOG_OPTIONAL_DATASET_INVALID_PARAMS});
					msgDialog.show();
					return false;
				}
				if(this.optionsGrid_data.itemsUI[i].item_id == "MajorTicksSeparation") {
					majorTicks = this.optionsGrid_data.itemsUI[i].item_value.getValue();
				} else if(this.optionsGrid_data.itemsUI[i].item_id == "MinorTicksSeparation") {
					minorTicks = this.optionsGrid_data.itemsUI[i].item_value.getValue();
				} else if(this.optionsGrid_data.itemsUI[i].item_id == "MaxValue") {
					maxValue = this.optionsGrid_data.itemsUI[i].item_value.getValue();
				} else if(this.optionsGrid_data.itemsUI[i].item_id == "MinValue") {
					minValue = this.optionsGrid_data.itemsUI[i].item_value.getValue();
				} else if(	this.optionsGrid_data.itemsUI[i].item_id == "Informational" ||
							this.optionsGrid_data.itemsUI[i].item_id == "Normal" || 
							this.optionsGrid_data.itemsUI[i].item_id == "Minor" ||
							this.optionsGrid_data.itemsUI[i].item_id == "Major" ||
							this.optionsGrid_data.itemsUI[i].item_id == "Critical" ||
							this.optionsGrid_data.itemsUI[i].item_id == "Fatal"
							) {
					allThresholds.push(this.optionsGrid_data.itemsUI[i].item_value.getValue());
				}
			}
			//maxValue, minValue, majorTicks, minorTicks;
			if(!maxValue)
				maxValue = 100;
			if(!minValue)
				minValue = 0;
				
			for(var index in allThresholds) {
				var value = allThresholds[index];
				if(isNaN(value)) {
						var msgDialog = new dojoe.messagedialog.MessageDialog({namespace: portletId+'_tsErrMsg', message: this.nls.MSGDIALOG_GAUGES_INVALID_EXPONENT});
						msgDialog.show();
						return false;
				}
			}
			
			if(maxValue <= minValue) {
				var msgDialog = new dojoe.messagedialog.MessageDialog({namespace: portletId+'_tsErrMsg', message: this.nls.MSGDIALOG_GAUGES_INVALID_RANGE});
				msgDialog.show();
				return false;
			}
			if((majorTicks && (maxValue-minValue)/majorTicks > 100) || (minorTicks && (maxValue-minValue)/minorTicks > 100)) {
				var msgDialog = new dojoe.messagedialog.MessageDialog({namespace: portletId+'_tsErrMsg', message: this.nls.MSGDIALOG_GAUGES_TICKS_INVALID_PARAMS});
				msgDialog.show();
				return false;
			}
			if(this._gaugeName == "VolumeBar" || this._gaugeName == "AnalogGauge") {
				for(var index in allThresholds) {
					if(allThresholds[index] > maxValue || allThresholds[index] < minValue) {
						var msgDialog = new dojoe.messagedialog.MessageDialog({namespace: portletId+'_tsErrMsg', message: this.nls.MSGDIALOG_GAUGES_GREATER_THAN_MAX});
						msgDialog.show();
						return false;
					}
				}
			}
			return true;
		},
		
		destroy: function () {
			if(this.optionsGridNode){
				if(this.optionsGridNode.destroyRecursive) 
					this.optionsGridNode.destroyRecursive();
				else if (this.optionsGridNode.destroy) 
					this.optionsGridNode.destroy();
			}
			this.inherited(arguments);		
		}		
	});
});
