/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/ssd/utils/RichHoverHelper", [
   "dojo/_base/declare",
   "ibm/tivoli/tip/richhover/RichHoverUrlInfo",
   "ibm/tivoli/tip/richhover/HoverListener",
   "ibm/tivoli/tip/richhover/RichHoverTooltip"
], function (declare, RichHoverUrlInfo, HoverListener, RichHoverTooltip) {
	return declare("dojoe.ssd.utils.RichHoverHelper", null, {
		portletNamespace: null,
		_myHoverDlg:null,
		_onMouseOutHandle:null,
		
		constructor: function (portletNamespace) {
			this.portletNamespace = portletNamespace;
		},
		
		displayRichHover: function(nodeid, urls, resRegistry, xcord, ycord)
		{
			if(this._onMouseOutHandle)
				dojo.disconnect(this._onMouseOutHandle);
			this._onMouseOutHandle = dojo.connect(dojo.byId(nodeid), "onmouseleave", dojo.hitch(this, this.onMouseoutCallback));
			if(resRegistry) {
				 var info = new ibm.tivoli.tip.richhover.RichHoverUrlInfo({
					urls : urls, 
					curiUrl : "/ibm/tivoli/rest",
					registryDomain:resRegistry,
					myNodeId: nodeid
				 });
			} else {
				var info = new ibm.tivoli.tip.richhover.RichHoverUrlInfo({
					urls : urls, 
					curiUrl : "/ibm/tivoli/rest",
					myNodeId: nodeid
				 });
			}
			this._hoverTimer = setTimeout(dojo.hitch(this,this.myHoverCallback, info, xcord, ycord), 3000);
		},
		  
		myHoverCallback: function(info, xcord, ycord)
		{
			 info.load(dojo.hitch(this, this.myLoadCallback, info, xcord, ycord));
		},
  
		myLoadCallback: function(info, xcord, ycord)
		{
			if (this._myHoverDlg != null)
				this._myHoverDlg.destroy();
			this._myHoverDlg = new ibm.tivoli.tip.richhover.RichHoverTooltip({
			  title: "",
			  aroundNode: dojo.byId(info.myNodeId),
			  contentIsolation: true,
			  namespace: this.portletNamespace,
			  xcord:xcord,
			  ycord:ycord
			});
			  
			this._myHoverDlg.setHoverUrlInfo(info);
			this._myHoverDlg.showHover();
		},
		
		onMouseoutCallback:function()
		{
			clearTimeout(this._hoverTimer);
			dojo.disconnect(this._onMouseOutHandle);
		}
	  
	});
});