/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("dojoe/tablelayout/TableLayout", [
	"dojo/_base/declare",
	"dijit/registry",	// registry.getEnclosingWidget
	"dijit/_Contained",
	"dijit/_Container",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dojoe/tablelayout/RowLayout"
], function(declare, registry, _Contained, _Container, _WidgetBase, _TemplatedMixin, RowLayout){
	return declare("dojoe.tablelayout.TableLayout", [_WidgetBase, _Container, _Contained, _TemplatedMixin],{
    
		// visible row fields
		cells : '',

		// where to look for template
		templateString:"<div class=\"tablelayout\">\n  <table dojoAttachPoint=\"_rowsNode\" class=\"rows\">\n  <!-- This code is commented because\n        items will be created at runtime.\n  <div class=\"row\">\n    ...\n  </div>\n  -->\n </table> \n</div>\n",
		rowTemplatePath : dojo.moduleUrl("dojoe.tablelayout","templates/RowLayout.html"),
		emptyRowTemplatePath : dojo.moduleUrl("dojoe.tablelayout","templates/EmptyRowLayout.html"),
		
		items: {},

		// postCreate is a predefined event
		// handler that is executed when widget
		// is created and initialized
		postCreate : function () {
		  this.fetch();
		},
	  
		fetch : function () {
			console.info("TableLayout: fetch() - BEGIN");
			console.dir(this.items);
			if(this.items && this.items.length>0){		
				dojo.empty(this._rowsNode);		
				console.info("Found items, length:"+this.items.length);
				var rowLayout;
				for(var i=0;i<this.items.length;i++){
					rowLayout = new RowLayout({item: this.items[i], templatePath:this.rowTemplatePath});
					//console.dir(rowLayout);
					this._rowsNode.appendChild(rowLayout.domNode);
				}	
			}else{
				//console.warn("TableLayout: fetch(): No items found!");
				dojo.empty(this._rowsNode);
				var rowLayout = new RowLayout({item: {row_value: 'None'}, templatePath:this.emptyRowTemplatePath});
				this._rowsNode.appendChild(rowLayout.domNode);
			}	
			console.info("TableLayout: fetch() - END");
		},
		
		destroy: function () {					
			this.inherited(arguments);		
		}				
	});
});		

