// wrapped by build app
define("dojoe/tablex/_ConfigureColumnsDialog", ["dijit","dojo","dojox","dojo/i18n!dojoe/tablex/nls/Table","dojo/require!dijit/_WidgetBase,dijit/_TemplatedMixin,dijit/_WidgetsInTemplateMixin,dijit/Dialog,dijit/form/Button,dijit/layout/LayoutContainer,dojoe/tablex/_TableOptions,dojo/i18n"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("dojoe.tablex._ConfigureColumnsDialog");

dojo.require("dijit._WidgetBase");
dojo.require("dijit._TemplatedMixin");
dojo.require("dijit._WidgetsInTemplateMixin");
dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");
dojo.require("dijit.layout.LayoutContainer");
dojo.require("dojoe.tablex._TableOptions");
dojo.require("dojo.i18n");

// NLS
dojo.requireLocalization("dojoe.tablex", "Table");
// define the widget class
dojo.declare ("dojoe.tablex._ConfigureColumnsDialog", [ dijit._WidgetBase, dijit._TemplatedMixin, dijit._WidgetsInTemplateMixin ],{

		// summary:
		//		Private class - Configure Columns Dialog
		
		//widgetsInTemplate: true,
		// Path to the template
		templateString : dojo.cache("dojoe.tablex", "templates/ConfigureColumnsDialog.html", "\n<div>\n  <div dojoType=\"dijit.Dialog\" dojoAttachPoint=\"dialog\"\ttitle=\"${resources_.CONFIGURE_SETTINGS}\" tabindex=0 role=\"dialog\" style=\"width:350px;height:auto;overflow:auto;\" >\n\t\t<table class=\"dijitDialogPaneContentArea\" role=\"presentation\">\n\t\t\t<tr><td>\n\t\t\t\t<div  style=\"width:100%;height:100%;overflow:auto;\" class=\"tivTable\">\n\t\t\t\t\t<label>${resources_.COLUMNS_VISIBLE}</label>\t\t\n\t\t\t\t\t \t\n\t                  <table border=\"0\" cellspacing=\"7\" cellpadding=\"0\" role=\"presentation\">\n\t\t\t\t\t\t<tbody>\n\t\t\t\t\t\t\t<tr>\t\t\t\t\t\t\n\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t<span dojoAttachPoint=\"selectAllButton\" role=\"button\">\n\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t\t<td>\n\t\t\t\t\t\t\t\t\t<span dojoAttachPoint=\"deselectAllButton\" role=\"button\">\n\t\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t</tbody>\n\t\t\t\t\t</table>\n\t\t\t\t</div>\n\t\t\t</td></tr>\n\t\t\t<tr><td>\t\t\n\t\t\t\t<div tabStrip=\"false\" id=\"${id}tabs\" dojoType=\"dijit.layout.LayoutContainer\"  class=\"dialog\" style=\"vertical-align:top;width:315px;height:110px;overflow-x:hidden;overflow-y:auto;padding:2px 0px 0px 10px;\">\n\t\t\t\t\t<div id=\"${id}columnsVisibleDivContainer\"></div>\n\t\t\t\t</div>\n\t\t\t</td></tr>\n\t\t</table>\t\n\t\t<div class=\"dijitDialogPaneActionBar\">\t\t\n\t\t\t<button value=\"${resources_.OK}\" dojoType=\"dijit.form.Button\" role=\"button\"\n\t\t\t\tdojoAttachEvent=\"onClick:onOK,onKeypress:onOK\">${resources_.OK}</button>&nbsp;\n\t\t\t<button value=\"${resources_.CANCEL}\" dojoType=\"dijit.form.Button\" role=\"button\"\n\t\t\tdojoAttachPoint=\"cancelButton\" dojoAttachEvent=\"onClick:onCancel,onKeypress:onCancel\">${resources_.CANCEL}</button>\t\n\t\t</div>\n  </div>\n</div>\n"),		
		optionsWidget_: null,
		_structure: null,
		_table: null,
		constructor: function() {
			this.resources_ = dojo.i18n.getLocalization("dojoe.tablex", "Table", this.lang);
		},		
		postCreate: function() { 
			this.inherited ("postCreate", arguments);
			/* 42703: TableView: Configure Options settings are not saved after refresh
			 * use table id instead of grid id to persist the grid options*/
			this.optionsWidget_=new dojoe.tablex._TableOptions({
				grid: this.grid, _structure: this._structure, _table: this._table 
			}, dojo.byId(this.id + "columnsVisibleDivContainer"));
			this.optionsWidget_.startup();	

			var selectIcon = new dijit.form.Button({
				id: this.id+"selectAllIcon",
				showLabel: false,
				iconClass: "selectAllIcon",
				label: this.resources_.SELECT_ALL
			},this.selectAllButton);
				
			selectIcon.onClick = dojo.hitch (this, "onSelectAll");
			selectIcon.onKeypress = dojo.hitch (this, "onSelectAll");		
			
			var deSelectIcon = new dijit.form.Button({
				id: this.id+"deselectAllIcon",
				showLabel: false,
				iconClass: "deselectAllIcon",
				label: this.resources_.DESELECT_ALL
			},this.deselectAllButton);
				
			deSelectIcon.onClick = dojo.hitch (this, "onDeselectAll");
			deSelectIcon.onKeypress = dojo.hitch (this, "onDeselectAll");
						
		},		
		onSelectAll: function(){		
			this.optionsWidget_.onSelectAll();
		},		
		onDeselectAll: function(){		
			this.optionsWidget_.onDeselectAll();
		},		
		onOK: function () {
			/*Ls - 17/01/2012 - 30956 - showing cursor busy when saving the column configuration*/
			//53457: Icon not changed when we hover between 2 columns on TableView for resizing columns
			//Bobby: 08Nov2012, element style can't be later changed via CSS
			//window.document.body.style.cursor = 'wait';
			dojo.addClass(dojo.body(), 'waitCursor');
			this.optionsWidget_.onSave();
			this.hide();
			//window.document.body.style.cursor = 'default';
			dojo.removeClass(dojo.body(), 'waitCursor');
		},		
		onCancel: function () {
			this.hide();
		},		
		show: function () {
			this.dialog.show();
			dijit.byId (this.id + "tabs").resize();
		},		
		hide: function () {
			this.dialog.hide();
			setTimeout (dojo.hitch (this, this.kill), 100);
		},		
		kill: function () {
			var id = this.id;
			this.destroyRecursive();
			dijit.registry.remove (id);
		},		
		getTableOptions: function () {
			return this.optionsWidget_;
		},
		destroy: function () {
			//memory leak issue: custom destroy method to take care of removing all widgets					
			try{
				delete this.resources_;
				//this is for destroying child templated widgets 
				//this should happen by itself but need to figure out why dijit._Templated is not taking care of it...
				var widgets = dijit.findWidgets(this.domNode);
				dojo.forEach(widgets, function(w) {
					if(w){
						if(w.destroyRecursive){
							w.destroyRecursive();
						} else if(w.destroy){
							w.destroy();
						}
					}
				});
				// this is for widgets added as child to this widget and their children..
				//not present in template
				var widgetArr = this.getChildren();
				dojo.forEach(widgetArr, function (child) {
					if(child){
						if(child.destroyRecursive){
							child.destroyRecursive();
						} else if(child.destroy){
							child.destroy();
						}
					}
				});
				this.inherited(arguments);
			}catch(ex){
				console.warn("Widget destroy failed: "+this.id+", ex="+ex.name+":"+ex.message);
			}
		}
	}
);
});
