require({cache:{
'url:dojoe/timeselector/templates/TimeSelectorButton.html':"<div data-dojo-attach-point=\"containerNode\">\n\t<div data-dojo-attach-point=\"selectorButtonNode\">\n\t</div>\n</div>"}});
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
/******************************************************* {COPYRIGHT-TOP-RM} ***
* Licensed Materials - Property of IBM
*
* "Restricted Materials of IBM"
*
* 5724-C51
* (C) Copyright IBM Corp. 2010 All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
******************************************************* {COPYRIGHT-END-RM} ***/

define("dojoe/timeselector/TimeSelectorButton",[
        "dojo/_base/lang",
        "dojo/_base/declare",
        "dijit/_WidgetBase",
        "dijit/_TemplatedMixin",
        "dijit/Menu",
        "dijit/MenuItem",
        "dijit/MenuSeparator",
        "dijit/form/DropDownButton",
        "dojoe/timeselector/ViewDialog",
        "dojo/i18n!dojoe/timeselector/nls/Common",
        "dojo/i18n!dojoe/timeselector/nls/Messages",
		"dojoe/BidiUtil",
        "dojo/text!dojoe/timeselector/templates/TimeSelectorButton.html"
        ], function(lang, declare, _WidgetBase, _TemplatedMixin, Menu, MenuItem, MenuSeparator, DropDownButton, ViewDialog,Common, Messages, bidiUtil, template){
		return declare("dojoe.timeselector.TimeSelectorButton", [_WidgetBase, _TemplatedMixin], {
		
		templateString: template,
		//templatePath: require.toUrl("dojoe/timeselector/templates/TimeSelectorButton.html"),
		
		_viewDialog: null,
		_displayText: null,
		_realtimeValues: null,
		_selectorButton: null,
		uniqueId: null,
		calendar: null,
		_recalc: false,
		
		constructor: function(args) {
            //var dArgs = !!args? {_uId: args._uId, dir: args.dir, calendar: args.calendar, _recalc: args._recalc} : {};
            var dArgs = lang.clone(args); // we want all the args for ViewDialog.
            delete dArgs.id; // remove id to avoid conflict in ViewDialog.
		   this._viewDialog = new ViewDialog(dArgs);
		   this._viewDialog.startup();
		   this._initLocalization();
		   this._initRealtimeValues();
		   
		   this.uniqueId = args._uId;
		   this._selectorButton =   "_selectorButton_"+this.uniqueId;
		},
		
		_initLocalization: function() {
            this._realtimeText = Common.REAL_TIME;
            this._minuteText = Common.MINUTES;
            this._hourText = Common.HOURS;
            this._dayText = Common.DAYS;
            this._weekText = Common.WEEKS;
            this._monthText = Common.MONTHS;
            this._quarterText = Common.QUARTERS;
            this._yearText = Common.YEARS;
            this._custom = Common.CUSTOM;
	  },
	  
	  /*
	   * init default value range data
	   */
	  _initRealtimeValues: function(){
	  	this._realtimeValues = new Array();
	  	this._realtimeValues.push({value:2,unit:"hour"});
	  	this._realtimeValues.push({value:4,unit:"hour"});
	  	this._realtimeValues.push({value:8,unit:"hour"});
	  	this._realtimeValues.push({value:12,unit:"hour"});
	  	this._realtimeValues.push({value:1,unit:"day"});
	  	this._realtimeValues.push({value:1,unit:"week"});
	  	this._realtimeValues.push({value:1,unit:"month"});
	  	this._realtimeValues.push({value:3,unit:"month"});
	  	this._realtimeValues.push({value:6,unit:"month"});
	  	this._realtimeValues.push({value:9,unit:"month"});
	  	this._realtimeValues.push({value:12,unit:"month"});
	  },
		
		postCreate: function(){
			
            var timeSelectorList = new Menu({
                dir : this.dir
            });
			//realtime only item
			var realtimeItem = new MenuItem({
				label: bidiUtil.getFormattedText(this._realtimeText,"auto","ltr"),
				onClick: lang.hitch(this, function() {
					this._selectOnlyRealTime();
				}),
				dir: this.dir
			});
			
			timeSelectorList.addChild(realtimeItem);
			timeSelectorList.addChild(new MenuSeparator());
			//realtime plus time item
			var realTimeValueItem = null;
			for(var i=0;i<this._realtimeValues.length;i++){
				realTimeValueItem = this._realtimeValues[i];
				timeSelectorList.addChild(this._createPlusRealTimeItem(realTimeValueItem));
				timeSelectorList.addChild(new MenuSeparator());
			}
			
			//custom item
			var customItem = new MenuItem({
				label: bidiUtil.getFormattedText(this._custom + '<b> . . . <b>',"auto","ltr"),
				onClick: lang.hitch(this, function() {
					this._selectCustomTime();
				}),
				dir: this.dir
			});
			timeSelectorList.addChild(customItem);
			
			var params = {
	            label: this._displayText,
	            dropDown: timeSelectorList,
	            dir: this.dir
	        };
			
			this._selectorButton = new DropDownButton(params,this.selectorButtonNode);
			this._selectorButton.startup();
	        if (this._recalc){
	        	this._viewDialog.setSelButton(this._selectorButton);
	        	this._viewDialog.onOkClicked();		        	
	        }

		},
		
		/**
		 * button display text
		 */
		setDisplayText: function(text){
            this._selectorButton.set("label", text);
		},
		
		_createPlusRealTimeItem: function(item){
			var value = item.value;
			var unit = item.unit;
			var labelText = value + " " + this._getUnitText(unit);
			var plusRealtimeItem = new dijit.MenuItem({
				label: bidiUtil.getFormattedText(labelText,"auto","ltr"),
				onClick: lang.hitch(this, function() {
					this._selectPlusRealTime(value, unit);
				}),
				dir: this.dir
			});
			return plusRealtimeItem;
		},
		
		_getUnitText: function(id){
			if(id=="hour"){
				return this._hourText;
	      	} else if(id=="day"){
	      		return this._dayText;
	      	} else if(id=="week"){
	      		return this._weekText;
	      	} else if(id=="month"){
	      		return this._monthText;
	      	} else{
	      		return null;
	      	}
		},
		
		_selectOnlyRealTime: function(){
			this._viewDialog.setSelButton(this._selectorButton);
			this._viewDialog.selectRealTime();
		},
		
		_selectPlusRealTime: function(value,unit){
			this._viewDialog.setSelButton(this._selectorButton);
			this._viewDialog.selectPlusRealTime(value,unit);
		},
		
		_selectCustomTime: function(){
			this._viewDialog.setSelButton(this._selectorButton);
			this._viewDialog.show();
			this._viewDialog.startup();
		}
	});
});
