// wrapped by build app
define("dojoe/treetable/_Toolbar", ["dijit","dojo","dojox","dojo/i18n!dojoe/treetable/nls/TreeTable","dojo/require!dojoe/common/toolbar/_Toolbar,dijit/form/Button,dijit/ToolbarSeparator,dijit/form/DropDownButton,dijit/Menu,dojo/i18n,dojoe/treetable/_ConfigureColumnsDialog,dojoe/treetable/_QuickSearchFilter"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
// dojo.provide allows pages to use all of the types declared in this resource.
dojo.provide("dojoe.treetable._Toolbar");

//dojo.require("dijit.Toolbar");
dojo.require("dojoe.common.toolbar._Toolbar");
dojo.require("dijit.form.Button");
dojo.require("dijit.ToolbarSeparator");
dojo.require("dijit.form.DropDownButton");
dojo.require("dijit.Menu");
dojo.require("dojo.i18n");
dojo.require("dojoe.treetable._ConfigureColumnsDialog");
dojo.require("dojoe.treetable._QuickSearchFilter");

dojo.requireLocalization("dojoe.treetable", "TreeTable");

dojo.declare("dojoe.treetable._Toolbar", [ dojoe.common.toolbar._Toolbar], {	
	
		// summary: 
		//		A private class to create tree table toolbar with icons, action lists and fitler options
		// description: 
		//		This is based on a common toolbar widget which supports both table and tree table widgets.
		//		This class is internally used to enable/disable toolbar icons, actions and search controls in the tree table
		//		Please refer dojoe.treetable.TreeTable.toolbarOptions property.
		// tags: private
		
		// widgetsInTemplate: boolean
		//		to indicate widgets in template
		widgetsInTemplate:true,
		//toolbar:null,
		
		// treeTable: object
		//		Reference to tree table instance
		treeTable:null,
		
		// actionListWidget: object
		//		Reference to Action List menu in toolbar
		actionListWidget:null,
		
		// quickFilter: object
		//		Reference to quick filter widget in the toolbar
		quickFilter:null,
		
		// filterOptions: object
		//		filter options to set to quick filter
		filterOptions: null,
		
		// refreshIcon: boolean
		//		To enable/disable refresh icon on toolbar, defaults to true
		refreshIcon:true,
		
		// refreshMenu: boolean
		//		To enable/disable refresh menu item in the action list 
		refreshMenu:true,
		
		// showSelectAllIcon: boolean
		//		to enable/disable select All icon in the toolbar
		showSelectAllIcon:true,
		
		// onlySelectAllIcon: boolean
		//		To provide a option to use only select All without de-select All option
		onlySelectAllIcon:false,
		
		// onlyDeselectAllIcon: boolean
		//		To provide a option to use only de-select All without select All option	
		onlyDeselectAllIcon:false,
		
		// expandAllIcon: boolean
		//		to indicate the state of items expand/collapse when the tree table loads
		expandAllIcon: true,
		
		// clearSortIcon: boolean
		//		To enable/disable clear sort icon on the toolbar, defaults to true
		clearSortIcon: true,
		
		// configureTreeTableIcon: boolean
		//		To enable/disable Configure options in the toolbar, defaults to true
		configureTreeTableIcon:true,
		
		// actionMenu: boolean
		//		To enable/disable Action list in the toolbar, defaults to true
		actionMenu:true,
		
		// selectAllMenu: boolean
		//		To enable/disable select All menu item in the Action list, defaults to true
		selectAllMenu: true,
		
		// expandAllMenu: boolean
		//		To enable/disable expandAll menu item in Action list, defaults to true
		expandAllMenu : true,
		
		// clearSortMenu: boolean
		//		To enable/disable clear sort menu item in Action list, defaults to true
		clearSortMenu: true,
		
		// configureTreeTableMenu: boolean
		//		To enable/disable configure options menu item in Action list, defaults to true
		configureTreeTableMenu:true,
		
		// toolbarOptions: object
		//		local variable which holds the tree table toolbarOptions values 
		toolbarOptions : null,
		
		// quickFilterVisible: boolean
		//		To enable/disable quick search filter on the toolbar, defaults to true
		quickFilterVisible : true,
		
		// quickFilterVisible: boolean
		//		To enable/disable quick filter button on the toolbar, defaults to false
		showQuickFilterButton: false,		
	
		_mapToolbarControls : function() {
			// summary: 
			//		Internal function to map toolbar options from dojoe.treetable.TreeTable to properties of this class
	
			if(this.toolbarOptions) {
				if(this.toolbarOptions.refreshIcon == false){
					this.refreshIcon = this.toolbarOptions.refreshIcon;
				}
				//23789: Refresh should be part of Actions Menu also - OID
				//Bobby:29Jun11
				if(this.toolbarOptions.refreshMenu == false){
					this.refreshMenu = this.toolbarOptions.refreshMenu;
				}				
				if(this.toolbarOptions.selectAllIcon == false){
					this.showSelectAllIcon = this.toolbarOptions.selectAllIcon;
					
				}else{
					if(this.toolbarOptions.onlySelectAllIcon == true){
						this.onlySelectAllIcon=this.toolbarOptions.onlySelectAllIcon;
					}
					if(this.toolbarOptions.onlyDeselectAllIcon == true){
						this.onlyDeselectAllIcon=this.toolbarOptions.onlyDeselectAllIcon;
					}
				}
				if(this.toolbarOptions.selectAllMenu == false){
					this.selectAllMenu = this.toolbarOptions.selectAllMenu;
				}				
				//Only collapseAll is supported in TED 1.1 and TED 1.0.
				if(this.toolbarOptions.expandAllIcon == false){
					this.expandAllIcon = this.toolbarOptions.expandAllIcon;
				}
				if(this.toolbarOptions.expandAllMenu == false){
					this.expandAllMenu = this.toolbarOptions.expandAllMenu;
				}
				
				if(this.toolbarOptions.clearSortIcon == false){
					this.clearSortIcon = this.toolbarOptions.clearSortIcon;
				}
				if(this.toolbarOptions.clearSortMenu == false){
					this.clearSortMenu = this.toolbarOptions.clearSortMenu;
				}
				if(this.toolbarOptions.configureTreeTableIcon == false) 
				{
					this.configureTreeTableIcon = this.toolbarOptions.configureTreeTableIcon;
				}
				if(this.toolbarOptions.configureTreeTableMenu == false){
					this.configureTreeTableMenu = this.toolbarOptions.configureTreeTableMenu;
				}
				if(this.toolbarOptions.actionMenu == false){
					this.actionMenu = this.toolbarOptions.actionMenu;
				}				
				//Keep for backward compatibility?
				//console.log('_mapToolbarControls: this.toolbarOptions.quickFilterVisible:'+this.toolbarOptions.quickFilterVisible);
				if(this.toolbarOptions.quickFilterVisible == false){
					this.quickFilterVisible = this.toolbarOptions.quickFilterVisible;
				}	
				//LS- 26/10/2011 - # 30377 - Treetable - incorrect results when setting filter or sorting while data is being loaded
				//this was missed in mapping
				if(this.toolbarOptions.quickFilterVisible && this.toolbarOptions.showQuickFilterButton){
					this.showQuickFilterButton = this.toolbarOptions.showQuickFilterButton;
				}
				//console.log('_mapToolbarControls: this.quickFilterVisible:'+this.quickFilterVisible);				
			}			
		},
		
		// Place comma-separated class attributes here. Note, instance attributes 
		// should be initialized in the constructor. Variables initialized here
		// will be treated as 'static' class variables.

		// Constructor function. Called when instance of this class is created
		constructor : function() {
			// summary:
			//		constructor
			this.resources_ = dojo.i18n.getLocalization("dojoe.treetable", "TreeTable", this.lang);	
		},
		
		_refreshTreeTable: function(){
			// summary:
			//		Internal function to invoke tree table refresh
			
			/*LA - 09/01/2012 - TWL - 16212- TreeTable CURI refresh not clearing cache*/
			//setting forceRefresh true to clear the LTG cache so that data from stores is reloaded...
			this.treeTable.refresh(true);
		},
		
		_selectAll: function () 
		{
			// summary:
			//		Internal function to select all the rows in the tree table, provided Indirect Selection is enabled
			
			if(this.treeTable.indirectSelection === true){
				//moving this to indirect selection class
				this.treeTable._loadIndSelection.selectAllRows();
			}else{
				var count = this.treeTable.grid.rowCount;
				for (var i=0; i<count; i++) {
					this.treeTable.grid.selection.addToSelection(i);
				}
			}
		},
		
		_deselectAll: function () 
		{
			// summary:
			//		Internal function to deselect all the rows in the tree table, provided Indirect selection is enabled
			
			if(this.treeTable.indirectSelection === true){
				this.treeTable._loadIndSelection.deSelectAllRows();
			}else{
				this.treeTable.grid.selection.deselectAll();
			}			
		},
		
		/* Not supported in the base widget, dojo LazyTreeGrid.
		_expandAll : function(){
			this.treeTable.grid.foldingAll(true);
		},
		*/
		_collapseAll : function()
		{
			// summary:
			//		Internal function to collapse all the parent items in the tree
			
			//this.treeTable.grid.foldingAll(false);
			//Satanik:07Jun2011: changing the collapse all
			this.treeTable.grid._cleanup();
			/*Lakshmi - 15/07/2011 - 21173 - In Treetable, Collapse all is not working */
			//normal grid refresh solves this issue and even is suffice
			this.treeTable.grid._refresh(true);
		},
		
		_clearSort : function()
		{
			// summary:
			//		Internal function to clear sorting applied to all the columns
			
			//LS - 21/10/2011 - #30979 - Clear sort does not work for treetable
			//since LTG refresh has changed adding cleanup before clear sort to make sure the applied sort is cleared.
			this.treeTable.grid._cleanup();
			this.treeTable.grid.setSortInfo(0);
			this.treeTable.grid._refresh(true);
		},
		
		_configureColumn : function()
		{ 
			// summary:
			//		Internal function to show configure options dialog, which provides ability to show/hide columns in the tree table
			
		    //Satanik:25May2011: changes made to address ILMT requiremnt 19890
			this.tableOptionsDialog = new dojoe.treetable._ConfigureColumnsDialog ({ grid:this.treeTable.grid,indirectSelection:this.treeTable.indirectSelection,enableColumnReorder:this.treeTable.enableColumnReorder});
			this.tableOptionsDialog.show();
		},
		
		postCreate:function(){
			// summary:
			//		To handle stuff when the toolbar is rendered
			// tags: extension
			
			//this.inherited(arguments);
			//22694: Hiding the quickfilter in TreeTable toolbar doesn't work - Bjørn Stadheim
			//Bobby: 22Jun2011, correcting the validation below, undefined doesn't need quotes too.
			//Also changing filterOptions.quickFilter -> filterOptions.showQuickFilter to be consistent with Table
			if(this.filterOptions && this.filterOptions.showQuickFilter !== undefined){
				this.quickFilterVisible = this.filterOptions.showQuickFilter;
			}	
			if(this.filterOptions && this.filterOptions.showQuickFilterButton !== undefined){
				this.showQuickFilterButton = this.filterOptions.showQuickFilterButton;
			}			
			//console.log("postCreate: this.quickFilterVisible:"+this.quickFilterVisible);
			
			//commenting as this not required
			//this.toolbar = new dijit.Toolbar({id: "toolbar"+this.id});
			this.toolbarOptions = this.treeTable.toolbarOptions;
			this._mapToolbarControls();
			this._createToolBarControls();			
		},
		
		//16716: table toolbar has browser popup menu on right click
		_stopEvent: function(e){
			// summary:
			//		to stop event propagation
			
			//Since event is oncontextmenu, just stop it!
			dojo.stopEvent(e);				
		},
		
		_createToolBarControls: function(){
			// summary:
			//		Internal function specific to tree table used to create required toolbar options/controls
			
			if(this.refreshIcon) {
				var refreshTableIcon = new dijit.form.Button({
					id: this.id+"refreshIcon",
					showLabel: false,
					iconClass: "refreshIcon",
					label: this.resources_.REFRESH
				});
					
				refreshTableIcon.onClick = dojo.hitch (this, "_refreshTreeTable");
				refreshTableIcon.onKeypress = dojo.hitch (this, "_refreshTreeTable");
				var seperator = new dijit.ToolbarSeparator({id: "refSeperator"+this.id});
				
				this._addStateControl(refreshTableIcon,0);
				this._addStateControl(seperator);
				
				
			}
			if(this.showSelectAllIcon) {	
				//Satanik:25May2011: changes made to address ILMT requiremnt of showing only select all or deselect all icon
				if(this.onlySelectAllIcon){
					var selectAllIcon = new dijit.form.Button({
						id: this.id+"selectAllIcon",
						showLabel: false,
						iconClass: "selectAllIcon",
						label: this.resources_.SELECT_ALL
					});
						
					selectAllIcon.onClick = dojo.hitch (this, "_selectAll");
					selectAllIcon.onKeypress = dojo.hitch (this, "_selectAll");
					
					this._addFastPathControl(selectAllIcon);
					
					
				}else if(this.onlyDeselectAllIcon){
					var deselectAllIcon = new dijit.form.Button({
						id: this.id+"deselectAllIcon",
						showLabel: false,
						iconClass: "deselectAllIcon",
						label: this.resources_.DESELECT_ALL
					});
						
					deselectAllIcon.onClick = dojo.hitch (this, "_deselectAll");
					deselectAllIcon.onKeypress = dojo.hitch (this, "_deselectAll");
					
					this._addFastPathControl(deselectAllIcon);
				}else {
					var selectAllIcon = new dijit.form.Button({
						id: this.id+"selectAllIcon",
						showLabel: false,
						iconClass: "selectAllIcon",
						label: this.resources_.SELECT_ALL
					});
						
					selectAllIcon.onClick = dojo.hitch (this, "_selectAll");
					selectAllIcon.onKeypress = dojo.hitch (this, "_selectAll");
					
					this._addFastPathControl(selectAllIcon);
					
					var deselectAllIcon = new dijit.form.Button({
						id: this.id+"deselectAllIcon",
						showLabel: false,
						iconClass: "deselectAllIcon",
						label: this.resources_.DESELECT_ALL
					});
						
					deselectAllIcon.onClick = dojo.hitch (this, "_deselectAll");
					deselectAllIcon.onKeypress = dojo.hitch (this, "_deselectAll");
					this._addFastPathControl(deselectAllIcon);
				}
			}
			
			
			if(this.expandAllIcon) {
				/* Not supported in the base widget, dojo LazyTreeGrid
				var expandtAllIcon = new dijit.form.Button({
						id: this.id+"expandableAllIcon",
						showLabel: false,
						iconClass: "expandtAllIcon",
						label: this.resources_.EXPAND_ALL
					},this.expandtAllIcon);
					
				expandtAllIcon.onClick = dojo.hitch (this, "_expandAll");
				expandtAllIcon.onKeypress = dojo.hitch (this, "_expandAll");*/
				
				var collapseAllIcon = new dijit.form.Button({
					id: this.id+"collapseAllIcon",
					showLabel: false,
					iconClass: "collapseAllIcon",
					label: this.resources_.COLLAPSE_ALL
				});				
				//Bobby:18Mar2011. Workaround for now since refresh collapses the grid!	
				//Satanik:07Jun2011: ORIA fixed the refresh code so it does not collapse the grid so calling different api
				collapseAllIcon.onClick = dojo.hitch (this, "_collapseAll");
				collapseAllIcon.onKeypress = dojo.hitch (this, "_collapseAll");			
				this._addFastPathControl(collapseAllIcon);
				//collapseAllIcon.onClick = dojo.hitch (this, "_refreshTreeTable");
				//collapseAllIcon.onKeypress = dojo.hitch (this, "_refreshTreeTable");
			}
					
				
			if(this.clearSortIcon) {
				var removeSortIcon = new dijit.form.Button({
					id: this.id+"clearSortIcon",
					showLabel: false,
					iconClass: "removeSortIcon",
					label: this.resources_.CLEAR_SORT
				});
					
				removeSortIcon.onClick = dojo.hitch (this, "_clearSort");
				removeSortIcon.onKeypress = dojo.hitch (this, "_clearSort");
				this._addFastPathControl(removeSortIcon);
			}
			
			if(this.configureTreeTableIcon) {
				var configureColIcon = new dijit.form.Button({
					id: this.id+"configureTreeTableIcon",
					showLabel: false,
					iconClass: "configureColIcon",
					label: this.resources_.CONFIGURE_TREETABLE
				});
					
				configureColIcon.onClick = dojo.hitch (this, "_configureColumn");
				configureColIcon.onKeypress = dojo.hitch (this, "_configureColumn");
				this._addFastPathControl(configureColIcon);
			}
					
			//console.log("this.quickFilterVisible:"+this.quickFilterVisible);
			
			if(this.quickFilterVisible && this.showQuickFilterButton) {
				this.quickFilter = new dojoe.treetable._QuickSearchFilter({
					id: this.id+"quickFilter", 
					grid: this.treeTable.grid,
					_quickFilterButton: true,
					filterOptions: this.filterOptions },this.quickFilterNode);	
				var quickFilterIcon = new dijit.form.Button({
					showLabel: false,
					iconClass: "filterIcon",
					id: "quickFilterIcon"+this.id,
					label: this.resources_.QUICK_FILTER,
					title: this.resources_.QUICK_FILTER
				},this.filterButton);				
				quickFilterIcon.onClick = dojo.hitch (this, "_setQuickFilter");
				quickFilterIcon.onKeypress = dojo.hitch (this, "_setQuickFilter");
				quickFilterIcon.domNode.title = this.resources_.QUICK_FILTER;	
			}else if(this.quickFilterVisible && !this.showQuickFilterButton) {
				this.quickFilter = new dojoe.treetable._QuickSearchFilter({
					id: this.id+"quickFilter", 
					grid: this.treeTable.grid,
					_quickFilterButton: false,
					filterOptions: this.filterOptions },this.quickFilterNode);				
			}
			
			if(this.actionMenu){
				var menu = new dijit.Menu({ style: "display: none;"});
				//menu.addChild(new dijit.MenuSeparator());
				
				//23789: Refresh should be part of Actions Menu also - OID
				//Bobby:29Jun11				
				if(this.refreshMenu) {
					//Menu Item for Configure Columns action
					var refreshMenuItem = new dijit.MenuItem({
						//Bobby:19Jul11, title is reqd by JAWS to anounce the menu item.					
						//24709: JAWS does not read the items in the Actions, Export or Print menus.					
						title: this.resources_.REFRESH,
						label: this.resources_.REFRESH,
						iconClass: "refreshIcon"
					});
					refreshMenuItem.onClick = dojo.hitch (this, "_refreshTreeTable");
					refreshMenuItem.onKeypress = dojo.hitch (this, "_refreshTreeTable");					 
					menu.addChild(refreshMenuItem);
				}				
				
				if(this.selectAllMenu){
					var selectAllMenuItem = new dijit.MenuItem({
						 //id: this.id+"selectAllMenuItem",
						 title: this.resources_.SELECT_ALL,
						 label: this.resources_.SELECT_ALL,
						 iconClass: "selectAllIcon"			         
					 });
					 selectAllMenuItem.onClick = dojo.hitch (this, "_selectAll");
					 selectAllMenuItem.onKeypress = dojo.hitch (this, "_selectAll");	
					 menu.addChild(selectAllMenuItem);
					
					 var deselectAllMenuItem = new dijit.MenuItem({
						 //id: this.id+"deselectAllMenuItem",
						 title: this.resources_.DESELECT_ALL,
						 label: this.resources_.DESELECT_ALL,
						 iconClass: "deselectAllIcon"
					  });
					 deselectAllMenuItem.onClick = dojo.hitch (this, "_deselectAll");
					 deselectAllMenuItem.onKeypress = dojo.hitch (this, "_deselectAll");
					 menu.addChild(deselectAllMenuItem);
				}
				
				if(this.expandAllMenu){
					/* Not supported in the base widget, dojo LazyTreeGrid
					var expandAllMenuItem = new dijit.MenuItem({
						 id: this.id+"expandAllMenuItem",
						 label: this.resources_.EXPAND_ALL,
						 iconClass: "expandtAllIcon"
					 });
					 expandAllMenuItem.onClick = dojo.hitch (this, "_expandAll");
					 expandAllMenuItem.onKeypress = dojo.hitch (this, "_expandAll");
					 menu.addChild(expandAllMenuItem);*/
					 
					 var collapseAllMenuItem = new dijit.MenuItem({
						 //id: this.id+"collapeAllMenuItem",
						 title: this.resources_.COLLAPSE_ALL,						 
						 label: this.resources_.COLLAPSE_ALL,
						 iconClass: "collapseAllIcon"
					 });
					 collapseAllMenuItem.onClick = dojo.hitch (this, "_collapseAll");
					 collapseAllMenuItem.onKeypress = dojo.hitch (this, "_collapseAll");
					 //collapseAllMenuItem.onClick = dojo.hitch (this, "_refreshTreeTable");
					 //collapseAllMenuItem.onKeypress = dojo.hitch (this, "_refreshTreeTable");					 
					 menu.addChild(collapseAllMenuItem);
				}
					
				if(this.clearSortMenu){
					 var clearSortMenuItem = new dijit.MenuItem({
						 //id: this.id+"clearSortMenuItem",
						 title: this.resources_.CLEAR_SORT,
						 label: this.resources_.CLEAR_SORT,
						 iconClass: "removeSortIcon"
					 });
					 clearSortMenuItem.onClick = dojo.hitch (this, "_clearSort");
					 clearSortMenuItem.onKeypress = dojo.hitch (this, "_clearSort");
					 menu.addChild(clearSortMenuItem);
				}
				
				if(this.configureTreeTableMenu){
					 var configureColMenuItem = new dijit.MenuItem({
						 //id: this.id+"configureColMenuItem",
						 title: this.resources_.CONFIGURE_TREETABLE,
						 label: this.resources_.CONFIGURE_TREETABLE,
						 iconClass: "configureColIcon"
					 });
					 configureColMenuItem.onClick = dojo.hitch (this, "_configureColumn");
					 configureColMenuItem.onKeypress = dojo.hitch (this, "_configureColumn");
					 menu.addChild(configureColMenuItem);
				}
				menu.startup();
				var actionList = new dijit.form.DropDownButton({
					optionsTitle : this.resources_.ACTIONS,
			        label: this.resources_.ACTIONS,
			        dropDown: menu,
					scrollOnFocus : true
			    });				
				this.actionListWidget = actionList;		
				this._addFastPathControl(actionList);	
			}
		},
		
		_setQuickFilter: function(){
			// summary:
			//		Internal function to set filter criteria for quick filter
			
			//console.info("In _setQuickFilter.....");
			//this.quickFilter.filterObj = this.filterOptions;
			this.quickFilter._setFilter();
		},		
		
		_removeFromActionList: function (menuItemId){
			// summary:
			//		Internal function invoked by dojoe.treetable.TreeTable to remove items form Action list on the toolbar
			
			var menuItem = dijit.byId(menuItemId);
			if(menuItem !== null && menuItem !== undefined) {
				menuItem.destroyRecursive();
			}
		},
		
		//do not call this method directly, use table.removeItemFromToolbar(itemId) method to remove a custom item from the toolbar
		_removeItem: function(itemId){
			// summary:
			//		Internal function invoked by dojoe.treetable.TreeTable to remove controls on the toolbar
			
			var button= dijit.byId(itemId);
			if(button !== null && button !== undefined) {		
				if (button.domNode.parentNode) {
					//remove td which is the parent of the button
					buttonParent = button.domNode.parentNode;
					buttonParent.parentNode.removeChild(buttonParent);
				}
				button.destroyRecursive();
			}
		},
		
		//do not call this method directly, use treetable.addToToolbar(item,position,row) method to add a custom item to the toolbar before default buttons
		_addCustomControl: function(item, position, row){
			// summary:
			//		Internal function invoked by dojoe.treetable.TreeTable to add custom buttons, actions to the toolbar
			
			this.inherited(arguments);
		},	

		destroy: function(){
			// summary:  Destroys the toolbar.
			// tags: public	
			
			//memory leak issue: custom destroy method to take care of removing all widgets					
			try{
				delete this.resources_;
				//this is for destroying child templated widgets 
				//this should happen by itself but need to figure out why dijit._Templated is not taking care of it...
				var widgets = dijit.findWidgets(this.domNode);
				dojo.forEach(widgets, function(w) {
					if(w){
						if(w.destroyRecursive){
							w.destroyRecursive();
						} else if(w.destroy){
							w.destroy();
						}
					}
				});
				// this is for widgets added as child to this widget and their children..
				//not present in template
				var widgetArr = this.getChildren();
				dojo.forEach(widgetArr, function (child) {
					if(child){
						if(child.destroyRecursive){
							child.destroyRecursive();
						} else if(child.destroy){
							child.destroy();
						}
					}
				});
				this.inherited(arguments);
			}catch(ex){
				console.warn("Widget destroy failed: "+this.id+", ex="+ex.name+":"+ex.message);
			}
		}		
	//Uncomment above comma and add comma-separated functions here. Do not leave a 
	// trailing comma after last element.			
});
});
