// wrapped by build app
define("ibm/tivoli/tip/dijit/tests/tivwizard_pages/SubstepFind", ["dijit","dojo","dojox","dojo/require!ibm/tivoli/tip/dijit/TivSubstep"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("ibm.tivoli.tip.dijit.tests.tivwizard_pages.SubstepFind");

dojo.require("ibm.tivoli.tip.dijit.TivSubstep");

dojo.declare("ibm.tivoli.tip.dijit.tests.tivwizard_pages.SubstepFind", [ibm.tivoli.tip.dijit.TivSubstep], 
{
  templateString:"<div class=\"substepfind\">\r\n  <div class=\"tiv-page-header\">\r\n    <h2>Find Item</h2>\r\n    <p>First substep in loop.  Make your selections and then press OK to go to the second substep.\r\n    To get out of the loop and go to Page 8, press the Next button.  To go to the previous page,\r\n    press the Cancel button.</p>\r\n    <h4>Find catalogs matching your search criteria</h4>\r\n  </div>\r\n  <div class=\"tiv-page-content\">\r\n    <table>\r\n      <tr>\r\n        <td>Search for:</td>\r\n        <td>\r\n          <select dojoAttachPoint=\"_itemType\">\r\n            <option value=\"0\">Business Cards</option>\r\n            <option value=\"1\">Flowers</option>\r\n            <option value=\"2\">Printers</option>\r\n          </select>\r\n        </td>\r\n      </tr>\r\n      <tr>\r\n        <td>Within:</td>\r\n        <td>\r\n          <select dojoAttachPoint=\"_catalog\">\r\n            <option value=\"0\">All catalogs</option>\r\n            <option value=\"1\" disabled>Office supply catalogs</option>\r\n            <option value=\"2\" disabled>Hardware catalogs</option>\r\n            <option value=\"3\" disabled>Miscellaneous catalogs</option>\r\n          </select>\r\n        </td>\r\n      </tr>\r\n      <tr>\r\n        <td>Price range:</td>\r\n        <td>\r\n          <select dojoAttachPoint=\"_priceRange\">\r\n            <option value=\"0\">Any</option>\r\n            <option value=\"1\" disabled>$0 - $20</option>\r\n            <option value=\"2\" disabled>$20 - $50</option>\r\n            <option value=\"3\" disabled>$50 - $100</option>\r\n            <option value=\"3\" disabled>&gt $200</option>\r\n          </select>\r\n        </td>\r\n      </tr>\r\n    </table>      \r\n    \r\n    <div style=\"margin-top:3em;\">        \r\n      <input type=\"button\" dojoAttachPoint=\"_okButton\" value=\"OK\" />\r\n      <input type=\"button\" dojoAttachPoint=\"_cancelButton\" value=\"Cancel\" />\r\n    </div>\r\n  </div>\r\n</div>\r\n",
  title: "Find Item",
  
  postCreate: function()
  {
    dojo.connect(this._okButton, "onclick", this, this.onOK);
    dojo.connect(this._cancelButton, "onclick", this, this.onCancel);
  },
  
  onOK: function()
  {
    // go to next step in loop
    this.visited = true;
    this.wizard.jumpToNextLoopStep();
  },
  
  onCancel: function()
  {
    // go to previous step in loop
    this.wizard.jumpToPreviousLoopStep();
  },
  
  reset: function()
  {
    this._itemType.selectedIndex = 0;
    this._catalog.selectedIndex = 0;
    this._priceRange.selectedIndex = 0;
  }
 
});

});
