// wrapped by build app
define("ibm/tivoli/tip/dijit/tests/tivwizard_pages/TestPage4", ["dijit","dojo","dojox","dojo/require!ibm/tivoli/tip/dijit/TivPage"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
dojo.provide("ibm.tivoli.tip.dijit.tests.tivwizard_pages.TestPage4");

dojo.require("ibm.tivoli.tip.dijit.TivPage");

dojo.declare("ibm.tivoli.tip.dijit.tests.tivwizard_pages.TestPage4", [ibm.tivoli.tip.dijit.TivPage], 
{
  templateString:"<div>\r\n  <div class=\"tiv-page-header\">\r\n    <h2>Page 4</h2>\r\n    <p>Watch the skip again</p>\r\n  </div>\r\n  <div class=\"tiv-page-content\">\r\n    <h4>Skip test</h4>\r\n    <input dojoAttachPoint=\"_skipper\" type=\"button\" value=\"Skip to next step\"></input>\r\n    <input dojoAttachPoint=\"_skipToNested\" type=\"button\" value=\"Skip to Nested Wizard Step\"></input>\r\n    <input dojoAttachPoint=\"_skipAhead\" type=\"button\" value=\"Skip to Summary\"></input>\r\n    <p>Skip way ahead also changes Finish button text</p>\r\n    <br />\r\n    <input dojoAttachPoint=\"_skipBack\" type=\"button\" value=\"Skip back\"></input>\r\n    <p>Skip back jumps back to Page 2</p>\r\n  </div>\r\n</div>\r\n",
  title: "Page 4",
  skipHandler: null,
  skipHandler2: null,

  postCreate: function()
  {
    console.log("TestPage4.postCreate");

    this.inherited(arguments);

    if (this.skipHandler == null)
    {
      this.skipHandler = dojo.connect(this._skipper, "onclick", this, this.doSkip);
      this.skipHandler2 = dojo.connect(this._skipToNested, "onclick", this, this.doSkip2Nested);
      this.skipHandler2 = dojo.connect(this._skipAhead, "onclick", this, this.doSkip2);
      this.skipHandler3 = dojo.connect(this._skipBack, "onclick", this, this.doSkip3);
    }
  },

  AfterPageSelected: function()
  {
    this.wizard.resetFinishLabel("Finish");
    this.wizard.enableFinishButton(true);
  },

  doSkip: function(event)
  {
    console.log("TestPage4.doSkip");

    this.wizard.skipToNextMainStep();
  },

  doSkip2Nested: function(event)
  {
    console.log("TestPage4.doSkip2Nested");

    var nestedWizStep = dojo.query(".wiz-nested-wizard-step", this.wizard.domNode);
    var wizPage = dijit.getEnclosingWidget(nestedWizStep[0]);

    this.wizard.markPreviousPagesVisited(wizPage);
    this.wizard.jumpBackToPage(wizPage);
  },
  
  doSkip2: function(event)
  {
    console.log("TestPage4.doSkip2");

    var nextToLast = dojo.query(".wiz-summary", this.wizard.domNode);
    var wizPage = dijit.getEnclosingWidget(nextToLast[0]);

    this.wizard.markPreviousPagesVisited(wizPage);
    this.wizard.jumpBackToPage(wizPage);
    this.wizard.resetFinishLabel("Good to Go");
  },
  
  doSkip3: function(event)
  {    
    console.log("TestPage4.doSkip3");
    
    var page2Node = dojo.query(".page2", this.wizard.domNode);
    var wizPage = dijit.getEnclosingWidget(page2Node[0]);
    this.wizard.jumpBackToPage(wizPage);    
  },

  reset: function()
  {
    this.wizard.resetFinishLabel("Finish");
  }
  
});

});
