/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("ibm/tivoli/tip/navwidget/gauge/dijit/AbstractGaugeView", 
	[
		"dojo/_base/declare",
		"ibm/tivoli/navmodel/Dataset",
		"ibm/tivoli/tip/navwidget/dijit/NavWidgetPluggableView",
		"dojoe/Util",
		"dojox/widget/Standby"
	],
	function(declare, Dataset, PluggableView, Util, Standby) {
		return declare("ibm.tivoli.tip.navwidget.gauge.dijit.AbstractGaugeView", [PluggableView], {
		
		datasetInfo: null,
		_gauge: null,
		_usesWidgetDefinition : false,
		_start: 0,
		_count: 1,
		standby: null,
		theme:"oneui",
		
		postMixInProperties: function() {
			console.debug("postMixInProperties : AbstractGaugeView");
			this.inherited("postMixInProperties", arguments);
			if(this.datasetInfo) {
				if(this.datasetInfo.start)
					this._start = this.datasetInfo.start;
				if(this.datasetInfo.count)
					this._count = this.datasetInfo.count;
			}
			/*if(this._gauge != null) {
				if(this.datasetInfo != null) {
					try {
						console.debug("Creating the dataset");
						var dataset = Dataset(this.datasetInfo);
						console.debug("Dataset created : " + dataset);
						console.info("this.setDataset - "+ this.setDataset);
						//this.setDataset(dataset);				
					} catch (ex) {
						console.log("There was a problem creating the dataset... " + ex.name + ": " + ex.message);
						this._gauge._currentValue = undefined;
					}
				}
			}*/			
		},
		
		_setDatasetLoadData: function(dataset){
			this._datasetReady(this.dataset);
			this.inherited(arguments);
			if(!this.standby) {
				/*Richa,24May13, #72756 , Setting the Standby Widget image based on the theme*/
				var theme=dojo.body().className;
				if (theme.indexOf( "oneui" ) != -1){
					this.theme = "oneui"	;
				}else 
					if(theme.indexOf( "breeze" ) != -1 || theme.indexOf( "TIPDark" ) != -1) {
					this.theme = "breeze";
				}
				this.standby = new Standby({target: this.domNode, color:"transparent", image: dojo.moduleUrl("themes."+this.theme,"dojoe/common/themes/"+this.theme+"/images/progress22.gif")});
				this.domNode.appendChild(this.standby.domNode);
				this.standby.startup();
			}
		},
									
		_datasetReady: function(dataset)	{
			var kwArgs = {};
			this.dataset = dataset;
			kwArgs.onComplete = dojo.hitch(this,this._itemFetchComplete);
			//kwArgs.properties = ["all"];			
			if(dataset !== null) {
				kwArgs.start = this._start;
				kwArgs.count = this._count;
				dataset.getItems(kwArgs);
			}
			kwArgs = null;
			
		},
	
		_itemFetchComplete: function(items) {
			console.log("Items fetch complete");
			var topLabel = null;
			var leftLabel = null;
			var reading = null;
			if (typeof items != "undefined" && items != null)
			{
				var item = null;
				for (var index in items)
				{
					item = items[index];
					
					if(item.getProperty(this.datasetInfo.value) && typeof(item.getProperty(this.datasetInfo.value).getValue) != "undefined"){
						if(item.getProperty(this.datasetInfo.value).getValueType != "undefined" && item.getProperty(this.datasetInfo.value).getValueType() == "status") {
							reading = item.getProperty(this.datasetInfo.value).getValue();
						}else{
							reading = item.getProperty(this.datasetInfo.value).getValue();
							var valProp = item.getProperty(this.datasetInfo.value);
							if(typeof(valProp.getValueMax) != "undefined" && valProp.getValueMax() && valProp.getValueMax() != 0
								&& valProp.getValueType != "undefined" && valProp.getValueType() == "percentage") {
								reading = (reading * 100)/valProp.getValueMax();
							}
						}
					}
					if(this.datasetInfo.topLabel != "None" && item.getProperty(this.datasetInfo.topLabel) && typeof(item.getProperty(this.datasetInfo.topLabel).getValue) != "undefined" ) {
						var allTopLabelProp;
						if(item.getProperty(this.datasetInfo.topLabel).getValueType != "undefined" && item.getProperty(this.datasetInfo.topLabel).getValueType() == "status") {
							topLabel = escapeHTML(item.getProperty(this.datasetInfo.topLabel).getValue().getValue());
							allTopLabelProp = item.getProperty(this.datasetInfo.topLabel).getValue();
						}else{
							topLabel = escapeHTML(item.getProperty(this.datasetInfo.topLabel).getValue());
							allTopLabelProp = item.getProperty(this.datasetInfo.topLabel);
						}
						if(allTopLabelProp && typeof(allTopLabelProp.getValueMax) != "undefined" && allTopLabelProp.getValueMax() && allTopLabelProp.getValueMax() != 0
							&& allTopLabelProp.getValueType != "undefined" && allTopLabelProp.getValueType() == "percentage") {
							topLabel = (topLabel * 100)/allTopLabelProp.getValueMax();
						}
					}
					if(this.datasetInfo.leftLabel != "None" && item.getProperty(this.datasetInfo.leftLabel) && typeof(item.getProperty(this.datasetInfo.leftLabel).getValue) != "undefined" ){
						var allLeftLabelProp;
						if(item.getProperty(this.datasetInfo.leftLabel).getValueType != "undefined" && item.getProperty(this.datasetInfo.leftLabel).getValueType() == "status") {
							leftLabel = escapeHTML(item.getProperty(this.datasetInfo.leftLabel).getValue().getValue());		
							allLeftLabelProp = item.getProperty(this.datasetInfo.leftLabel).getValue();
						}else{
							leftLabel = escapeHTML(item.getProperty(this.datasetInfo.leftLabel).getValue());	
							allLeftLabelProp = item.getProperty(this.datasetInfo.leftLabel);
						}
						if(allLeftLabelProp && typeof(allLeftLabelProp.getValueMax) != "undefined" && allLeftLabelProp.getValueMax() && allLeftLabelProp.getValueMax() != 0
							&& allLeftLabelProp.getValueType != "undefined" && allLeftLabelProp.getValueType() == "percentage") {
							leftLabel = (leftLabel * 100)/allLeftLabelProp.getValueMax();
						}		
					}
					
				}
				if(item != null) {
					this._gauge.setLabelAndValue(topLabel, leftLabel, reading);
					this._gauge.itemId = item.getId();
					if(item.getProperty("OslcResourceURI"))
						this._gauge.oslcResourceURI = item.getProperty("OslcResourceURI").getValue();
				} else {
					this._gauge.setValue(undefined);
				}
				item = null;
				items = null;
				topLabel = null;
				leftLabel = null;
				reading = null;
			
			}	
		},
	
	/*	_updatePropertiesInGauge: function(properties) {
			console.log("Update Properties");
			var value = this._gauge.value;
			var topLabel = this._gauge.topLabel;
			var leftLabel = this._gauge.leftLabel;
	
			var propsLength = properties.length;			
			for (var propIndex = 0;  propIndex < propsLength;  ++propIndex) {
				var property = properties[propIndex];
				var propId = property.getId();
				if (this._trace.isFinest()) {
					this._trace.finest("datasetId=" + event.getDataset().getId() + " prop=" + propId + " value=" + property.getDisplayValue(), "_handleItemPropertiesChangedEvent");
				}

				if (propId === this.datasetInfo.value) {					
					value = property.getValue();
				} 
				if (propId === this.datasetInfo.topLabel) {
					topLabel = escapeHTML(property.getValue());
				} 
				if (propId === this.datasetInfo.leftLabel) {
					leftLabel = escapeHTML(property.getValue());
				}
			}
			
			this._gauge.setLabelAndValue(topLabel, leftLabel, value);								
		},*/
		
		_handleItemStatusChangedEvent: function(event) {
			console.debug("itemStatusChanged event received");
			return;
			//var items = event.getItems();
			//this._itemFetchComplete(items);
			/*var items = event.getItems();
			if (items) {
				//Loop through info in event to fill in the array
				for (var i = 0; i < items.length; i++) {
					var item = items[i];
					if (item) {
						var statusesArgs = {};
						var itemStatuses = item.getStatuses(statusesArgs);
						if (itemStatuses) {
							for (var j = 0; j < itemStatuses.length; j++) {
								var status = itemStatuses[j];								
								// Status updates really happening here or as part of _handleItemPropertiesChangedEvent?
								// this._gauge.setLabelAndValue(this._gauge.topLabel, this._gauge.leftLabel, status);
							}
						}
					}
				}
			}*/
		},
		
		_handleItemPropertiesChangedEvent: function(event) {	
			console.debug("itemPropertiesChanged event received");					
			if (event.getProperties()) {
				var length = event.getItems().length;	
							
				for (var index = 0;  index < length;  ++index) {	
					this._gauge.itemId = event.getItems()[index].getId();	
					if ((event.getProperties())[index]) {
						console.info('here in proper event handler!');
						//this._updatePropertiesInGauge(properties);
						var value = null;
						var topLabel = null;
						var leftLabel = null;
				
						var propsLength = (event.getProperties())[index].length;			
						for (var propIndex = 0;  propIndex < propsLength;  ++propIndex) {
							if (this._trace.isFinest()) {
								this._trace.finest("datasetId=" + event.getDataset().getId() + " prop=" + propId + " value=" + property.getDisplayValue(), "_handleItemPropertiesChangedEvent");
							}

							if (((event.getProperties())[index])[propIndex].getId() === this.datasetInfo.value &&
									((event.getProperties())[index])[propIndex].getValue) {
								if(((event.getProperties())[index])[propIndex].getValueType != "undefined" && ((event.getProperties())[index])[propIndex].getValueType() == "status") {
									value = ((event.getProperties())[index])[propIndex].getValue();
								}else{
									value = ((event.getProperties())[index])[propIndex].getValue();
									if(typeof(value.getValueMax) != "undefined" && value.getValueMax() && value.getValueMax() != 0
										&& value.getValueType != "undefined" && value.getValueType() == "percentage") {
										value = (value * 100)/value.getValueMax();
									}
								}
							} 
							if (((event.getProperties())[index])[propIndex].getId()  === this.datasetInfo.topLabel &&
									((event.getProperties())[index])[propIndex].getValue) {
								var allTopLabelProp;
								if(((event.getProperties())[index])[propIndex].getValueType != "undefined" && ((event.getProperties())[index])[propIndex].getValueType() == "status") {
									topLabel = escapeHTML(((event.getProperties())[index])[propIndex].getValue().getValue());
									allTopLabelProp = ((event.getProperties())[index])[propIndex].getValue();
								}else{
									topLabel = escapeHTML(((event.getProperties())[index])[propIndex].getValue());
									allTopLabelProp = ((event.getProperties())[index])[propIndex];
								}
								if(allTopLabelProp && typeof(allTopLabelProp.getValueMax) != "undefined" && allTopLabelProp.getValueMax() && allTopLabelProp.getValueMax() != 0
									&& allTopLabelProp.getValueType != "undefined" && allTopLabelProp.getValueType() == "percentage") {
									topLabel = (topLabel * 100)/allTopLabelProp.getValueMax();
								}
							} 
							if (((event.getProperties())[index])[propIndex].getId()  === this.datasetInfo.leftLabel &&
									((event.getProperties())[index])[propIndex].getValue) {
								var allLeftLabelProp;
								if(((event.getProperties())[index])[propIndex].getValueType != "undefined" && ((event.getProperties())[index])[propIndex].getValueType() == "status") {
									leftLabel = escapeHTML(((event.getProperties())[index])[propIndex].getValue().getValue());
									allLeftLabelProp = ((event.getProperties())[index])[propIndex].getValue();
								}else{
									leftLabel = escapeHTML(((event.getProperties())[index])[propIndex].getValue());
									allLeftLabelProp = ((event.getProperties())[index])[propIndex];
								}
								if(allLeftLabelProp && typeof(allLeftLabelProp.getValueMax) != "undefined" && allLeftLabelProp.getValueMax() && allLeftLabelProp.getValueMax() != 0
									&& allLeftLabelProp.getValueType != "undefined" && allLeftLabelProp.getValueType() == "percentage") {
									leftLabel = (leftLabel * 100)/allLeftLabelProp.getValueMax();
								}	
							}
							if(((event.getProperties())[index])[propIndex].getId()  === "OslcResourcURI"  &&
									((event.getProperties())[index])[propIndex].getValue) {
								this._gauge.oslcResourceURI = escapeHTML(((event.getProperties())[index])[propIndex].getValue());
							}
						}
						this._gauge.setLabelAndValue(topLabel, leftLabel, value);	
						//set all the references to null to ensure browser deletes the items and properties
						value = null;
						topLabel = null;
						leftLabel = null;
									
					}	
							
				}			
			}
			//setting event object reference to null to ensure browser does not hold any references
			event = null;
		},

		_handleItemsRemovedEvent: function(event) {
			console.info("_handleItemsRemovedEvent");
			this._datasetReady(event.getDataset());
		},
		
		_handleItemsAddedEvent: function(event) {
			console.info("_handleItemsAddedEvent");
			this._datasetReady(event.getDataset());
		},
		
		_handleChangedEvent: function(event) {	
			console.debug("datasetChanged event received");
			//var items = event.getItems();
			//this._itemFetchComplete(items);
			// console.log("REFRESH DATASET");			
			//this.dataset._clearAllCaches();
			this._datasetReady(event.getDataset());
		},
		
		showBusyPane: function(event){		
			if(this.standby) this.standby.show();		
		},	
		
		hideBusyPane: function(event){		
			if(this.standby) this.standby.hide();		
		},
		
		forceHideBusyPane: function(event){		
			if(this.standby) this.standby.hide();		
		}
		
});
});
