/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/
define("ibm/tivoli/tip/navwidget/list/dijit/ListView", 
	[
		"dojo/_base/declare",
		"ibm/tivoli/tip/navwidget/dijit/NavWidgetPluggableView",
		"dojoe/list/List",
		"dojo/dom-style",
		"dojo/_base/lang",
		"dojox/mobile/TabBar",
		"dojoe/list/_MultiSelectTabBarButton",
		"dojo/query",
		"dojox/widget/Standby"
	],
	function(declare, PluggableView, List, domStyle, lang, TabBar, _MultiSelectTabBarButton,query, Standby) {
		return declare("ibm.tivoli.tip.navwidget.list.dijit.ListView", [PluggableView, List], {
		
		datasetInfo: null,
		_usesWidgetDefinition : false,
		barfilter: "",
		qFilter: "",
		button0Filter: "",
		button1Filter: "",
		button2Filter: "",
		button3Filter: "",
		button0Name: "",
		button1Name: "",
		button2Name: "",
		button3Name: "",
		sort: null,	
		standby: null,	
	
		_setDatasetLoadData: function(dataset){
			this.inherited(arguments);
			this._datasetReady(this.dataset);
			//60594: TWL 1.1 : Quick Filter does not filter List items
			//Bobby: 12Dec2012, changed from image to dojo button
			//if(this.searchButtonNode) this.searchButtonNode.onclick = lang.hitch(this,this._applyQuickFilter);
			if(this.searchButtonNode) dojo.connect(this.searchButtonNode,"onClick",lang.hitch(this,this._applyQuickFilter));
			//else console.warn('ListView.js: _setDatasetLoadData(): this.searchButtonNode not found!');
			//67642: Add manual refresh control for List			
			//Bobby: 20Mar2013, adding a manual refresh button
			if(this.refreshButtonNode) dojo.connect(this.refreshButtonNode,"onClick",lang.hitch(this,this.refresh));
			if(this.clearFilterNode) this.clearFilterNode.onclick = lang.hitch(this,this._clearQuickFilter);	
			//else console.warn('ListView.js: _setDatasetLoadData(): this.clearFilterNode not found!');	
			//60489: TWL 1.1 : List dashlet does not render items on IE8
			//Bobby:11Dec2012, color: none breaks IE! - Unspecified error.
			//this.standby = new Standby({target: this.domNode, color:'none'});
			this.standby = new Standby({target: this.domNode, color:'transparent'});
			this.domNode.appendChild(this.standby.domNode);
			this.standby.startup();
		},

		refresh: function(){
			console.debug("ListView.js: refresh(): called...");	
			this.showBusyPane();
			this._datasetReady(this.dataset);
		},
		
		_clearQuickFilter: function(){		
			this.showBusyPane();
			this.qFilter = "";
			//Richa ,12Mar13 #68041, changing the text from Search to Filter.
			this.searchField.value = this.nls.FILTER;
			//Bobby: 04Oct2012, need to reset as pagination could have changed these
			//Latha: 55495: TWL 1.1 : Show more items in List dashlet is shown even when there are no more filter items to be shown
			this._count = 0; // Initializing count to zero as this is to keep track of the count of records retrieved from the dataset
			this._start = 0; //initialize start to 0
			this._datasetReady(this.dataset);
		},
		
		_applyQuickFilter: function(){			
			if(this.searchField.value && this.searchField.value!= this.nls.FILTER){
				this.showBusyPane();
				var condition = "";
				var foundAttr = false;
				if(this.configInfo.Severity && this.configInfo.Severity!="None" && this.configInfo.Severity!="" && this.configInfo.Severity!="undefined"){
					condition = "("+this.configInfo.Severity+" contains '"+this.searchField.value+"')";
					foundAttr = true;
				}
				if(this.configInfo.Node && this.configInfo.Node!="None" && this.configInfo.Node!="" && this.configInfo.Node!="undefined"){
					if(foundAttr){
						condition = condition + ' or ';						
					}
					foundAttr = true;
					condition = condition + "("+this.configInfo.Node+" contains '"+this.searchField.value+"')";
				}
				if(this.configInfo.Summary && this.configInfo.Summary!="None" && this.configInfo.Summary!="" && this.configInfo.Summary!="undefined"){
					if(foundAttr){
						condition = condition + ' or ';
					}
					foundAttr = true;
					condition = condition + "("+this.configInfo.Summary+" contains '"+this.searchField.value+"')";				
				}
				if(this.configInfo.LastOccurrenceDate && this.configInfo.LastOccurrenceDate!="None" && this.configInfo.LastOccurrenceDate!="" && this.configInfo.LastOccurrenceDate!="undefined"){
					if(foundAttr){
						condition = condition + ' or ';
					}
					foundAttr = true;
					condition = condition + "("+this.configInfo.LastOccurrenceDate+" contains '"+this.searchField.value+"')";	
				}			
				if(condition){
					//Bobby: 04Oct2012, need to reset as pagination could have changed these
					this._count = 0; // Initializing count to zero as this is to keep track of the count of records retrieved from the dataset
					this._start = 0; //initialize start to 0				
					this.qFilter = condition;
					this._datasetReady(this.dataset);
				}	
			}else this._clearQuickFilter();
			//this.searchPane.toggle();
		},
		
		_clearBarFilter: function(){	
			this.showBusyPane();
			this.barFilter = "";
			//Bobby: 04Oct2012, need to reset as pagination could have changed these
			this._count = 0; // Initializing count to zero as this is to keep track of the count of records retrieved from the dataset
			this._start = 0; //initialize start to 0
			this._datasetReady(this.dataset);
		},
		
		_applyBarFilter: function(filterName, filterValue){
			this.showBusyPane();
			console.debug("_applyBarFilter called with value: "+filterName +"|"+filterValue);			
			//find out which filterButton was clicked
			if(filterName == this.button0Name){		
				this.button0Filter = filterValue;
			}else if(filterName == this.button1Name){		
				this.button1Filter = filterValue;
			}else if(filterName == this.button2Name){		
				this.button2Filter = filterValue;
			}else if(filterName == this.button3Name){		
				this.button3Filter = filterValue;			
			}		
		
			//construct the condition for the whole filterBar (multi-select)
			this.barFilter = "";
			if(this.button0Filter || this.button0Filter=="0"){
				if(this.barFilter){
					this.barFilter = this.barFilter + ' or ' + "("+this.configInfo.Severity+" = "+this.button0Filter+")"; 
				}else this.barFilter = "("+this.configInfo.Severity+" = "+this.button0Filter+")"; 
			}	
			if(this.button1Filter || this.button1Filter=="0"){
				if(this.barFilter){
					this.barFilter = this.barFilter + ' or ' + "("+this.configInfo.Severity+" = "+this.button1Filter+")"; 
				}else this.barFilter = "("+this.configInfo.Severity+" = "+this.button1Filter+")"; 
			}
			if(this.button2Filter || this.button2Filter=="0"){
				if(this.barFilter){
					this.barFilter = this.barFilter + ' or ' + "("+this.configInfo.Severity+" = "+this.button2Filter+")"; 
				}else this.barFilter = "("+this.configInfo.Severity+" = "+this.button2Filter+")"; 
			}
			if(this.button3Filter || this.button3Filter=="0"){
				if(this.barFilter){
					this.barFilter = this.barFilter + ' or ' + "("+this.configInfo.Severity+" = "+this.button3Filter+")"; 
				}else this.barFilter = "("+this.configInfo.Severity+" = "+this.button3Filter+")"; 
			}
			
			console.debug("_applyBarFilter constructed filter: "+this.barFilter);
			//this.barFilter = "("+this.configInfo.Severity+" contains '"+filterValue+"')";
			//Bobby: 04Oct2012, need to reset as pagination could have changed these
			this._count = 0; // Initializing count to zero as this is to keep track of the count of records retrieved from the dataset
			this._start = 0; //initialize start to 0
			this._datasetReady(this.dataset);
		},
									
		_datasetReady: function(dataset){
			//Bobby: 21Nov2012, List already has a wait indiciator for initial load
			//this.showBusyPane();			
			if(dataset){
				//60269: Dash: Search in List Widget doesn't appear to do anything
				if(dataset.getArg('dataUrl')){
					this.hideFilterBar();
					this.hideSearchBar();
				}
			}	
			
			var condition = "";
			if(this.barFilter && this.qFilter){
				condition = "("+this.barFilter+") and (" + this.qFilter + ")";
			}else if(this.barFilter){
				condition = this.barFilter;
			}else if(this.qFilter){
				condition = this.qFilter;
			}	
			//Latha: 03Oct2012, start & count will be managed by default & pagination control
			//this._count = this._pageSize; //initialize count to pageSize
			//this._start = 0; //initialize start to 0			
			var kwArgs = {};
			kwArgs.onComplete = dojo.hitch(this,this._itemFetchComplete);
			//kwArgs.properties = ["all"];			
			if(dataset !== null) {
				kwArgs.count = this._pageSize;
				kwArgs.start = this._start;
				kwArgs.sort = this.sort;
				this._count = parseInt(this._start) + parseInt(this._pageSize);
				
				//quickfilter
				if(condition){
					kwArgs.condition = condition;
				}else kwArgs.condition = null;
				
				dataset.getItems(kwArgs);
			}
		},
	
		_itemFetchComplete: function(items) {
			if(this.enableFilter){
				if(this.dataset) this.dataset.getStatuses({
					type: "item",
					onComplete: dojo.hitch(this, this._fillFilterBar),
					onError: dojo.hitch(this, this._fillFilterBarError)
				});
			}else this.hideFilterBar();	
							
			if(this._start == 0){
				this.listWidget.set("items", {});
				//this._rowData = new Array(); //items are cached here, need to reset
				this._rowData.splice(0,this._rowData.length);
			}
			
			//Richa,9May13 ,#71605: [CUST/BP][T-Systems]Improve the message in the List widget when no data to display 
			//If there are no items in the list , display an inline error message instead of the emptyTemplate
			if(items.length != 0){
				this.processData(items);
			} else{
				//Richa ,22May13 , #75525 , Remove the "No Data Found" description
				this.processData(null);	
			}
			
				
			this.forceHideBusyPane();	
		},
		
		_fillFilterBar: function(/*Object[]*/ itemStatuses, /*fillTheBarWithFilters_kwArgs*/ kwArgs) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			console.debug("ListView.js: _fillFilterBar - BEGIN");			
			if(!this.filterBar){
				console.dir(itemStatuses);
				//Bobby: 04Oct2012, no point in having a filter bar with single icon
				//if(itemStatuses.length>0){
				if(itemStatuses.length>1){
					this.filterBar = new TabBar({fixed: "bottom"},this.filterBarDiv);				
					var image;
					for(var i=0; (i< 4 && i<itemStatuses.length); i++){
						//console.dir(itemStatuses[i]);		
						image = itemStatuses[i].getImage();	
						if(image.indexOf('[widget]') > -1){
							//Bobby: 04Oct2012, pointing to 32x32 version of the 16x16 icons
							//image = image.replace('[widget]', "ibm/tivoli/tip/navwidget/themes");
							image = image.replace('[widget]', "dojoe/list/themes");
							image = require.toUrl(image);
						}			
						var statusButton = new _MultiSelectTabBarButton({
							icon1: image,
							icon2: image,
							title: itemStatuses[i].getLabel(),
							alt: itemStatuses[i].getLabel(),
							filterVal: itemStatuses[i].getValue(),
							filterFnc: lang.hitch(this,"_applyBarFilter")
						});		
						if(i==0) this.button0Name = statusButton.filterVal;
						else if(i==1) this.button1Name = statusButton.filterVal;
						else if(i==2) this.button2Name = statusButton.filterVal;
						else if(i==3) this.button3Name = statusButton.filterVal;
						statusButton.connect(statusButton, "onClick", function(){
							if(this.selected) this.filterFnc(this.filterVal, this.filterVal);
							else this.filterFnc(this.filterVal, ""); //clear the filter
						});
						
						this.filterBar.addChild(statusButton);				
					}	
					this.filterBar.startup();
					
					query(".twllist .mblTabBarButtonIcon").forEach(function(node){
						domStyle.set(node.firstChild, {'height' : '32px', 'width' : '32px', });
					});					
				}else this.hideFilterBar();
			}	
			console.debug("ListView.js: _fillFilterBar - END");	
		},
		
		_fillFilterBarError: function(/*Object*/ error, /*Object*/ exception, /*Object*/ ioArgs) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon		
			//this.displayException(error);
			console.warn("ListView.js: _fillFilterBarError: An error occured while constructing filter bar from available statuses");
			console.warn(exception.getMsgText());
			this.hideFilterBar();
		},
		
		_retrieveMoreItems: function() {
			console.debug("ListView.js: _retrieveMoreItems: BEGIN");
			this._start = parseInt(this._start) + parseInt(this._pageSize);
			console.debug("start : "+this._start);
			this._datasetReady(this.dataset);
			console.debug("ListView.js: _retrieveMoreItems: END");
		}, 
	
		_handleItemStatusChangedEvent: function(event) {
			console.debug("ListView.js: itemStatusChanged event received");
			//var items = event.getItems();
			//console.dir(items);
			//this._itemFetchComplete(items);
			this._datasetReady(this.dataset);
		},
		
		_handleItemPropertiesChangedEvent: function(event) {	
			console.debug("ListView.js: itemPropertiesChanged event received");
			//var items = event.getItems();
			//console.dir(items);
			//this._itemFetchComplete(items);
			this._datasetReady(this.dataset);
		},

		_handleChangedEvent: function(event) {	
			console.debug("ListView.js: datasetChanged event received");
			//var items = event.getItems();
			//console.dir(items);
			//this._itemFetchComplete(items);
			this._datasetReady(this.dataset);
		},

		_onKeyUp: function(event){		
			//enter key
			if (event.keyCode == 13) {     				
				dojo.stopEvent(event);
				this._applyQuickFilter();
				return;
			}		
		},
		
		//Bobby:06Dec2012, overriding as busypane has issues in mobile devices
		showBusyPane: function(event){		
			if(this.standby) this.standby.show();		
		},	
		hideBusyPane: function(event){		
			if(this.standby) this.standby.hide();		
		},
		forceHideBusyPane: function(event){	
			if(this.standby) this.standby.hide();		
		},
		
		//61890: List - dataset errors should be shown in List instead of Message Dialog
		displayException: function(exception){
			this.processData(null, exception.getMsgText());	
		}					
	});
});
