// wrapped by build app
define("ibm/tivoli/tip/richhover/RichHoverTooltip", ["dijit","dojo","dojox","dojo/i18n!ibm/tivoli/tip/richhover/nls/RichHover","dojo/require!dijit/TooltipDialog,dijit/form/Button,dijit/Dialog,ibm/tivoli/tip/richhover/RichHover,ibm/tivoli/tip/richhover/RichHoverDataset,ibm/tivoli/tip/richhover/RichHoverUrlInfo,ibm/tivoli/tip/richhover/MessageDialog,dojo/i18n"], function(dijit,dojo,dojox){
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed Materials - Property of IBM
* Tivoli Widget Library
*
* (C) Copyright IBM Corp. 2013.  All Rights Reserved.
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
************************************************************ {COPYRIGHT-END} **/

dojo.require("dijit.TooltipDialog");
dojo.require("dijit.form.Button");
dojo.require("dijit.Dialog");
dojo.require("ibm.tivoli.tip.richhover.RichHover");
dojo.require("ibm.tivoli.tip.richhover.RichHoverDataset");
dojo.require("ibm.tivoli.tip.richhover.RichHoverUrlInfo");
dojo.require("ibm.tivoli.tip.richhover.MessageDialog");
dojo.require("dojo.i18n");
dojo.provide("ibm.tivoli.tip.richhover.RichHoverTooltip");

dojo.requireLocalization("ibm.tivoli.tip.richhover", "RichHover");

dojo.declare("ibm.tivoli.tip.richhover.RichHoverTooltip",
             dijit.TooltipDialog,
{
  urlInfo : null,
  aroundNode : null, /* The dom node for which this tooltip will be shown around */
  hoverHeight : 0,  /* height of the hover iframe, not the entire dialog */
  hoverWidth : 0,   /* width of the hover iframe, not the entire dialog */
  dlgAddlHeight : {"px": 50, "em": 5, "ex": 5, "default": 10}, /* how much higher to make the actual dlg than iframe height */
  dlgAddlWidth : {"px": 10, "em": 1, "ex": 1, "default": 10},  /* how much wider to make actual dlg than iframe width */
  dimensionUnit : null,
  largeLeft: 0,
  largeTop:0,
  isLargeHoverPresent : null,
  contentIsolation : false,
  namespace:"",
  hoverTitle : null,
  xcord:0,
  ycord:0,
  _largeHtmlUrl : null,
   //resources:object
   //Reference to the resources
   resources_:null,
  _largePreview : null,
  _resourceUrl : null,
  _largeHoverHeight : 0,
  _largeHoverWidth : 0,
  _shownAlready : false,
  _tabSwitchListener : null,
  _anchorList : null,
  _blurListener : null,
  _focusListener : null,
  _hoverNodeLeaveListener : null,
  _hoverNodeEnterListener : null,
  _mouseEnterListener : null,
  _mouseExitListener : null,
  
  _dismissNodeLeaveTime : 500,
  _dismissDlgLeaveTime : 250,
  _hoveringNode : false,
  _hoveringDlg : false,
  
  _terminationTimer : null,
  _iniTabStripOffset : 0,
  _hiddenTabs: -1,
  _hiddenTabsLeft: 0,
  _popupUrl:null,
  theme:"oneui",
 
  constructor: function(args)
  {
	this.resources_ = dojo.i18n.getLocalization("ibm.tivoli.tip.richhover", "RichHover",this.lang);
    var oldWidget = dijit.byId("dlgtab");
    if (oldWidget)
      oldWidget.destroy();
  },

  onClickMore: function()
  {
    window.open(this._resourceUrl);
  },

  onClickClose: function()
  {
	this._dismissDlg();
  },
  
  
  /* This fucntions facilitates  opening of large hoven 
   * when the chevron(on small hover) is clicked
   * Large hover renders the URL in an iFrame. MessageDialog.js is used for this.
  */
  onClickChevron: function()
  {
	this._onMouseExitDlg();
    var lHoverIframe= '<iframe id="largeHover" style="border:0px; width:100%; height:100%" src="'+this._largeHtmlUrl+'">pane</iframe>';
	 var cp = new dijit.layout.ContentPane({
	  content:lHoverIframe,
      resourceUrl: this._largeHtmlUrl
    });
			
	var dialogStyle = "width:" + this.largeHoverWidth + "px; height:" + this.largeHoverHeight + "px";
	largeHover = new dijit.Dialog({
            title: this.hoverTitle,
			style : dialogStyle
        });
			
	var msgDlg = new ibm.tivoli.tip.richhover.MessageDialog(
							{
							title: this.hoverTitle,
							theme: this.theme,
							content:cp,
							_popupUrl : this._popupUrl,
							contentIsolation : false, // even if content isolated we will reuse iFrame of tooltip
							height:this._largeHoverHeight,
							_resourceUrl:this._resourceUrl,
							width:this._largeHoverWidth});

	msgDlg.startup();
	msgDlg.show();
  },
  
  
  onCloseCallback : function(buttonPressedId, messageId, checked) {
		this._mouseExitListener = dojo.connect(this.domNode,"onmouseleave",this,this._onMouseExitDlg);
  },
			
  destroy: function()
  {
	if (this._tabSwitchListener!=null)
	{
		dojo.disconnect(this._tabSwitchListener);
		this._tabSwitchListener=null;
	}
	this.inherited(arguments);
  },

  
  /* This method adds the footer to the small hover.  More Info Link and >>(chevron)
   * are added by this. More info is disabled until the design team  
   * okays its usage.
   */
  _addButtons: function(mdiv)
  {
    if (dijit.byId("morebutton") != null)
       dijit.byId("morebutton").destroy();

    var moreInfoButton = dojo.create("a", {href: "javascript:void(0)", align:"left", title: this.resources_.MORE_INFO, id: "moreInfo", onclick: dojo.hitch(this, this.onClickMore), innerHTML: this.resources_.MORE_INFO})
    var moreInfodiv = dojo.create("span", {align:"left", innerHTML: "&nbsp;&nbsp;"})
	var buttonDiv = dojo.create("div", {title: "buttons", id:"buttonDiv", style:"width:50%; float: left;"});
	
	buttonDiv.appendChild(moreInfodiv);
	var footerDiv = dojo.create("div", {title: "footer", id:"footer_div", style:"width:100%;"});
	var chevronDiv = dojo.create("div", {align: "right", title: "LargePreview", id:"chevronDiv", style:"width:50%; float: right;"});
	var chevron = dojo.create("a", {href: "javascript:void(0)", align:"right", onclick: dojo.hitch(this, this.onClickChevron), title: this.resources_.LARGE_PREVIEW, innerHTML: ">>"})
	chevronDiv.appendChild(chevron);

	var chevHidden = false;
	if((this.isLargeHoverPresent.join(" ")).indexOf(this._resourceUrl) == -1)
	{
		chevHidden="true";
	}
	var footerContent = this.getFooter(buttonDiv, chevronDiv, chevHidden);
	footerDiv.innerHTML = footerContent;
	mdiv.appendChild(footerDiv);
  },

  
  /* Allows display of hidden tabs in IE. By default Dojo sets the width of
   * noWrapTabStrip to 50000 so that it doesn't wrap if the number of tabs exceed 
   * the allowed width.  This isn't set on IE automatically.
   */
  _ieTabFix : function(tc) {
    var noWrapTabParent;	
	var tabListContainer = dojo.query('> .dijitTabListContainer-top',tc);
	if (tabListContainer.length == 1)
	  {
		  noWrapTabParent = tabListContainer[0];
	  }
	  //Richa,24Apr13, #70697: Theming work for Rich Hover widget
	  //Removing the hatch pattern
	//  var icon = dojo.moduleUrl("themes.common.images", "hatch-pattern.png");
	//  noWrapTabParent.style.backgroundImage="url('" + icon +"')";
	  
	  for (var i=0; i<noWrapTabParent.children.length; i++)
		  {
			  var classes = noWrapTabParent.children[i].className;
			  if(classes.indexOf('dijitTabListWrapper') > -1)
			  {
				var noWrapTabStrip = dojo.query("> .nowrapTabStrip", noWrapTabParent.children[i]);
				noWrapTabStrip[0].style.border="0px";
				if(dojo.isIE && noWrapTabParent !="undefined"  &&  noWrapTabParent != null) {
					if(noWrapTabStrip != null &&  noWrapTabStrip != "undefined" &&  noWrapTabStrip.length>0) {
						dojo.style(noWrapTabStrip[0], "width", "50000px"); // dojo sets 50000 as default, which is not reflecting in IE
					}
				  }
			  }
		}
	  return ;
  },
  
  
  /*  Some Dojo Hack on style to get the tabs displayed properly.
   *  This removed the right arrow(allows only drop down arrow) for hidden tabs
   *  Returns an array of right button, dropdown button and the tabContainer.
   *  The return value is reused at other place, hence saves some computations.
   */
  _dojoHack: function(tc)
  {
	  var elems = [];
	  var tabListContainer = dojo.query('> .dijitTabListContainer-top',tc);
	  var tooltipContainer = dojo.query('> .dijitTooltipContainer', this.domNode);
	  if (tabListContainer.length == 1)
	  {
		  var tabs = dojo.query('> .tabStripButton-top',tabListContainer[0]);
		  var removedChild;
		  var leftButton;
		  for (var i=0; i<tabs.length; i++)
		  {
			  tabs[i].style.display="none";
			  if(tabs[i].getAttribute("widgetid") != null && tabs[i].getAttribute("widgetid") != "undefined")
			  {
				if(tabs[i].getAttribute("widgetid").indexOf("rightBtn") > 0)
				{
					removedChild = tabs[i];
				} else if(tabs[i].getAttribute("widgetid").indexOf("menuBtn") > 0)
				{
					elems.push(tabs[i]);
				} else if(tabs[i].getAttribute("widgetid").indexOf("leftBtn") > 0)
				{
					leftButton = tabs[i];
				}
			  }		  
		  }
		  elems.push(removedChild);
		  elems.push(tabListContainer[0]);
		  elems.push(leftButton);
		  leftButton.title = this._hiddenTabsLeft + " Resources";
	  }
	  return elems;
	  // not needed as of now.
	  var toolTipContainer = dojo.query('> .dijitTooltipContainer',this.domNode);
	  if (toolTipContainer.length==1)
	  {
		  var toolTipContents = dojo.query('> .dijitTooltipContents',toolTipContainer[0]);
		  if (toolTipContents.length == 1)
		  {
			  var tabContainer = toolTipContents[0].childNodes[0];
			  var tabListContainer = dojo.query('> .dijitTabListContainer-top',tabContainer);
			  if (tabListContainer.length == 1)
			  {
				  var tabs = dojo.query('> .tabStripButton-top',tabListContainer[0]);
				  for (var i=0; i<tabs.length; i++)
				  {
					  tabs[i].style.display="none";
				  }
			  }
		  }
	  }
	  
	return; // below this line is what the old code for the dialog looked like.  
    // Dojo hackery... need to get rid of the annoying tab strip
    // should contact IDT about this
    var tab = dojo.byId("dlgtab_tablist_menuBtn");
    tab.style.display="none";
    tab.parentNode.style.display="none";

    tab = dojo.byId("dlgtab_tablist_leftBtn");
    tab.style.display="none";
    tab.parentNode.style.display="none";

    tab = dojo.byId("dlgtab_tablist_rightBtn");
    tab.style.display="none";
    tab.parentNode.style.display="none";
  },
  
  
  /* this method prepares the footer and retuns the HTML for it.
   * The HTML is added to the small hover.
   */
  getFooter: function(buttonDiv, chevronDiv, chevHidden)
  {
	var innerHtml = "";
	innerHtml = innerHtml + "<table>";
	innerHtml = innerHtml + "<tr valign=\"top\">";
	innerHtml = innerHtml + "<td width=\"100%\">" + buttonDiv.innerHTML;
	innerHtml = innerHtml + "</td>";
	if(chevHidden)
		innerHtml = innerHtml + "<td align=\"right\" width=\"100%\" id=\"chevTd\" style=\"visibility:hidden\">" + chevronDiv.innerHTML;
	else
		innerHtml = innerHtml + "<td align=\"right\" width=\"100%\" id=\"chevTd\">" + chevronDiv.innerHTML;
	innerHtml = innerHtml + "</td>";
	innerHtml = innerHtml + "</tr>";
	innerHtml = innerHtml + "</table>";
	return innerHtml;
  },
  
  
  /* Action handler when a tab is switched. This decides if the >> should be hidden or displayed based on the Large Hover URL.
   * Also sets the custom dimension os large hover which is related to this tab.
   */
  _onTabSwitch: function(tab)
  {
    this._resourceUrl = tab.resourceUrl;
	for (var i=0; i<this._largePreview.length; i++)
	{
		if(this._largePreview[i].resourceUrl == this._resourceUrl)
		{
			this._resourceUrl=this._largePreview[i].resourceUrl
			this._largeHtmlUrl = this._largePreview[i].url;
			this._largeHoverHeight =this._largePreview[i].heighthint;
			this._largeHoverWidth = this._largePreview[i].widthhint;
			this.hoverTitle = this._largePreview[i].shortTitle;
		}
	}
	
	var chevDiv = dojo.byId("chevTd");
	if((this.isLargeHoverPresent.join(" ")).indexOf(tab.resourceUrl)==-1)
	{
		chevDiv.style.visibility="hidden";
	}
	else {
		chevDiv.style.visibility="";
	}
  },
  
  
  
  _parseDim: function(dimension)
  {
	  /* Remove whitespace if any */
	  var ds = dimension.replace(/^\s+|\s+$/g, '');

	  var num = parseInt(ds);
	  var numstr = ""+num;
	  var unit = "em";
	  if (ds.length>numstr.length)
	  {
	     var units = ds.substring(numstr.length);
	     unit = units.replace(/^\s+|\s+$/g, '');
	  }
	  
	  return {num: num, unit: unit};
  },
  
  
  _calculateDimensions: function()
  {
     if (typeof this.urlInfo != "undefined" && this.urlInfo != null && this.urlInfo.getPreviews() != null)
     {
	    var previews = this.urlInfo.getPreviews();
	    for (var i=0; i<previews.length; i++)
	    {
	        var preview = previews[i];
			if(preview.smallPreview == undefined || preview.smallPreview == null)
			  {
				// set props for Large Hover.
				continue;
			  }
	    	// TODO: not a great way of dealing with hints, but ok for now
	    	var height = preview.smallPreview.heighthint;
	    	var width = preview.smallPreview.widthhint;
	    	if (height != null)
	    	{
	    		var ds = this._parseDim(height);
	    		if (this.hoverHeight < ds.num)
	    			this.hoverHeight = ds.num;
	    		if (this.dimensionUnit == null)
	    			this.dimensionUnit = ds.unit;
	    		else if (ds.unit == "px")
	    			this.dimensionUnit = ds.unit;
	    	}
	    	if (width != null)
	    	{
	    		var ds = this._parseDim(width);
	    		if (this.hoverWidth < ds.num)
	    			this.hoverWidth = ds.num;
	    		if (this.dimensionUnit == null)
	    			this.dimensionUnit = ds.unit;
	    		else if (ds.unit == "px")
	    			this.dimensionUnit = ds.unit;
	    	}
	    }
     }
     if (this.hoverHeight==0)
     	this.hoverHeight=14;
     if (this.hoverWidth==0)
     	this.hoverWidth=20;
     if (this.dimensionUnit==null)
     	this.dimensionUnit="em";
     
     /* Once dimensions are calculated for the previews, we want to set the size of the dialog as a whole */
     var addlWidth = (typeof this.dlgAddlWidth[this.dimensionUnit]=="undefined"?this.dlgAddlWidth["default"]:this.dlgAddlWidth[this.dimensionUnit]);
     var addlHeight = (typeof this.dlgAddlHeight[this.dimensionUnit]=="undefined"?this.dlgAddlHeight["default"]:this.dlgAddlHeight[this.dimensionUnit]);
     var dlgStyle = "display:none; height: "+(this.hoverHeight+addlHeight)+this.dimensionUnit+"; width: "+(this.hoverWidth+addlWidth)+this.dimensionUnit+";"
     
     this.set("style",dlgStyle);
  },
  
  _disconnectListener: function(listener)
  {
	 if (listener != null)
	 {
		dojo.disconnect(listener);
	 }
	 return null;
  },
  
  _dismissDlg: function()
  {
  	  this._clearTerminationTimer();
	  dijit.popup.close(this);
	  
	  // Disconnect all the listeners
	  this._blurListener = this._disconnectListener(this._blurListener);
	  this._focusListener = this._disconnectListener(this._focusListener);
	  this._hoverNodeLeaveListener = this._disconnectListener(this._hoverNodeLeaveListener);
	  this._hoverNodeEnterListener = this._disconnectListener(this._hoverNodeEnterListener);
	  this._mouseEnterListener = this._disconnectListener(this._mouseEnterListener);
	  this._mouseExitListener = this._disconnectListener(this._mouseExitListener);
	  this._anchorList = this._disconnectListener(this._anchorList);
	  this._onClickClose = this._disconnectListener(this._onClickClose);
  },
  
  _onMouseEnterDlg: function()
  {
	this._clearTerminationTimer();
  },
  
  _onMouseExitDlg: function(evt)
  {
	var parentNode  = this.domNode.parentNode;
	var tabPopup = parentNode.nextSibling;
	if(tabPopup != null && tabPopup != "undefined") {
		var top = parentNode.offsetTop;
		var left = parentNode.offsetLeft;
		var right = left + parentNode.offsetWidth;
		var bottom = top + parentNode.offsetHeight;
		if(evt.pageX > left && evt.pageX < right && evt.pageY > top && evt.pageY < bottom)
			return;
	}
	this._clearTerminationTimer();
	this._terminationTimer = setTimeout(dojo.hitch(this,this._dismissDlg), this._dismissDlgLeaveTime);

  },
  
  _onNodeLeave: function()
  {
	this._clearTerminationTimer(); 
	//53148: TBSM 35186 - Hover preview dialog dismisses immediately after being shown
	if(!this._popupUrl)
		this._terminationTimer = setTimeout(dojo.hitch(this,this._dismissDlg), this._dismissNodeLeaveTime);
  },
  
  _onNodeEnter: function()
  {
	this._clearTerminationTimer();
  },
  
  _onDlgFocus: function()
  {
    this._clearTerminationTimer();
  },
  
  _clearTerminationTimer: function()
  {
	 if (this._terminationTimer != null)
     {
		 clearTimeout(this._terminationTimer);
		 this._terminationTimer = null;
	 }
  },
  
  /**
   * Internal function that should be called to show the dialog.  It will connect a listener
   * to dismiss the popup dialog.
   */
  _internalShow: function(elems)
  {
      this._hoverNodeLeaveListener= dojo.connect(this.aroundNode,"onmouseleave",this,this._onNodeLeave);
      this._hoverNodeEnterListener= dojo.connect(this.aroundNode,"onmouseenter",this,this._onNodeEnter);
	  if(this.aroundNode == null || this.aroundNode == "undefined") {
		dijit.popup.open({popup:this, x:this.xcord, y:this.ycord});
	  } else {
		dijit.popup.open({popup:this, around:this.aroundNode});
	  }
      this._focusListener= dojo.connect(this,"onFocus",this,this._onDlgFocus);
      this._mouseEnterListener = dojo.connect(this.domNode,"onmouseenter",this,this._onMouseEnterDlg);
      this._mouseExitListener = dojo.connect(this.domNode.offsetParent,"onmouseleave",this,this._onMouseExitDlg);
      // Remove the blur listener because when working in the google map, I got a blur that caused it to close.
      //this._blurListener= dojo.connect(this,"onBlur",this,this._dismissDlg);
	  
	  // Right slide arrow is being removed and is replaced by a close icon.
	  // DropDown button is shifted in place of right slider.
	  
	  //Richa,24Apr13, #70697: Theming work for Rich Hover widget
	  //Removing the close icon from the div containing the tabs
//	  var closeIconDiv = dojo.create("div", {id:"closeIconDiv"});
//      var closeIcon = dojo.create("img", {id:"closeImg", alt: this.resources_.CLOSE,  role:"presentation", src:dojo.moduleUrl("themes.common.images", "x.png")});
//	  var leftShift = elems[0].style.left;
	  elems[2].removeChild(elems[1]);
	  dojo.connect(elems[0],"onclick",elems[0],this._updateHiddenTab, false);
	  //dojo.connect(elems[0],"onmouseover",elems[0],this._hoverUpdate, false);
//	  closeIconDiv.style.cssText = elems[0].style.cssText;
//	  closeIconDiv.style.left = leftShift;
	//  closeIconDiv.style.border = "0px";
	  //closeIconDiv.className = elems[0].className;
//	  closeIconDiv.style.cursor = "default";
	  
//	  closeIcon.style.marginTop = "4px";
//	  closeIcon.style.marginLeft = "6px";
//	  closeIcon.style.cursor = "pointer";
	  
//	  closeIconDiv.appendChild(closeIcon);  
/* 	  if(elems[0].style.display == "none")  // i.e. no hidden tabs
	  {
		closeIconDiv.style.display = "inline";
		var closeIconShift=25;
		if(this.dimensionUnit == "em")
			closeIconShift = 2;
		closeIconDiv.style.left = this.hoverWidth - closeIconShift + this.dimensionUnit;
	  } */
//	  elems[2].appendChild(closeIconDiv);
	  elems[0].style.left = elems[1].style.left;
//	  this._onClickClose = dojo.connect(closeIcon,"onclick",this,this._onMouseExitDlg);
	  var noWrapTabStrip = dojo.query(".nowrapTabStrip");
	  this._iniTabStripOffset = (noWrapTabStrip[0].getClientRects())[0].left;
	  var func = dojo.hitch(this, this._updateHiddenTab, noWrapTabStrip);
	  dojo.connect((elems[0].children)[0], 'onclick', elems[0], func, true);
	  this._hoverUpdate(noWrapTabStrip, elems[0]);
	  var tempFunc = dojo.hitch(this, this._leftHoverUpdate, noWrapTabStrip, elems[3]);
	  dojo.connect(elems[3],"onmouseover", elems[3], tempFunc , true);
  },
  
  
  _updateHiddenTab: function(noWrapTabStrip)
  {
	if(noWrapTabStrip && noWrapTabStrip[0] && noWrapTabStrip[0].childNodes && noWrapTabStrip[0].childNodes[0]) {
		var diff = this._iniTabStripOffset - (noWrapTabStrip[0].getClientRects())[0].left;
		var hiddenTabsLeft = Math.ceil(diff/(noWrapTabStrip[0]).childNodes[0].offsetWidth);
		var hiddenTabsRight = ((noWrapTabStrip[0]).childNodes.length * noWrapTabStrip[0].childNodes[0].offsetWidth) - (diff + noWrapTabStrip[0].offsetParent.offsetWidth);
		hiddenTabsRight = Math.ceil(hiddenTabsRight/(noWrapTabStrip[0]).childNodes[0].offsetWidth);
		var parentNode  = this.domNode.parentNode;
		var tabPopup = parentNode.nextSibling;
		var tbody = tabPopup.children[0].tBodies[0];
		var tabsHidden = tbody.rows.length - hiddenTabsRight;
		for (var i=hiddenTabsLeft; i< tabsHidden; i++)
		{
			tbody.rows[i].style.display = "none";
		}
	}
  },
  
  _hoverUpdate: function(noWrapTabStrip, elem)
  {
	if(this._hiddenTabs > -1)
		return;
	if(noWrapTabStrip && noWrapTabStrip[0] && noWrapTabStrip[0].childNodes && noWrapTabStrip[0].childNodes[0]) {
		var diff = this._iniTabStripOffset - (noWrapTabStrip[0].getClientRects())[0].left;
		var hiddenTabsLeft = Math.ceil(diff/(noWrapTabStrip[0]).childNodes[0].offsetWidth);
		var hiddenTabsRight = ((noWrapTabStrip[0]).childNodes.length * noWrapTabStrip[0].childNodes[0].offsetWidth) - (diff + noWrapTabStrip[0].offsetParent.offsetWidth);
		hiddenTabsRight = Math.ceil(hiddenTabsRight/(noWrapTabStrip[0]).childNodes[0].offsetWidth);
		this._hiddenTabs = hiddenTabsLeft + hiddenTabsRight;
		elem.title = this._hiddenTabs + " Resources";
	}
  },
  
  _leftHoverUpdate: function(noWrapTabStrip, elem)
  {
    if(noWrapTabStrip && noWrapTabStrip[0] && noWrapTabStrip[0].childNodes && noWrapTabStrip[0].childNodes[0]) {
		var diff = this._iniTabStripOffset - (noWrapTabStrip[0].getClientRects())[0].left;
		var hiddenTabsOnLeft = Math.ceil(diff/(noWrapTabStrip[0]).childNodes[0].offsetWidth);
		this._hiddenTabsLeft = hiddenTabsOnLeft + " Resources";
		elem.title = hiddenTabsOnLeft + " Resources";
	}
  },
  
  
  showHover: function()
  {
	 var elems=[];
	  if (this._shownAlready)
	  {
		  //this.show();
		  this._internalShow(elems);
		  return;
	  }
	  if (this.urlInfo == null || this.urlInfo.isLoaded() == false || this.urlInfo.hasError() == true)
	  {
		/* The dataset is not ready, don't show until we are ready. */
		console.error("show was called on RichHoverTooltip, but urlInfo is not ready.");
		console.log(" urlinfo is "+(this.urlInfo==null?"null":"not null"));
		console.log(" urlinfo.isLoaded is "+(this.urlInfo.isLoaded()?"true":"false"));
		console.log(" urlinfo.hasError is "+(this.urlInfo.hasError()?"true":"false"));
		return;
	  }
	  
	if (this.urlInfo.getPreviews() == null || this.urlInfo.getPreviews().length == 0)
	{
	    console.log("No previews exist for this dialog.  Will not show dialog.");
	    return;
	}

	dojo.addClass(this.domNode, 'richHover');
    this.startup();
    this._calculateDimensions();
    
    var myStyle = "height: "+this.hoverHeight+this.dimensionUnit+"; width: "+this.hoverWidth+this.dimensionUnit+";";
	
	if( this.contentIsolation == true ){
			console.log("content Isolation is true");
			// Get the namespace identifying the content that launched the context menu
			console.info("Inside Show if PopupUtil Undefined");
			var namespace="";
			if(this.namespace != null)
			 namespace = this.namespace;
			
			//Close (just in case) and then open the popup covering the whole page
			console.info("Opening Popup namespace "+namespace);
			var dialogNamespace=namespace+'ibm.tivoli.tip.richhover.RichHoverTooltip';
			var old_popup_iframe = PopupUtil.ClosePopup( namespace+'ibm.tivoli.tip.richhover.RichHoverTooltip' );
			//Changes for fixing Content Isolation issue with Claro theme
			//var theme = dojo.body().className;
			//var theme=this.theme;
			var theme=dojo.body().className;
		if (theme.indexOf( "oneui" ) != -1){
			this.theme = "oneui"	;
		}else 
		if(theme.indexOf( "breeze" ) != -1 || theme.indexOf( "TIPDark" ) != -1) {
				this.theme = "breeze";
			}
			this.baseUrl=dojo.baseUrl;

			var index = this.baseUrl.lastIndexOf("/dojo");
			
			if (index != -1) {
				this.baseUrl=this.baseUrl.substring(0,index);
			}
			console.log("this.baseUrl : " + this.baseUrl);
			var popupUrl =this.baseUrl+'/ibm/tivoli/tip/richhover/RichHover.html?PopupID='+dialogNamespace+'&eLeft='
				+this.xcord+'&eTop='+this.ycord+'&locale='+dojo.locale+"&theme="+this.theme;
			console.info("url :"+popupUrl);
			var popup_iframe = PopupUtil.OpenPopup( 
				namespace, 
				namespace+'ibm.tivoli.tip.richhover.RichHoverTooltip', 
				true, 
				null, 
				null, 
				null, 
				null, 
				popupUrl, 
				null
			);
			console.debug("after popup opening code - popup_iframe", popup_iframe);
			//Initialize the contextMenu when the iframe popup is finished loading
			var tThis = this;
			if( popup_iframe.addEventListener ){
				popup_iframe.addEventListener(
					"load", 
					function(){
						popup_iframe.contentWindow.makeTooltip( tThis, myStyle );
					}, 
					false
				);
			}
			else if (popup_iframe.attachEvent){
				popup_iframe.attachEvent(
					"onload", 
					function(){ 
						popup_iframe.contentWindow.makeTooltip( tThis, myStyle);
					}
				);
			}
		}
	else {
		var tc = new ibm.tivoli.tip.richhover.RichHover({
			style: myStyle
		});
		this._ieTabFix(tc.domNode);
		this._tabSwitchListener = dojo.connect(tc,"selectChild",this,this._onTabSwitch);
		var previews = this.urlInfo.getPreviews();
		this.isLargeHoverPresent=[];
		for (var i=0; i<previews.length; i++)
		{
		  var preview = previews[i];
		  if(i==0)
		  {
			this._resourceUrl = preview.resourceUrl;
			this._largeHtmlUrl = preview.largePreview.url;
			this._largeHoverHeight = preview.largePreview.heighthint;
			this._largeHoverWidth = preview.largePreview.widthhint;
			this.hoverTitle = preview.shortTitle;
			this._largePreview=[];
		  }
		// We will need something to map small previews with their corresponding largePreview details. using resourceUrl
		var temp = {};
		temp.resourceUrl=preview.resourceUrl;
		temp.url=preview.largePreview.url;
		temp.heighthint=preview.largePreview.heighthint;
		temp.widthhint=preview.largePreview.widthhint;
		temp.shortTitle=preview.shortTitle;
		this._largePreview.push(temp);
		if(preview.largePreview.url != null && preview.largePreview.url != "undefined" && (this.isLargeHoverPresent.join(" ")).indexOf(preview.resourceUrl)==-1) {
			this.isLargeHoverPresent.push(preview.resourceUrl);
			console.debug("pushing : ", preview.resourceUrl);
		}
		
		  tc.addIframeUrl(preview.shortTitle, preview.smallPreview.url, preview.resourceUrl);  
		}
		elems = this._dojoHack(tc.domNode);
		//tc.startup();	
		//Richa,24Apr13, #70697: Theming work for Rich Hover widget
		//Adding the closeIconDiv to the header	
		var mdiv = dojo.create("div");
		var headerDiv = dojo.create("div", {title: "header", id:"header_div", style:"width:100%;" , role:"button"});
		
		var closeIconDiv = dojo.create("div", {id:"closeIconDiv", title:this.resources_.CLOSE});
		var closeIcon = dojo.create("span", {id:"closeImg", alt: this.resources_.CLOSE,  role:"presentation"});
	    closeIconDiv.appendChild(closeIcon);  
	    headerDiv.appendChild(closeIconDiv);
	    // 75789: Richhover - hatched pattern missing and close icon is not clickable
	    this._onClickClose = dojo.connect(closeIconDiv,"onclick",this,this._onMouseExitDlg);
		mdiv.appendChild(headerDiv);
		mdiv.appendChild(tc.domNode);
		this._addButtons(mdiv);
		this.set("content",mdiv);
		this._shownAlready = true;
		//this.show();
		this._internalShow(elems);
		var par = mdiv.offsetParent;
		this.largeLeft = par.offsetLeft;
		this.largeTop = par.offsetTop;
		this._anchorList=dojo.connect(dojo.byId("chevTd"), 'onclick', this, dojo.hitch(this, this.onClickChevron), true);
		//dojo.connect(dojo.byId("closeLink"), 'onclick', this, dojo.hitch(this, this.onClickClose), true);
		//dojo.connect(dojo.byId("moreInfo"), 'onclick', this, dojo.hitch(this, this.onClickMore), true);
	}
  },
  
  resize: function()
  {
	console.log("resize");
  },
  
  setHoverUrlInfo: function(urlInfo)
  {
	  this.urlInfo = urlInfo;
  },
  
  getHoverUrlInfo: function(urlInfo)
  {
	  return this.urlInfo;
  }

});

});
