/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
/*global define */
define("ibm/usmi/scheduler/wizard_pages/nls/zh-tw/JobLaunchWizardResources", {
	/**
	 * This file contains resources for each page of the job launch wizard.
	 * Please keep overall Job Launch Wizard resources in the first section of
	 * the file. The second section contains resources for the Schedule page.
	 * The third section contains resources for the Notifications page. The
	 * fourth section contains resources for the Options page.
	 */

	/**
	 * Section 1: Overall Job Launch Wizard resources.
	 */
	// Messages:
	JOB_SUCCESSFULLY_RUN_NOW : "已順利建立並啟動下列工作：",
	JOB_SUCCESSFULLY_SCHEDULED : "已順利建立並排定下列工作：",
	JOB_CREATION_FAILED : "新工作建立失敗。",
	JOB_FAILED_RESPONSE : "如果問題持續發生，請聯絡「支援中心」。",
	// The following error message should never be displayed to the user.  There 
	// are no scenarios where this message should ever needed
	// However, if a bug exists in the code, this message can be used so that
	// the UI does not crash (and give no reason to the user why the UI did not function
	// as expected).  Currently logging is not defined...When logging is defined and working, 
	// the code is obligated to log additional information (when available) before issuing
	// this message.
	GENERIC_ERROR_MESSAGE : "嘗試啟動作業時發生問題。",
	GENERIC_ERROR_RESPONSE : "如果問題持續發生，請聯絡下一層支援人員或客戶服務代表。",
	
	// Field labels:
	SUBMIT_BUTTON_LABEL : "提交",
			
	// Completion Message link text
	VIEW_JOB_LINK_TEXT : "檢視工作",

	/**
	 * Section 2: Resources for the Schedule Page of the Job Launch Wizard.
	 */
	// Page title:
	SCHEDULE_PAGE_TITLE : "排程",

	// Messages:
	NO_VALID_JOB_NAME_ERROR : "針對工作名稱輸入的值無效。",
	MISSING_CUSTOM_DATES : "未選取任何自訂日期。",
	SELECTED_DATE_IN_PAST : "目前選取的日期和時間為過去的日期和時間或現在的日期和時間。",
	REPEAT_FOR_DURATION_NOT_VALID : "選擇介於 1 與 5000 之間的「重複」持續期間值。",
	REPEAT_UNTIL_DURATION_NOT_VALID : "「重複截止於」期間值是在排定日期之前。",
	MISSING_SELECTED_DAY_OF_WEEK : "未選取星期。",
	MISSING_MONTHLY_DATES : "未選取每月日期。",
	CUSTOM_DATE_ALREADY_SELECTED : "選取的自訂日期已在清單中。請選取不同的日期。",
	CUSTOM_DATE_IN_PAST : "選取的自訂日期為過去的日期或現在的日期。請選取不同的日期。",
	MONTHLY_DATE_ALREADY_SELECTED : "選取的每月日期已在清單中。請選取不同的日期。",

	// Field labels:
	WHEN_TO_RUN_LABEL : "執行時間：",
	JOB_NAME_LABEL : "工作名稱：",
	SCHEDULE_DATE_LABEL : "日期：",
	SCHEDULE_TIME_LABEL : "時間：",
	REPEATE_OPTIONS_LABEL : "重複選項：",
	FREQUENCY_LABEL : "頻率：",
	WEEKEND_LABEL : "在週末：",
	WEEKLY_VALUES_LABEL : "在每週的下列日期執行：",
	MONTHLY_SELECT_LABEL : "在每月的下列日期執行：",
	CUSTOM_DATES_ADD_VALUES_PROMPT : "按一下「新增」，以將上面的日期新增至下面的排定日期清單。",
	DURATION_LABEL : "持續時間：",
	REPEAT_OPTIONS_LABEL : "重複選項：",
	REPEAT_FOR_VALUE_LABEL : "重複：",
	REPEAT_UNTIL_VALUE_LABEL : "重複截止於：",
	REPEAT_FOREVER_PROMPT : "無限制",
	REPEAT_FOR_PROMPT : "適用於",
	REPEAT_UNTIL_PROMPT : "截止",
	ADD_BUTTON_LABEL : "新增",
	REMOVE_BUTTON_LABEL : "移除",

	// Field values:
	RUN_NOW_VALUE : "立即執行",
	RUN_LATER_VALUE : "排程",
	REPEAT_FOREVER_VALUE : "永久重複",
	REPEAT_SELECTION_ONCE_VALUE : "一次",
	REPEAT_SELECTION_HOURLY_VALUE : "每小時",
	REPEAT_SELECTION_DAILY_VALUE : "每日",
	REPEAT_SELECTION_WEEKLY_VALUE : "每週",
	REPEAT_SELECTION_MONTHLY_VALUE : "每月",
	REPEAT_SELECTION_YEARLY_VALUE : "每年",
	REPEAT_SELECTION_CUSTOM_VALUE : "自訂",
	WEEKEND_DONT_MOVE_VALUE : "不移動",
	WEEKEND_MOVE_TO_FRIDAY_VALUE : "移至星期五",
	WEEKEND_MOVE_TO_MONDAY_VALUE : "移至星期一",
	WEEKEND_MOVE_TO_WEEKDAY_VALUE : "移至最接近的工作日",
	WEEKEND_DELETE_VALUE : "刪除",
	WEEKLY_SUNDAY_VALUE : "星期日",
	WEEKLY_MONDAY_VALUE : "星期一",
	WEEKLY_TUESDAY_VALUE : "星期二",
	WEEKLY_WEDNESDAY_VALUE : "星期三",
	WEEKLY_THURSDAY_VALUE : "星期四",
	WEEKLY_FRIDAY_VALUE : "星期五",
	WEEKLY_SATURDAY_VALUE : "星期六",

	MONTHLY_DATE_1ST_VALUE : "第 1",
	MONTHLY_DATE_2ND_VALUE : "第 2",
	MONTHLY_DATE_3RD_VALUE : "第 3",
	MONTHLY_DATE_4TH_VALUE : "第 4",
	MONTHLY_DATE_5TH_VALUE : "第 5",
	MONTHLY_DATE_6TH_VALUE : "第 6",
	MONTHLY_DATE_7TH_VALUE : "第 7",
	MONTHLY_DATE_8TH_VALUE : "第 8",
	MONTHLY_DATE_9TH_VALUE : "第 9",
	MONTHLY_DATE_10TH_VALUE : "第 10",
	MONTHLY_DATE_11TH_VALUE : "第 11",
	MONTHLY_DATE_12TH_VALUE : "第 12",
	MONTHLY_DATE_13TH_VALUE : "第 13",
	MONTHLY_DATE_14TH_VALUE : "第 14",
	MONTHLY_DATE_15TH_VALUE : "第 15",
	MONTHLY_DATE_16TH_VALUE : "第 16",
	MONTHLY_DATE_17TH_VALUE : "第 17",
	MONTHLY_DATE_18TH_VALUE : "第 18",
	MONTHLY_DATE_19TH_VALUE : "第 19",
	MONTHLY_DATE_20TH_VALUE : "第 20",
	MONTHLY_DATE_21ST_VALUE : "第 21",
	MONTHLY_DATE_22ND_VALUE : "第 22",
	MONTHLY_DATE_23RD_VALUE : "第 23",
	MONTHLY_DATE_24TH_VALUE : "第 24",
	MONTHLY_DATE_25TH_VALUE : "第 25",
	MONTHLY_DATE_26TH_VALUE : "第 26",
	MONTHLY_DATE_27TH_VALUE : "第 27",
	MONTHLY_DATE_28TH_VALUE : "第 28",
	MONTHLY_DATE_29TH_VALUE : "第 29",
	MONTHLY_DATE_30TH_VALUE : "第 30",
	MONTHLY_DATE_31ST_VALUE : "第 31",

	REPEAT_FOR_HOURS_VALUE : "小時",
	REPEAT_FOR_DAYS_VALUE : "日",
	REPEAT_FOR_WEEKS_VALUE : "週",
	REPEAT_FOR_MONTHS_VALUE : "月",
	REPEAT_FOR_YEARS_VALUE : "年",

	/**
	 * Section 3: Resources for the Notifications Page of the Job Launch Wizard.
	 */
	// Page title:
	NOTIFICATIONS_PAGE_TITLE : "通知",

	// Messages:
	PERCENT_FAILED_VALUE_NOT_SET_ERROR : "選擇介於 1 與 100 之間的目標失敗百分比。",
	NUMBER_FAILED_VALUE_NOT_SET_ERROR : "選擇大於 0 的失敗目標數目。",
	MISSING_EMAIL_INFORMATION : "確定已對所有電子郵件欄位輸入資訊。",
	EMAIL_ADDRESS_WRONG_FORMAT : "電子郵件位址的格式錯誤",

	// Field labels:
	RECEIVE_NOTIFICATIONS_LABEL : "接收通知：",
	JOB_FAILS_ANY_ERROR_RADIO_LABEL : "任何錯誤",
	JOB_FAILS_PERCENT_ERROR_RADIO_LABEL : "含有錯誤的目標百分比：",
	JOB_FAILS_NUMBER_ERROR_RADIO_LABEL : "含有錯誤的目標數目：",
	EMAIL_INFORMATION_LABEL : "電子郵件資訊：",
	EMAIL_ADDRESS_LABEL : "電子郵件位址：",
	EMAIL_SERVER_LABEL : "電子郵件伺服器名稱：",
	EMAIL_PORT_LABEL : "電子郵件伺服器埠號：",

	// Field values:
	JOB_BEGINS_VALUE : "在此工作開始時通知。",
	JOB_COMPLETES_OK_VALUE : "在此工作順利完成時通知。",
	JOB_FAILS_VALUE : "在此工作失敗時通知。",

	/**
	 * Section 4: Resources for the Notifications Page of the Job Launch Wizard.
	 */
	// Page title:
	OPTIONS_PAGE_TITLE : "選項",

	// Messages:
	MAXIMUM_JOB_INSTANCES_VALUE_ERROR : "選擇介於 10 與 100 之間的工作實例數目上限。",

	// Field labels:
	SYSTEM_TIMES_LABEL : "系統時間：",
	UNAVAILABLE_SYSTEMS_LABEL : "無法使用系統：",
	MAXIMUM_JOBS_LABEL : "工作實例數目上限：",
	MANAGEMENT_SERVER_TIME_RADIO : "使用管理伺服器時間",
	LOCAL_SYSTEM_TIME_RADIO : "使用本端系統時間",
	FAIL_IF_UNAVAILABLE_RADIO : "在系統無法使用時失敗",
	RUN_WHEN_AVAILABLE_RADIO : "在系統變成可用時執行"
});

