require({cache:{
'url:ibm/usmi/tasks/templates/DefaultConfirmationDialog.html':"<div id=\"defaultConfirmationDialogContent\" data-dojo-attach-point=�containerNode� style=\"padding:10px\">\r\n<!--\r\n\r\nLicensed Materials - Property of IBM\r\n\r\n(C) Copyright IBM Corp. 2013 All Rights Reserved\r\n\r\nUS Government Users Restricted Rights - Use, duplicate or\r\ndisclosure restricted by GSA ADP Schedule Contract with\r\nIBM Corp.\r\n\r\n-->\r\n\t<div data-dojo-attach-point=\"confirmationText\"></div>\r\n\t<div data-dojo-attach-point=\"confirmationButtonsDiv\" style=\"padding:5px 5px 5px 10px\">\r\n\t\t<div data-dojo-attach-point=\"OKButton\" role=\"button\"></div>\r\n\r\n\t\t<div data-dojo-attach-point=\"CancelButton\" role=\"button\"></div>\r\n\t</div>\r\n</div>"}});
/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012, 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/tasks/DefaultConfirmationDialogTask", [
	"dijit/_WidgetBase",
	"dijit/_Templated",
	"dijit/Dialog",
	"dijit/form/Button",
	"dojox/data/dom",
	"ibm/tivoli/navmodel/Trace",
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/on",
	"dojo/topic",
	"dojo/dom-construct",
	"dojo/_base/window",
	"dijit/registry",
	"dojo/i18n!ibm/usmi/nls/frameworkResources",
	"ibm/usmi/util/DefaultMessageHandler",
	"ibm/usmi/core/utils/Logger",
	"ibm/tivoli/navmodel/Selection",
	"dojo/i18n!ibm/usmi/nls/defaultTaskResources",
	"dojo/text!./templates/DefaultConfirmationDialog.html",
	"dojo/string"
],

function (_WidgetBase, _TemplatedMixin, _Dialog, Button, dom, theTrace,
		declare, lang, on, topic, construct, win, registry, FrameworkMRI, DefaultMessageHandler,
		Logger, Selection, DefaultMRI, template, string) {

	//Create our widget!
	return declare([
		_WidgetBase,
		_TemplatedMixin
	], {

		templateString: template,

		// private members
	//	_args: null,
		_task: null,
		_selectionName: null,
		FrameworkResources: FrameworkMRI,
		DefaultResources: DefaultMRI,
		taskID: null,
		dataset: null,
		launchParms: null,
		menuItem: null,
		context: null,

		// Logger
		DefaultConfirmationLogger: new Logger("ibm.usmi.tasks.DefaultConfirmationDialogTask","DefaultConfirmationDialogTask"),
/*
		constructor: function (kwArgs) {

			this._args = {
				launchParms: "",
				menuItem: "",
				context: ""
			};

			lang.mixin(this._args, kwArgs);


			// Run any parent postCreate processes - can be done at any point
			this.inherited(arguments);
			if (this.DefaultConfirmationLogger.isFine()) {
				this.DefaultConfirmationLogger.fine("DefaultConfirmationDialogTask: Constructor");
			}
		},
*/
		postMixInProperties: function () {
			// summary:
			//      occurs before build rendering
			// description:
			//      need to define the confirmation text and set title for the template

			//set taskID
			this.taskID = this.menuItem.actionID;

			//set dataSet
			this.dataset = this.context.dataset;

			// Run any parent postMixInProperties processes - can be done at any point
			this.inherited(arguments);
		},

		postCreate: function () {

			var selections=this.context.selection.getItems();
			this._selectionName=selections[0].getLabel();
			
			var getTasksError = function (error, request) {
				this._navWidget.hideBusyPane();

				//Give the user some feedback
				this.displayException(error);
			};

			this.dataset.getTasks({
				onComplete: lang.hitch(this, this._findTaskForId),
				onError: lang.hitch(this, getTasksError),
				taskCategory: "menu", //TODO: Could I specifically request nav hints instead of all tasks?
				selection: this.getSelection()
			});

			// Run any parent postCreate processes - can be done at any point
			this.inherited(arguments);
			

			if (!(this.launchParms.confirmationText)) {
				this.launchParms.confirmationText = string.substitute(this.DefaultResources.CONFIRMMSG, [1, this._selectionName ]);
			}

			//Set the confirmation text into the dom tree and the buttons
			this.confirmationText.innerHTML = this.launchParms.confirmationText;

			var saveButton = new Button({
				id: this.id + "_DialogOKButton",
				label: this.FrameworkResources.OK
			}, this.OKButton); 

			var cancelButton = new Button({
				id: this.id + "_DialogCancelButton",
				label: this.FrameworkResources.CANCEL
			}, this.CancelButton); 

			on(saveButton, "click", lang.hitch(this, "onOK"));
			on(cancelButton, "click", lang.hitch(this, "onCancel"));

		},
/*
		// get task from id
		_getTasksComplete: function (tasks) {

			//Want to loop through tasks looking for
			if (tasks) {
				for ( var i = 0; i < tasks.length; i++) {
					var task = tasks[i];
					// found are task.
					if (task.getId() === this.getTaskId()) {

						this.setTask(task);

						break;
					} else if (task.getChildTasks()) {
						var subTasks = task.getChildTasks();
						if (subTasks.length > 0) {
							this._getTasksComplete(subTasks);
							if (this.getTask()) {
								break;
							}
						}
					}
				}
			}
		},
	*/
		_findTaskForId: function (tasks) {
			// summary:
			//      Get the complete list of menu tasks, and find the one that matches the menu item that launched me, so I can use it when the user clicks OK.
			// description:
			//      This routine is recursive to handle the submenus

			var i = 0, task = null, subTasks = null;

			//Want to loop through tasks looking for
			if (tasks) {
				for (i = 0; i < tasks.length; i++) {
					task = tasks[i];
					// found our task.
					if (task.getId() === this.taskID) {

						this._task = task;

						break;
					} else if (task.getChildTasks()) {
						// calls this method recursively if a submenu is found
						subTasks = task.getChildTasks();
						if (subTasks.length > 0) {
							this._findTaskForId(subTasks);
							if (this._task) {
								// stops iterating through submenu items when found
								break;
							}
						}
					}
				}
			}
		},


		//override the onCancel method to also destroy the whole widget.
		onCancel: function () {

			//This widget should allow the default dialog to destroy its content in
			//order to ensure that the outer dialog is dismissed
			topic.publish("DefaultDialogDismissal", []);
			this.inherited(arguments);
		},

		//override the onCancel method to also destroy the whole widget.
		onOK: function () {

			this._task.execute({
				onError: lang.hitch(this, this._handleExecuteOnServerError),
				onComplete: lang.hitch(this, this._getExecuteComplete),
				selection: this.getSelection()
			});

			var delayedDestroy = lang.hitch(this, function() {
				// Sometime, this widget has already gone.
				if (registry.byId(this.id)) {
					registry.byId(this.id).destroyRecursive();
				}
			});

			setTimeout(delayedDestroy, 200);


			// the above line was not deleting the button id and so additional step
			var buttonId = this.id + "_DialogOKButton";
			if (buttonId) {
				registry.byId(this.id + "_DialogOKButton").destroyRecursive();
			}

			topic.publish("DefaultDialogDismissal", []);
			this.inherited(arguments);
		},

		_getExecuteComplete: function (result, arg) {
			/*
			 * SEE note below.  This code is for future function to display a message on job completion
			 * This code should be retained for when the server/message infrastructure is updated.
			var r = result;
			var a = arg;
			var moduleName = "_getExecuteComplete";
			// TODO:  Consider how to add a link to the job details in the message -- based on the job ID....r.JobId
			var theMessageTitle = "";
			var msgDesc = "";

			// Display the message...
			var msgHandler = new DefaultMessageHandler();
			var msgId = ""; // not specifying a message ID
			var msgSeverity = DefaultMessageHandler.SUCCESS;
			// Server side has not been implemented yet
			//msgHandler.displayMessage(msgId, msgSeverity, theMessageTitle, msgDesc, true);
			*/
		},


		getSelection: function () {
			var selectedThings = this.context.selection,
			currentSelection = null;
			
			if (selectedThings) {
				currentSelection = new Selection({
					version: this.dataset.getVersion()
				});
				currentSelection.addItems(selectedThings.getItemIds());
				currentSelection.addLinks(selectedThings.getLinkIds());
				currentSelection.addRelationships(selectedThings.getRelationshipIds());
			}
			return currentSelection;
		},

		getBodyHeight: function () {
			return (0.1 * ((window.innerHeight !== undefined) ? window.innerHeight : document.body.offsetHeight));
		},

		_handleExecuteOnServerError: function (error, exception, ioArgs) {
			var err = error,
			exc = exception,
			moduleName = "_handleExecuteOnServerError",
			msgId = "", 
			theMessageDesription = exc.getMsgText();
		
			if (this.DefaultConfirmationLogger.error()) {
				this.DefaultConfirmationLogger.error("DefaultConfirmationDialogTask:  Failed to rename system: "+ this._selectionName, moduleName);
				this.DefaultConfirmationLogger.error("DefaultConfirmationDialogTask:  The error received is:  " + err, moduleName);
				this.DefaultConfirmationLogger.error("DefaultConfirmationDialogTask:  The exception is:  " + exc, moduleName);
			}

			// Display the message...
			var msgHandler = new DefaultMessageHandler();
			var msgSeverity = DefaultMessageHandler.ERROR;
			msgHandler.displayMessage(msgId, msgSeverity, theMessageDesription, theMessageDescription, true);
		}
	}); // and that's it!
});
