// wrapped by build app
define("ibm/usmi/util/DefaultNoninteractiveTask", ["dijit","dojo","dojox","dojo/require!ibm/tivoli/navmodel/Trace,dojox/data/dom,ibm/usmi/util/DefaultMessageHandler"], function(dijit,dojo,dojox){
/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */

dojo.provide("ibm.usmi.util.DefaultNoninteractiveTask");

dojo.require("ibm.tivoli.navmodel.Trace");
dojo.require("dojox.data.dom");
dojo.require("ibm.usmi.util.DefaultMessageHandler");

util.DefaultNoninteractiveTask._trace = new ibm.tivoli.navmodel.Trace("ibm.usmi.util.DefaultNoninteractiveTask");

dojo.declare("ibm.usmi.util.DefaultNoninteractiveTask", null, {

    // private members
    _launchParms: null,
    _menuItem: null,
    _context: null,
    _trace : ibm.usmi.util.DefaultNoninteractiveTask._trace,

    constructor : function() {
        // summary:
        //		Coming soon
        // description:
        //		Coming soon

        // Register for a URL launch task event
        dojo.subscribe("DefaultNoninteractiveTask", this, "_handleUserInterfaceTask");

    },


    _handleUserInterfaceTask : function(launchParms, menuItem, context) {
        // summary:
        //		Coming soon
        // description:
        //		Coming soon
        
        this._launchParms = launchParms;
        this._menuItem = menuItem;
        this._context = context;

        alert("***** The task ID '" + menuItem.actionID + "' is a DefaultNoninteractiveTask.  The handler for DefaultNoninteractiveTask tasks is not yet defined. *****");


/*        var runServerTask = function(tasks){
            var task = null;
        
            task = this.fetchTask(tasks);
            
            // Call execute on the server task
            task.execute({onError: dojo.hitch(this, this._handleExecuteOnServerError),
                          selection: this.getSelection(context)});
        };
        

        // Process the user interface task
        // Check launchParms to decide how to handle
        if (launchParms) {
            if (launchParms.launchType === "NoninteractiveTask") {
                // Get the task and execute it
                context.dataset.getTasks({
                onComplete: dojo.hitch(this, runServerTask),
                onError: dojo.hitch(this, this.getTasksError),
                taskCategory: "menu",
                selection: this.getSelection(context)});
            }
            else {
                alert("launchParms are not valid");
                // TODO log error and put up message?
            }
        }
        else {
            alert("undefined launch parms from server task");
            // TODO log error and put up message?
        } */
    },


    fetchTask: function(tasks) {
    
        //Want to loop through tasks looking for match to menuItem actionID
        if (tasks) {
            for (var i = 0; i < tasks.length; i++) {
                if (tasks[i].getId() === this._menuItem.actionID) {
                    return tasks[i];
                }
                else if (tasks[i].getChildTasks()) {
                    var subTasks = tasks[i].getChildTasks();
                    if (subTasks.length > 0) {
                        var task = this.fetchTask(subTasks);
                        if (task && (task.getId() === this._menuItem.actionID)) {
                            return task;
                        }
                    }
                }
            }
        }
    },


    getSelection: function(context) {
	    var selectedThings = context.selection; //this._args.context.selection;
	    var currentSelection = null;
	    if (selectedThings) {
                currentSelection = new ibm.tivoli.navmodel.Selection({version: context.dataset.getVersion()}); //this.getDataSet().getVersion()});
	        currentSelection.addItems(selectedThings.getItemIds());
	        currentSelection.addLinks(selectedThings.getLinkIds());
	        currentSelection.addRelationships(selectedThings.getRelationshipIds());
	    }
	    return currentSelection;
    },


    getTasksError: function(error, request){
        //There was a problem getting the tasks from the dataset
        var msgHandler = new ibm.usmi.util.DefaultMessageHandler({});
        msgHandler.displayException(error);
    },
	
	
    _handleExecuteOnServerError: function(error, exception, ioArgs) {
        // summary:
        //		Coming soon
        // description:
        //		Coming soon
        // error:
        //		
        // exception:
        //		
        // ioArgs:
        //		

        if (this._trace.isError()) {
            this._trace.error(">>> error executing server task = " + error, "_handleExecuteOnServerError");
        }
		
        //There was a problem executing the task on the server
        var msgHandler = new ibm.usmi.util.DefaultMessageHandler({});
        msgHandler.displayException(exception);
    },
});

});
