require({cache:{
'url:ibm/usmi/widgets/button/templates/SingleSelectButton.html':"<div class=\"${baseClass} barNode\">\r\n<!--\r\n\r\nLicensed Materials - Property of IBM\r\n\r\n(C) Copyright IBM Corp. 2013 All Rights Reserved\r\n\r\nUS Government Users Restricted Rights - Use, duplicate or\r\ndisclosure restricted by GSA ADP Schedule Contract with\r\nIBM Corp.\r\n\r\n-->\r\n\t<div class=\"buttonsNode\" data-dojo-attach-point=\"buttonsNode\" style=\"display:inline\"></div>\r\n</div>\r\n"}});
/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/widgets/button/SingleSelectButton", [
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/dom-class",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dijit/_CssStateMixin",
    "dojo/text!./templates/SingleSelectButton.html",
    "dijit/form/Button",
    "ibm/usmi/core/utils/Logger"
], function(array, declare, domClass, _WidgetBase, _TemplatedMixin, _CssStateMixin, template, Button, Logger) {

    return declare("ibm.usmi.widgets.button.SingleSelectButton", [
        _WidgetBase,
        _TemplatedMixin,
        _CssStateMixin
    ], {
        // summary:
        //      Single Select Button widget 
        // description:
        //      it's a buttons bar, and only one button would be showed as "selected" if you click that button. Other buttons are
        //      in de-Selected state.
        // Example:
        //       <span data-dojo-type="ibm/usmi/widgets/button/SingleSelectButton"
        //          data-dojo-props="
        //          defaultValue:'Active',
        //          labels:[this.nls.activeAlertsToggleButton, this.nls.ignoredAlertsToggleButton], 
        //          values:['Active', 'Ignore']"
        //          data-dojo-attach-point="viewSwitchButton"> 
        //       </span>

        // Template info
        templateString: template,

        baseClass: "SingleSelectButton",

        // label of the selected button
        selected: null,
        // index of the selected button
        selIndex: 0,

        labels: null,

        values: null,
        // hover text value,
        titles: null,

        _logger: new Logger("ibm.usmi.widgets.button", "SingleSelectButton"),

        postCreate: function() {
            this.inherited(arguments);
            if (this.defaultValue) {
                this.set("Selected", this.defaultValue);
            }
        },

        constructor: function() {
            this._buttonNodes = [];
            this.labels = [];
            this.values = [];
        },

        postMixInProperties: function() {
            this.inherited(arguments);

            if (this.labels === null || this.labels.length === 0) {
                this.labels = this.values;
            }
        },

        buildRendering: function() {
            var i, onclickFunc, keypressFunc;
            this.inherited(arguments);
            onclickFunc = function() {
                return this.buttonbar._onClick(this.label);
            };
            keypressFunc = function(event) {
                return this.buttonbar._onKeyPress(event);
            };

            for (i = 0; i < this.labels.length; i++) {
                var button = new Button({
                    buttonbar: this,
                    label: this.labels[i],
                    value: this.values[i],
                    title: this.titles === null ? "" : this.titles[i],
                    onClick: onclickFunc,
                    onKeyPress: keypressFunc,
                    tabindex: i === 0 ? 0 : -1,
                    "class": i === 0 ? "leftbutton" : i === this.labels.length - 1 ? "rightbutton" : "middlebutton"
                }).placeAt(this.buttonsNode);

                this._buttonNodes.push(button);
            }
        },

        destroy: function() {
            this.inherited(arguments);
            if (this._buttonNodes) {
                this._buttonNodes.forEach(function(button) {
                    button.destroy();
                });
                this._buttonNodes = null;
            }
        },

        _onClick: function(label) {
            // summary:
            //     button click callback
            // label:
            //     the target button was clicked
            this._setActive(array.indexOf(this.labels, label));
        },

        _setActive: function(index) {
            // summary:
            //     set the active button from the index
            // index:
            //     the index of the buttons array
            var value;
            this._styleButtons(index);

            if (this.selIndex === index) {
                // Already selected, don't call onClick (which should actually be called onChange).
                return false;
            }

            this.selIndex = index;
            value = this.get("selected");
            return this.onClick(value);
        },

        _styleButtons: function(selectedButton) {
            // summary:
            //     change the style for the buttons
            // selectedButton:
            //     the index of the selected button
            array.forEach(this._buttonNodes, function(item, i) {
                if (i === selectedButton) {
                    // selected
                    domClass.add(item.domNode, "buttonBarButtonActive");
                } else {
                    // unselected
                    domClass.remove(item.domNode, "buttonBarButtonActive");
                }
            }, this);
        },

        onClick: function(value) {
            // summary:
            //     button click callback
            return false;
        },

        _onKeyPress: function(event) {
            // summary:
            //     key press event callback
            var code = event.keyCode;
            if (code === 37 || code === 38 || code === 39 || code === 40) {
                // left arrow, up arrow, right arrow, down arrow
                var index = this._getNextIndex(code);
                this._setActive(index);
                this.onKeyPress(event);
                event.preventDefault();
            }

            this.onKeyPress(event);
        },

        onKeyPress: function(event) {
        // summary:
        //     key press event callback
        // do nothing, override if necessary
        },

        _getNextIndex: function(code) {
            // summary:
            //     determines the next index in navigation
            var index = this.selIndex;
            if (code === 37 || code === 38) {
                // left arrow, up arrow
                // navigate focus backward
                index--;
                if (index < 0) {
                    index = this._labelsArr.length - 1;
                }
            } else if (code === 39 || code === 40) {
                // right arrow, down arrow, tab
                // navigate focus forward
                index++;
                if (index >= this._labelsArr.length) {
                    index = 0;
                }
            }
            return index;
        },

        _getSelectedAttr: function() {
            // summary:
            //     return the selected button value
            return this.values[this.selIndex];
        },

        //Called by widget.set("selected", ____); 
        _setSelectedAttr: function(selected) {
            // summary:
            //    set the selected button from the value
            // selected:
            //    the value of the selected button
            var index;

            if (selected !== null) {
                index = array.indexOf(this.values, selected);

                if (index === -1) {
                    this._logger.error("SingleSelectButton.set(\"selected\"): bad value");
                    return;
                }
            } else {
                //user has chosen default value to be selected
                //button1 initially selected
                index = 0;
            }

            this._setActive(index);
        },

        _setSelIndexAttr: function(index) {
            // summary:
            //    set the selected button from the index
            // index:
            //    the index of the selected button
            if (index < this.labels.length) {
                this._setActive(index);
            }
        }

    });
});