(function(){

var factory = function(dojo_declare, dojo_lang, dojo_array, dojo_window, dojo_html, dojo_event, dojo_connect, dojo_keys, dijit_registry, dijit_Templated, dijit_layout_LayoutWidget, dijit_layout_ContentPane, idx_html, idx_util, idx_layout_BorderContainer, idx_layout_MoveableTabContainer, idx_layout_TitlePane, idx_layout_Dockable, idx_layout_DockAreaMixin){

/**
 * @name idx.layout.DockContentPane
 * @class Simple dock area based on ContentPane
 * @augments dijit.layout.ContentPane
 * @augments idx.layout._DockAreaMixin
 */
var DockContentPane = dojo_declare("idx.layout.DockContentPane", [dijit_layout_ContentPane, idx_layout_DockAreaMixin],
/**@lends idx.layout.DockContentPane#*/
{
	/**
	 * Resizes children.
	 */
	resize: function() {
		this.inherited(arguments);
		var children = this.getChildren();
		var w = dojo_html.contentBox(this.domNode).w;
		dojo_array.forEach(children, function(child) {
			if (child.resize) {
				child.resize({w: w});
			} else {
				dojo_html.marginBox(child.domNode, {w: w});
			}
		});
	},
	
	dock: function(dockable, pos) {
		this.inherited(arguments);
		this.resize();
	}
});


return DockContentPane;

}; // end of factory

var version = (window["dojo"] && dojo.version);
if(version && version.major == 1 && version.minor == 6){
	dojo.provide("idx.layout.DockContentPane");
	dojo.require("dijit._Templated");
	dojo.require("dijit.layout._LayoutWidget");
	dojo.require("dijit.layout.ContentPane");
	dojo.require("idx.html");
	dojo.require("idx.util");
	dojo.require("idx.layout.BorderContainer");
	dojo.require("idx.layout.MoveableTabContainer");
	dojo.require("idx.layout.TitlePane");
	dojo.require("idx.layout._Dockable");
	dojo.require("idx.layout._DockAreaMixin");
	var dojo_event = {stop: dojo.stopEvent};
	factory(dojo.declare, dojo, dojo, dojo, dojo, dojo_event, dojo, dojo.keys, dijit, dijit._Templated, dijit.layout._LayoutWidget, dijit.layout.ContentPane, idx, idx.util, idx.layout.BorderContainer, idx.layout.MoveableTabContainer, idx.layout.TitlePane,idx.layout._Dockable,idx.layout._DockAreaMixin);
}else{
	define("idx/layout/DockContentPane", [
		"dojo/_base/declare",
		"dojo/_base/lang",
		"dojo/_base/array",
		"dojo/_base/window",
		"dojo/_base/html",
		"dojo/_base/event",
		"dojo/_base/connect",
		"dojo/keys",
		"dijit/registry",
		"dijit/_Templated",
		"dijit/layout/_LayoutWidget",
		"dijit/layout/ContentPane",
		"idx/html",
		"idx/util",
		"idx/layout/BorderContainer",
		"idx/layout/MoveableTabContainer",
		"idx/layout/TitlePane",
		"idx/layout/_Dockable",
		"idx/layout/_DockAreaMixin"
	], factory);
}

})();
