/*
 * Licensed Materials - Property of IBM
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

(function(){
function factory(dLang,iMain,dKernel,dTooltip,dMasterTooltip,iUtil) {
	var iTooltips = dLang.getObject("tooltips", true, iMain);
    var masterProto = dMasterTooltip.prototype;
    
    if ((dKernel.version.major == 1) && (dKernel.version.minor < 7)) {
		console.log("****************");
    	console.log("****** Replacing dijit._MasterTooltip.show function for pre-1.7 Dojo");
		console.log("****************");
		
		var origShow = masterProto.show;
		
    	masterProto.show = function(innerHTML, aroundNode, pos, rtl) {
			if(this.aroundNode && this.aroundNode === aroundNode){
				return;
			}
    		origShow.call(this, innerHTML, aroundNode, pos, rtl);
    		
			if (iUtil.isFF || (iUtil.isIE < 8)) {
				var s = this.domNode.style;
				var l = dKernel._isBodyLtr();
				s[l ? "right" : "left"] = "auto";
			}
    	};
    	    	
    }
    
    dLang.extend(dTooltip, {
    	idxDefaultsClass: "idxTooltip_idxDefaults" 
    });
    
    return iTooltips;
}

var version = (window["dojo"] && dojo.version);
if(version && version.major == 1 && version.minor == 6){

	dojo.provide("idx.tooltips");
	dojo.require("idx.ext");
	dojo.require("dijit.Tooltip");
	dojo.require("idx.util");

	factory(dojo,idx,dojo,dijit.Tooltip,dijit._MasterTooltip,idx.util);
	
} else {
	define("idx/tooltips", ["dojo/_base/lang","idx/main","dojo/_base/kernel","dijit/Tooltip","./util"],
			function(dLang,iMain,dKernel,dTooltip,iUtil) {
				return factory(dLang,iMain,dKernel,dTooltip,dTooltip._MasterTooltip,iUtil);
			});
}

})();